<?php

class Backgrounds {
	var $capability = 'manage_backgroundproperties';
	var $save_post_done =false;
	var $show_ui = true;
	function Backgrounds($args=array()){
		$defaults = array(
			'capability'			=> 'manage_backgroundproperties',
			'show_ui'				=> true
		);
		foreach($defaults as $property => $default){
			$this->$property = isset($args[$property])?$args[$property]:$default;
		}	
		if(current_user_can('manage_options')||current_user_can($this->capability)){
		add_action('init',array(&$this,'init'),500);	
		add_action('admin_init',array(&$this,'admin_init'));
		
		add_action('admin_menu', array(&$this, 'post_meta_box') );
		add_action('save_post', array(&$this,'save_post') );	
		
		add_action('admin_head-post.php', array(&$this,'admin_head'));
		add_action('admin_head-post-new.php', array(&$this,'admin_head'));
		
		///AJAX Methods
		add_action('wp_ajax_bg_load_attachments', array(&$this,'bg_load_attachments'));
		add_action('wp_ajax_bg_delete_attachment', array(&$this,'bg_delete_attachment'));
		add_action('wp_ajax_bg_change_order', array(&$this,'bg_change_order'));
		add_action('wp_ajax_bg_no_image', array(&$this,'bg_no_image'));	
		add_action('wp_ajax_bg_save_attachment_field', array(&$this,'bg_save_attachment_field'));	
		//--post_edit_form_tag
		add_action('post_edit_form_tag',array(&$this,'post_edit_form_tag'));//allow file uploading. for non flash users.
		add_action('admin_head', array(&$this,'icon32_style'));	
		}
	}
	
	function icon32_style(){
?>
<style>
.icon32-posts-background{
	background: url("<?php echo CUSTBACK_URL.'images/cb32.png'?>") no-repeat scroll 0 1px transparent !important;
}
</style>
<?php	
	}
	
	function admin_init(){
		add_filter( 'manage_edit-background_columns', array(&$this,'admin_columns')  );
		add_action('manage_pages_custom_column', array(&$this,'custom_column'),10,2);		
	}
	
	function admin_columns($defaults){
		global $cbg_plugin;
		$taxonomies=isset($cbg_plugin->options['taxonomies'])?$cbg_plugin->options['taxonomies']:array();
		if(!empty($taxonomies)){
			$new = array();
			foreach($defaults as $key => $title){
				$new[$key]=$title;
				if($key=='title'){
					foreach($taxonomies as $taxonomy){
						if(taxonomy_exists($taxonomy)){
							$tax = get_taxonomy($taxonomy);

							$key='taxonomy_'.$taxonomy;
							$name = $tax->labels->name;
							$new[$key]=$name;						
						}
					}
				}
			}
			return $new;		
		}
		return $defaults;
	}
	
	function custom_column($field, $post_id=null){
		global $cbg_plugin;
		$taxonomies=isset($cbg_plugin->options['taxonomies'])?$cbg_plugin->options['taxonomies']:array();
		if(!empty($taxonomies)){
			foreach($taxonomies as $taxonomy){
				$key='taxonomy_'.$taxonomy;
				if($field==$key){
					$groups = get_the_terms($post_id, $taxonomy);
					$tmp = array();
					if(is_array($groups)&&count($groups)>0){
						foreach($groups as $group){
							$tmp[]=$group->name;
						}
					}
					echo implode(",",$tmp);
				}
			}
		}	
	}
		
	function post_edit_form_tag(){
		global $post;
		if('background'==@$post->post_type){
			echo " enctype=\"multipart/form-data\" ";
		}		
	}
	
	function check_ajax(){
		if(current_user_can('manage_options')||current_user_can($this->capability)){
			return true;
		}else{
			return false;
		}
	}
	
	function remove_actions(){
		remove_all_actions('save_post');
		remove_all_actions('new_to_publish');
	}	
	
	function bg_save_attachment_field(){
		if(!$this->check_ajax()){
			die(json_encode(array("R"=>"ERR",'MSG'=>'No access')));
		}
		$post_id = isset($_REQUEST['post_id'])?intval($_REQUEST['post_id']):0;
		$name = isset($_REQUEST['name'])?$_REQUEST['name']:0;
		$value= isset($_REQUEST['value'])?$_REQUEST['value']:0;
		
		$parts = explode("_",$name);
		$attachment_id = array_pop($parts);
		
		$meta_name = implode("_",$parts);
		//die(json_encode(array("R"=>"ERR",'MSG'=>"POSTID $post_id NAME $name $attachment_id")));
		//die(json_encode(array("R"=>"ERR",'MSG'=>"meta $meta_name")));
		$attachment_fields = $this->get_attachment_fields();
		if(in_array($meta_name,$attachment_fields)){
			update_post_meta($attachment_id,$meta_name,$value);
		}else{
			die(json_encode(array("R"=>"OK",'MSG'=>'Field name is not valid.')));
		}
		die(json_encode(array("R"=>"OK",'MSG'=>'')));
	}
	
	function bg_no_image(){
		if(!$this->check_ajax()){
			die(json_encode(array("R"=>"ERR",'MSG'=>'No access')));
		}
		$post_id = isset($_REQUEST['post_id'])?intval($_REQUEST['post_id']):0;
		if(!current_user_can('edit_post',$post_id)){
			die(json_encode(array("R"=>"ERR",'MSG'=>'No access')));
		}		
		
		$filename 	= CUSTBACK_PATH.'css/images/nobg.jpg';
		$url		= CUSTBACK_URL.'css/images/nobg.jpg';
		$wp_filetype = wp_check_filetype(basename($filename), null );
		$attachment = array(
		   'post_mime_type' => $wp_filetype['type'],
		   'post_title' => preg_replace('/\.[^.]+$/', '', basename($filename)),
		   'post_content' => $url,
		   'post_status' => 'inherit',
		   'post_type'	=>'cbg-attachment',
		   'post_parent'=> $post_id
		);
		
		$this->remove_actions();
		$attach_id = wp_insert_post( $attachment );

		if($attach_id>0){
			//update_post_meta($attach_id,'background_external_url',$url);
			//------------------
			$args = array(
				'post_parent' => $post_id,
				'orderby'	=> 'menu_order',
				'order'=>'ASC'
			);
			$attachments = get_cbg_attachments($args);			
			
			if ($attachments) {
				foreach ($attachments as $attachment) {
					if($attachment->ID==$attach_id)
						continue;
					$attachment->menu_order = $attachment->menu_order + 1;
					wp_update_post( $attachment );
				}
			}			
			//------------------	
			die(json_encode(array(
				"R" 		=> "OK",
				"MSG"		=> "",
				"ID"		=> $attach_id,
				"URL"		=> CUSTBACK_URL.'css/images/nobg.jpg'
			)));			
		}else{
			die(json_encode(array("R"=>"ERR",'MSG'=>'Error creating attachment.')));
		}
	}
	function bg_delete_attachment(){
		if(!$this->check_ajax()){
			die(json_encode(array("R"=>"ERR",'MSG'=>'No access')));
		}
		$attach_id = isset($_REQUEST['attach_id'])?intval($_REQUEST['attach_id']):0;
		global $wpdb;
		if(!in_array( $wpdb->get_var("SELECT post_type FROM $wpdb->posts WHERE ID=$attach_id",0,0) ,array('attachment','cbg-attachment'))){
			die(json_encode(array("R"=>"ERR",'MSG'=>'ID is not a custom background attachment.')));
		}		
		
		if($attach_id>0){
			wp_delete_post( $attach_id,true);
		}
		//-------------------------
		die(json_encode(array("R"=>"OK",'MSG'=>'')));
	}

	function bg_load_attachments(){
		if(!$this->check_ajax()){
			die('No access');	
		}	
		//-------------------------
		$post_id = isset($_REQUEST['post_id'])?intval($_REQUEST['post_id']):0;
		$used = isset($_REQUEST['used'])?intval($_REQUEST['used']):0;
		
		if($post_id<=0){
			die('Missing paramenter, post_id');
		}

		$args = array(
			'post_parent' => $post_id,
			'orderby'	=> 'menu_order',
			'order'=>'ASC'
		);
		$attachments = get_cbg_attachments($args);
		
		if ($attachments) {
			$shown = 0;
			foreach ($attachments as $attachment) {
				//if($used==get_post_meta($attachment->ID,'used',true)){
				$shown++;
				$class = $used==1?'used':'uploaded';
?>
<div id="bg-settings-<?php echo $attachment->ID?>" class="bg-settings-cont" rel="<?php echo $attachment->ID?>">
	<div class='bg-settings'>
		<?php $this->get_attachment_form($attachment)?>
	</div>
</div>
<?php				
			}
		}		
		
		if($shown==0){
			die('');
		}
			
		die();
	}
	
	function bg_change_order(){
		global $wpdb;
		
		if(!$this->check_ajax()){
			die(json_encode(array("R"=>"ERR",'MSG'=>'No access')));	
		}	
		//-------------------------
		foreach(array('post_id','attach_1','attach_2') as $field){
			$$field = isset($_REQUEST['attach_1'])?intval($_REQUEST[$field]):false;
			if(false===$$field){
				die(json_encode(array("R"=>"ERR",'MSG'=>'Missing parameter.')));
			}
			if(!current_user_can('edit_post',$$field)){
				die(json_encode(array("R"=>"ERR",'MSG'=>'No access(2)')));
			}
		}
		
		if($attach_1==$attach_2){
			die(json_encode(array("R"=>"ERR",'MSG'=>'Missing parameter(2)')));
		}
		
		$attach_2_order = intval($wpdb->get_var("SELECT menu_order FROM $wpdb->posts WHERE ID=$attach_2",0,0));
		
		$args = array(
			'post_parent' => $post_id,
			'orderby'	=> 'menu_order',
			'order'=>'ASC'
		);
		$attachments = get_cbg_attachments($args);
		
		if ($attachments) {
			$flag_increase_order = false;
			foreach ($attachments as $attachment) {
				if($attachment->ID==$attach_1){
					$attachment->menu_order = $attach_2_order;
					wp_update_post( $attachment );
					continue;
				}
				//------
				if($attachment->ID==$attach_2){
					$flag_increase_order =true;
				}
				
				if($flag_increase_order){
					$attachment->menu_order = $attachment->menu_order + 1;
					wp_update_post( $attachment );
				}
			}
		}	
		die(json_encode(array("R"=>"OK",'MSG'=>'')));
	}
	
	function form_template_css($post){
?>
<textarea class="css-extra" name="background-extra"><?php echo get_post_meta($post->ID,'background-extra',true)?></textarea>
<p>You can use this field to add custom CSS. This will allow you to e.g. adjust the placement, padding, margin etc. on the background.</p>
<?php	
	}
		
	function form_template($post){
		$background_type = get_post_meta($post->ID,'background_type',true);
		$background_type = ''==trim($background_type)?'bg-scheduled':$background_type;
?>
<div class="righthere-cb3">
<input type="hidden" name="background-css-nonce" id="background-css-nonce" value="<?php echo wp_create_nonce( 'background-css-nonce' )?>" />



<div id="bg-global-settings">	
	<div class="bg-settings">
		<div class="description topdesc">
			<p>Get started with creating your background by clicking <strong>Add Image</strong> to upload an image, or click <strong>External Image URL or No Image</strong> if you want to create a background without an image. Or you want to use an image that is stored on another server.</p>
		</div>
	</div>	
	
	<div class="bg-global-btn">
		<input class="upload-image" size="70" type="file" id="upload-image" name="upload_image" value="" />
	</div>
	<div class="bg-global-btn">
		<input type="button" class="button" id="btn-no-image" name="btn-no-image" value="External Image URL or No Image" />
	</div>

	<div class="bg-clearer"></div>
	<div id="uploadQueue" class="fileQueue"></div>
	<div class="bg-clearer"></div>
		
	<div class="bg-global-option">
		<div class="bg-settings">
			<div class="description topdesc">
				<p>Next step is to choose what type of background you want to create.</p>
			</div>
		</div>	
		<select id="background_type" name="background_type">
			<option <?php echo $background_type=='bg-scheduled'?'selected=""':'';?> value="bg-scheduled"> Single and Multiple (Scheduled)</option>
			<option <?php echo $background_type=='bg-change'?'selected=""':'';?> value="bg-change">Single and Multiple (Timer)</option>
			<option <?php echo $background_type=='bg-parallax'?'selected=""':'';?> value="bg-parallax">jQuery Parallax</option>
			<?php do_action('cb_type_option',array('background_type'=>$background_type)) ?>
		</select>			
		<div class="bg-clearer"></div>
		
		 <div id="cb_per_type_settings">
		<?php do_action('cb_global_options',array('post'=>$post)) ?>
		</div>
	</div>
</div>

<div id="list-of-bg" class="bg-viewport bg-uploaded">...</div>

<div id="dlg-helper-content" style="display:none;">
	<div id="bg-sel-top" class="bg-sel-top">
		<div class="">
			<label>URL:</label>
			<input type="text" id="bg_url" name="bg_url" value="<?php echo site_url()?>" />
			<input id="btn_bg_go" type="button" value="Go" />&nbsp;&nbsp;
			<label>Date filter:</label>
			<input type="text" id="bgts" name="bgts" value="" class="bg-browser-datepicker" />
			<input id="btn_apply_filter" type="button" value="Apply" />&nbsp;&nbsp;
		</div>
		<div class="">
			<label>Selector:</label>
			<input id="bg_selector" type="text" name="bg_selector" value="" />
			<input id="btn_bg_toggle" style="display:none;" type="button" value="Hide" />
			<input id="btn_bg_accept" type="button" value="Accept" />
			<input id="btn_bg_back" type="button" OnClick="javascript:jQuery('#dlg-helper-selector').hide();" value="Back" />
			<div id="bg_status">Type the url of the page where you want to apply this background and press on "Go"</div>
		</div>
	</div>
	<div id="bg-sel-cont" class="bg-sel-viewport-cont">
		<iframe id="bg_frame" src="<?php echo CUSTBACK_URL.'helper_selector.php'?>"></iframe>
	</div>
	<input id="bg-sel-attach-id" type="hidden" name="" value="" />	
</div>

</div>
<?php 	
	}
	
	function get_attachment_fields(){
		$attachment_fields = array('background_selector','background_external_url','background_attachment','background_color','background_custom_color', 'background_x','background_y','background_position','background_repeat','background_size','background_size_width','background_size_height','date_from','date_to','time_from','time_to','background_interval','background_target','background_cursor','background_url','parallax_width','parallax_height','parallax_left','parallax_top');
		return apply_filters('cb_attachment_fields',$attachment_fields);
	}
	
	function save_post($post_id){
		
		if ( !wp_verify_nonce( @$_POST['background-css-nonce'], 'background-css-nonce' )) {
			return $post_id;
		}
		if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
			return $post_id;
		// Check permissions
     
		//add_post_meta
		if ( 'background' == $_POST['post_type'] ) {
		  if ( !current_user_can( 'edit_post', $post_id ) ){
		  	return $post_id;
		  }    
		} else {
		    return $post_id;
		}
		
		if($this->save_post_done){
			return $post_id;
		}
		$this->save_post_done =true;
		global $post;
		//save general settings
		$general_settings = array('background_type','background-extra'); 
		$general_settings = apply_filters('cb_general_fields',$general_settings);
		foreach($general_settings as $field){
			if(isset($_POST[$field])){
				update_post_meta($post->ID,$field,$_POST[$field]);
			}
		}
		do_action('bg_save_post',array('post'=>$post));
		//save background settings
		//------------------
		$args = array(
			'post_type' => 'attachment',
			'numberposts' => 1000,
			'post_status' => null,
			'post_parent' => $post->ID
		);
		
		$attachment_fields = $this->get_attachment_fields();

		$attachments = get_cbg_attachments($args);
		if ($attachments) {
			foreach ($attachments as $attachment) {
				foreach( $attachment_fields  as $meta_name){
					$field = sprintf("%s_%s",$meta_name,$attachment->ID);
					update_post_meta($attachment->ID,$meta_name,@$_POST[$field]);
				}
			}
		}	
		//------------------		
		
		//---handle file upload
		if(isset($_FILES['upload_image'])&&$_FILES['upload_image']['size']>0){
			require_once(ABSPATH . 'wp-admin/includes/file.php');
			require_once(ABSPATH . 'wp-admin/includes/image.php');
			
			$result = wp_handle_upload($_FILES['upload_image'], array('test_form' => false) );		
			if( !array_key_exists('error', $result) ){
				$filename = $result['file'];
				$wp_filetype = wp_check_filetype(basename($filename), null );
				$attachment = array(
				   'post_mime_type' => $wp_filetype['type'],
				   'post_title' => preg_replace('/\.[^.]+$/', '', basename($filename)),
				   'post_content' => '',
				   'post_status' => 'inherit'
				);

				$attach_id = wp_insert_attachment( $attachment, $filename, $post->ID );

				$attach_data = wp_generate_attachment_metadata( $attach_id, $filename );
				wp_update_attachment_metadata( $attach_id,  $attach_data );
				//------------------
				$args = array(
					'post_type' => 'attachment',
					'numberposts' => 1000,
					'post_status' => null,
					'post_parent' => $post->ID
				);
				$attachments = get_posts($args);
				if ($attachments) {
					foreach ($attachments as $attachment) {
						if($attachment->ID==$attach_id)
							continue;
						$attachment->menu_order = $attachment->menu_order + 1;
						wp_update_post( $attachment );
					}
				}	
				//------------------				
			}				
		}

	}	
	function get_attachment_form($post){
		if($post->post_type=='attachment'){
			$url = wp_get_attachment_url($post->ID);
			$img = wp_get_attachment_image($post->ID, 'thumbnail', false);
			$img = $img==''? sprintf("<img class=\"attachment-thumbnail\" width=\"150\" height=\"100\" src=\"%s\" />",CUSTBACK_URL.'css/images/nobg.jpg'):$img;		
			$show_url = false;
			$ext_url = '';
		}else{
			$url = get_post_meta($post->ID,'background_external_url',true);
			$img = sprintf("<img class=\"attachment-thumbnail external-url\" width=\"150\" height=\"100\" src=\"%s\" />",(trim($url)==''?CUSTBACK_URL.'css/images/nobg.jpg':$url));
			$show_url = true;
			$ext_url = $url;
		}

?>
<div class="bg-tabs" rel="<?php echo $post->ID?>">
	<ul>
		<li class="bg-tab-image"><a href="#bg-tab-image-<?php echo $post->ID ?>">Image</a></li>
		<li class="bg-tab-css"><a href="#bg-tab-settings-<?php echo $post->ID ?>">CSS Settings</a></li>
		<li><a href="#bg-tab-schedule-<?php echo $post->ID ?>">Scheduling</a></li>
		<li class="bg-tab-timer"><a href="#bg-tab-timer-<?php echo $post->ID ?>">Timer</a></li>
		<li class="bg-tab-link"><a href="#bg-tab-link-<?php echo $post->ID ?>">Link</a></li>
<?php do_action("get_attachment_form_tab",array('post'=>$post))?>
	</ul>

	<div id="bg-tab-image-<?php echo $post->ID ?>" class="bg-tab-image">
		
		<div class="bg-location-selector">
			<div class="bg-image-holder">
				<div class="bg-image-cont" rel="<?php echo $post->ID?>">
					<input id="bg_image_<?php echo $post->ID?>" type="hidden" value="<?Php echo $url?>" />
					<div class="bg-image"><?php echo $img?></div>
					<div class='ico-close' rel='<?php echo $post->ID?>'>&nbsp;</div>
					<div style="text-align:center;"><?php echo basename($url)?></div>
				</div>
			</div>
			<div>
<?php if($post->post_type=='cbg-attachment'):?>				
				<p>External URL:
					<input class="background_external_url" rel="<?php echo $post->ID?>" name="background_external_url_<?php echo $post->ID?>" value="<?php echo $ext_url?>" type="text" />
				</p>
<?php endif;?>				
				<p>Background selector:
<?php
		$meta_name = 'background_selector';				
		$current = get_post_meta($post->ID,$meta_name,true);		
		echo " <input class=\"$meta_name\" type=\"text\" name=\"{$meta_name}_{$post->ID}\" value=\"$current\" /> <input rel=\"{$post->ID}\" class=\"button helper-selector\" type=\"button\" value=\"Lookup\" />";
		echo "<br />";		
		//----------------------
?>
				
				</p>
				<div class="bg-selector-desc">
					<div class="description ">
					<p>Choose where you want to apply the uploaded image. If you already know the name of the <strong>selector</strong>, type it in the field. Otherwise simply click <strong>Lookup</strong> and you will be able to point and click exactly where you want the background to be applied.</p>
					</div>
				</div>
				
			</div>

			<div class="clearer"></div>
		</div>	
	</div>	
	<div id="bg-tab-settings-<?php echo $post->ID ?>" class="bg-tab-css">
		

		<div class="bg-css-group">		
			
<?php		
		//---
		$meta_name = 'background_attachment';
		$options = array(
				'scroll' 	=> 'scroll',
				'fixed'		=> 'fixed',
				'inherit'	=> 'inherit'
				);
				
		$current = get_post_meta($post->ID,$meta_name,true);		
		$this->dropdown("{$meta_name}_{$post->ID}",$options,$current,'background-attachment',$meta_name);
		echo "<br />";		
		//----------------------
		$meta_name = 'background_color';
		echo "<div class=\"parent_child_select\">";
		$options = array(
				'custom' 		=> 'custom',
				'transparent'	=> 'transparent',
				'inherit'		=> 'inherit'
				);		
		$current = get_post_meta($post->ID,$meta_name,true);		
		$this->dropdown("{$meta_name}_{$post->ID}",$options,$current,'background-color','parent','custom');
		
		$color = get_post_meta($post->ID,'background_custom_color',true);
		
		echo '<div class="child">';
		echo '&nbsp;&nbsp;color = <input class="'.$meta_name.'" type="text" size="10" name="background_custom_color_'.$post->ID.'" value="'.$color.'"/>&nbsp;';
		echo '</div>';
		
		echo "</div>";
		echo "<br />";		
		//----------------------
		$meta_name = 'background_position';
		echo "<div class=\"parent_child_select\">";
		$options = array(
				'left top' 		=> 'left top',
				'left center'	=> 'left center',
				'left bottom'	=> 'left bottom',
				'right top'		=> 'right top',
				'right center'	=> 'right center',
				'right bottom'=>'right bottom',
				'center top'=>'center top',
				'center center'=>'center center',
				'center bottom'=>'center bottom',
				'x% y%'=>'x% y%',
				'xpos ypos'=>'xpos ypos',
				'inherit'=>'inherit'
				);
				
		$current = get_post_meta($post->ID,$meta_name,true);		
		$this->dropdown("{$meta_name}_{$post->ID}",$options,$current,'background-position',"parent $meta_name",'x% y%|xpos ypos');
		
		echo "<div class=\"child\">";
		$x = get_post_meta($post->ID,'background_x',true);
		echo '&nbsp;&nbsp;X = <input class="'.$meta_name.'" type="text" size="6" name="background_x_'.$post->ID.'" value="'.$x.'"/>&nbsp;';
		
		$y = get_post_meta($post->ID,'background_y',true);
		echo 'Y = <input class="'.$meta_name.'" type="text" size="6" name="background_y_'.$post->ID.'" value="'.$y.'" />';	
		echo "</div>";
		
		echo "</div>";
		echo "<br />";
		//----------------------		//----------------------
		$meta_name = 'background_repeat';
		$options = array(
				'repeat' 	=> 'repeat',
				'repeat-x'	=> 'repeat-x',
				'repeat-y'	=> 'repeat-y',
				'no-repeat'	=> 'no-repeat',
				'inherit'	=> 'inherit');

				
		$current = get_post_meta($post->ID,$meta_name,true);		
		$this->dropdown("{$meta_name}_{$post->ID}",$options,$current,'background-repeat',$meta_name);
		echo "<br />";
		//----------------------
		$meta_name = 'background_size';
		echo "<div class=\"parent_child_select_byval\">";
		$options = array(
				''				=> '--none--',
				'auto' 			=> 'auto',
				'cover'			=> 'cover',
				'contain'		=> 'contain',
				'length'		=> 'Custom width and height'
				);
				
		$current = get_post_meta($post->ID,$meta_name,true);		
		$this->dropdown("{$meta_name}_{$post->ID}",$options,$current,'background-size',"parent $meta_name",'length','percentage');

		echo "<div class=\"child length percentage\">";
		$value = get_post_meta($post->ID,'background_size_width',true);
		echo '&nbsp;&nbsp;Width = <input class="'.$meta_name.'" type="text" size="6" name="background_size_width_'.$post->ID.'" value="'.$value.'" />';	
		
		$value = get_post_meta($post->ID,'background_size_height',true);
		echo '&nbsp;&nbsp;Height = <input class="'.$meta_name.'" type="text" size="6" name="background_size_height_'.$post->ID.'" value="'.$value.'" />';	
		echo "<div class=\"description\">Please specify the unit. e.g. 100% or 1024px</div><div class=\"clearer\"></div>";
		echo "</div>";
		
		echo "</div>";
		echo "<br />";
		//----
		echo "</div>";//close bg-css-group
		//----
?>
		<div class="bg-parallax-group">
			<div class="bg-properties">
				<p><strong>Parallax settings</strong></p>
			</div>
			<div class="bg-properties">
				<label class="inline-label">Layer Width:</label><Input type='range' min='0' max='5000' class="parallax_width" name="parallax_width_<?php echo $post->ID?>" value="<?php  echo get_post_meta($post->ID,'parallax_width',true) ?>" />		
				<div class="clearer"></div>
			</div>
			<div class="bg-properties">
				<label class="inline-label">Layer Height:</label><Input type='range' min='0' max='5000' class="parallax_height" name="parallax_height_<?php echo $post->ID?>" value="<?php  echo get_post_meta($post->ID,'parallax_height',true) ?>" />	
				<div class="clearer"></div>
			</div>
			<div class="bg-properties">
				<label class="inline-label">Starting Top:</label><Input type='range' min='-500' max='500' class="parallax_top" name="parallax_top_<?php echo $post->ID?>" value="<?php  echo get_post_meta($post->ID,'parallax_top',true) ?>" />	
				<div class="clearer"></div>
			</div>
			<div class="bg-properties">
				<label class="inline-label">Starting Left:</label><Input type='range' min='-500' max='500' class="parallax_left" name="parallax_left_<?php echo $post->ID?>" value="<?php  echo get_post_meta($post->ID,'parallax_left',true) ?>" />	
				<div class="clearer"></div>
			</div>
			<div class="clearer"></div>
			<div class="bg-properties">
				<div class="description">Bigger layers move faster. Adjust the layer starting positioning with the top and left settings.</div>
			</div>
			<div class="clearer"></div>
		</div>

	</div>
	<div id="bg-tab-schedule-<?php echo $post->ID ?>">
		
<?php		
		//----------------------
		echo sprintf("<span class=\"bg-date-avail\">Date from (Optional):</span><input class=\"bg-datepicker\" type=\"text\" name=\"date_from_%s\" value=\"%s\" /><br />",$post->ID,get_post_meta($post->ID,'date_from',true));
		echo sprintf("<span class=\"bg-date-avail\">Date to (Optional):</span><input class=\"bg-datepicker\" type=\"text\" name=\"date_to_%s\" value=\"%s\" /><br />",$post->ID,get_post_meta($post->ID,'date_to',true));	
		echo sprintf("<span class=\"bg-date-avail\">Time from (Optional):</span><input class=\"jq-time\" type=\"text\" name=\"time_from_%s\" value=\"%s\" /><br />",$post->ID,get_post_meta($post->ID,'time_from',true));
		echo sprintf("<span class=\"bg-date-avail\">Time to (Optional):</span><input class=\"jq-time\" type=\"text\" name=\"time_to_%s\" value=\"%s\" /><br />",$post->ID,get_post_meta($post->ID,'time_to',true));
		echo "<div class=\"description\"><p><strong>The current date and time for your server:</strong> ".date("Y-m-d H:i")."</p></div><div class=\"clearer\"></div>";
?>
	</div>
	<div id="bg-tab-timer-<?php echo $post->ID ?>" class="bg-tab-timer">
		<div class="bg-properties bg-transition-delay">
			<label class="inline-label">Transition delay:</label><Input type='range' min='0' max='300' default='10' class="background_interval" name="background_interval_<?php echo $post->ID?>" value="<?php  echo ''==get_post_meta($post->ID,'background_interval',true)?10:get_post_meta($post->ID,'background_interval',true) ?>" /><br />
			<div class="clearer"></div>
			<div class="description"><p>This is the delay in seconds before the background changes.</p></div><div class="clearer"></div>
		</div>	
	</div>
		
	<div id="bg-tab-link-<?php echo $post->ID ?>" class="bg-tab-link">
		<div class="bg-properties">
			<label class="inline-label">Target:</label>
			<select name="background_target_<?php echo $post->ID?>">
				<option <?php  echo ''==get_post_meta($post->ID,'background_target',true)||'_self'==get_post_meta($post->ID,'background_target',true)?'selected="selected"':''?> value="_self">_self</option>
				<option <?php echo '_blank'==get_post_meta($post->ID,'background_target',true)?'selected="selected"':''?> value="_blank">_blank</option>
			</select>
		</div>

		<div class="bg-properties">
		<label class="inline-label">Use pointer cursor:</label>
			<select name="background_cursor_<?php echo $post->ID?>">
				<option <?php  echo ''==get_post_meta($post->ID,'background_cursor',true)||'1'==get_post_meta($post->ID,'background_cursor',true)?'selected="selected"':''?> value="1">Yes</option>
				<option <?php echo '0'==get_post_meta($post->ID,'background_cursor',true)?'selected="selected"':''?> value="0">No</option>
			</select>		
		</div>			
		<div class="bg-properties">
		<label class="inline-label">Target URL:</label>
		<Input type='text' class="background_url" name="background_url_<?php echo $post->ID?>" value="<?php  echo get_post_meta($post->ID,'background_url',true)?>" />
		<div class="description">
			<p><strong>Target:</strong> Choose self to open link in the same window, or blank to open a new tab.</p>
			<p><strong>Use pointer cursor:</strong> Choose yes to display a pointer cursor if the background is clickable.</p>
			<p><strong>Target URL:</strong> Clicking on the background image will take the user to this URL.</p>
		</div><div class="clearer"></div>
		</div>
	</div>
	
	<?php do_action('get_attachment_form_tab_body',array('post'=>$post))?>
</div>
<?php
	}
	function admin_head(){
		global $post;
		if($post->post_type!='background')
			return;
		wp_print_styles('theme-colorpicker-css');	
		wp_print_scripts('theme-colorpicker');	
		wp_print_styles('theme-uploadify-css');
		wp_print_scripts('theme-uploadify');		
		
		$auth_cookie = $_COOKIE[AUTH_COOKIE];
?>
<link rel='stylesheet' href='<?php echo CUSTBACK_URL?>css/rangeinput.css?v=1.0.1' type='text/css' media='all' />
<link rel='stylesheet' href='<?php echo CUSTBACK_URL?>css/smoothness/jquery-ui-1.8.18.custom.css' type='text/css' media='all' />
<script type='text/javascript' src='<?php echo CUSTBACK_URL?>js/jquery.ui.core.js'></script>
<script type='text/javascript' src='<?php echo CUSTBACK_URL?>js/jquery.ui.widget.js'></script>
<script type='text/javascript' src='<?php echo CUSTBACK_URL?>js/jquery.ui.mouse.js'></script>
<script type='text/javascript' src='<?php echo CUSTBACK_URL?>js/jquery.ui.draggable.js'></script>
<script type='text/javascript' src='<?php echo CUSTBACK_URL?>js/jquery.ui.droppable.js'></script>
<script type='text/javascript' src='<?php echo CUSTBACK_URL?>js/jquery.ui.slider.js'></script>
<script type='text/javascript' src='<?php echo CUSTBACK_URL?>js/jquery.ui.datepicker.js'></script>
<script type='text/javascript' src='<?php echo CUSTBACK_URL?>js/jquery-ui-timepicker-addon.js'></script>
<script type='text/javascript' src='<?php echo CUSTBACK_URL?>js/jquery.ui.tabs.js'></script>
<script type='text/javascript' src='<?php echo CUSTBACK_URL?>js/rangeinput.js'></script>
<script type='text/javascript'>
var auth_cookie = '<?php echo $auth_cookie ?>';
var logged_in_cookie = '<?php echo $_COOKIE[LOGGED_IN_COOKIE]?>';
var custback_url = '<?php echo CUSTBACK_URL; ?>';
var post_id = '<?php echo $post->ID?>';
</script>
<script type='text/javascript' src='<?php echo CUSTBACK_URL?>js/admin_custom_background.js?v=1.0.0'></script>
<?php		
		do_action('cb_admin_head',array('post'=>$post));	
	}
	
	function post_meta_box(){
		//3.0
		add_meta_box( 'background-settings', __('Backgrounds','cbw'),	array( &$this, 'form_template' ), 'background', 'normal', 'high');
		add_meta_box( 'background-css', __('Additional CSS','cbw'),	array( &$this, 'form_template_css' ), 'background', 'normal', 'high');			
	}	
	
	function get_background_dropdown($name,$value=''){
		global $wpdb;
		
		$str = "<select name=\"$name\">";
		$sql = "SELECT ID as value, post_title as label FROM `{$wpdb->posts}` WHERE post_type='background' AND post_status='publish'";
		if($wpdb->query($sql)&&$wpdb->num_rows>0){
			$str.="<option value=\"\">".__("--no custom background--","cbw")."</option>";
			foreach($wpdb->last_result as $row){
				$selected = $value==$row->value ? 'selected':'';
				$str.= sprintf("<option %s value=\"%s\">%s</option>",$selected,$row->value,htmlentities($row->label));		
			}
		}else{
			$str.="<option value=\"\">".__("--no options--")."</option>";
		}
		$str.= "</select>";
		return $str;	
	}
	
	function background_dropdown($name,$value=''){
		echo $this->get_background_dropdown($name,$value);
	}
			
	function dropdown($meta_name,$options,$current,$label=false,$class='',$rel=''){
		$label = false===$label?$meta_name:$label;
		echo sprintf('<label for="%s">%s:&nbsp;</label>',$meta_name,$label);
		echo sprintf('<select name="%s" class="%s" rel="%s">',$meta_name,$class,$rel);
		foreach($options as $property => $label){
				$checked = $property==$current ? 'selected':'';
				echo sprintf('<option %s value="%s">%s</option>',$checked,$property,$label);				
			}
		echo '</select>';
	}
	function dropdown_sec($meta_name,$options,$current){
		echo sprintf('<label for="%s">%s:&nbsp;</label>',$meta_name,str_replace("-sec","",$meta_name));
		echo sprintf('<select name="%s">',$meta_name);
		foreach($options as $property => $label){
				$checked = $property==$current ? 'selected':'';
				if(($label=="transparent") and empty($current)){$checked="selected";}
				echo sprintf('<option %s value="%s">%s</option>',$checked,$property,$label);				
			}
		echo '</select>';
	}
	
	function init($install=false){
		//NEW POST TYPE
		
		$labels = array(
			'menu_name'			=> __('Backgrounds'),
			'name' 				=> __('Backgrounds'),
			'singular_name' 	=> __('Background'),
			'add_new' 			=> __('Add new background'),
			'edit_item' 		=> __('Edit background'),
			'new_item' 			=> __('New background'),
			'view_item'			=> __('View background'),
			'search_items'		=> __('Search background'),
			'not_found'			=> __('No backgrounds found'),
			'not_found_in_trash'=> __('No backgrounds found in trash')
		);
		
		$taxonomies = array('category');
		global $cbg_plugin;
		if(is_array($cbg_plugin->options['taxonomies'])&&count($cbg_plugin->options['taxonomies'])>0){
			$taxonomies = array_merge($taxonomies,$cbg_plugin->options['taxonomies']);
		}
		
		register_post_type('background', array(
			'label' => __('Backgrounds'),
			'labels' => $labels,
			'public' => true,
			'show_ui' => ($install)?true:($this->show_ui?true:false),
			'capability_type' => 'post',
			'hierarchical' => true,
			'rewrite' => false,
			'query_var' => false,
			'supports' => array('title','revisions','page-attributes'),
			'exclude_from_search' => false,
			//'menu_position' => 5,
			'show_in_nav_menus' => false,
			'taxonomies' => $taxonomies,
			'menu_icon'=> CUSTBACK_URL.'images/cb.png'
		));
				
		register_post_type('cbg-attachment', array(
			'label' => __('Background attachments','cbw'),
			'public' => true,
			'show_ui' => false,
			'capability_type' => 'post',
			'hierarchical' => false,
			'rewrite' => false,
			'query_var' => false,
			'supports' => array('title','content'),
			'exclude_from_search' => true,
			'show_in_nav_menus' => false
		));
		
//		global $cbg_plugin;
//		if(is_array($cbg_plugin->options['taxonomies'])&&count($cbg_plugin->options['taxonomies'])>0){
//			foreach($cbg_plugin->options['taxonomies'] as $taxonomy){
//				register_taxonomy_for_object_type($taxonomy, 'background');
//			}
//		}
	}
}
?>