<?php

/**
 * 
 *
 * @version $Id$
 * @copyright 2003 
 **/

class cb_bgstretcher {
	function cb_bgstretcher(){
		add_action('cb_type_option',array(&$this,'cb_type_option'),10,1);
		
		add_action('cb_global_options',array(&$this,'cb_global_options'),10,1);
		add_action('cb_admin_head',array(&$this,'cb_admin_head'),10,1);
		add_filter('cb_general_fields',array(&$this,'cb_general_fields'),10,1);
	}
	
	function cb_admin_head($args){
		extract($args);
?>
<style>
.bg-stretcher .bg-tab-bgstretcher {
display:block;
}
.bg-tab-bgstretcher {
display:none;
}
.bg-tab-bgstretcher {
	margin-top:15px;
}
</style>
<script type='text/javascript'>
jQuery(document).ready(function($){
	$('.bg-tab-bgstretcher').tabs();
	$('.bgst_overlay').change(function(e){
		var _val = $(this).val();
		$('.bg-overlay-preview').css('background-image', 'none');
		if('custom'==_val){
			$('.bg-overlay-url-cont').show();
			var _url = $('#bgst_overlay_url').val();	
			if(''!=_url){
				$('.bg-overlay-preview').css('background-image', 'url('+_url+')');
			}
		}else{
			$('.bg-overlay-url-cont').hide();
			if(''!=_val){
				var _url = '<?php echo CUSTBACK_URL ?>css/images/overlays/' + _val;
				$('.bg-overlay-preview').css('background-image', 'url('+_url+')');
			}
		}
	}).trigger('change');
	
	$('#bgst_overlay_url').change(function(e){
		var _url = $(this).val();
		$('.bg-overlay-preview').css('background-image', 'none');
		if(_url!=''){
			$('.bg-overlay-preview').css('background-image', 'url('+_url+')');
		}
	});
});

</script>
<?php		
	}
	
	function cb_type_option($args){
		extract($args);
?>
<option <?php echo $background_type=='bg-stretcher'?'selected=""':'';?> value="bg-stretcher">jQuery Background Stretcher</option>
<?php	
	}
		
	function cb_general_fields($fields){
		$option = array();
		foreach(		array(
		'bgst_overlay',
		'bgst_overlay_url',
		'bgst_preloadImg',
		'bgst_resizeProportionally',
		'bgst_resizeAnimate',
		'bgst_imageWidth',
		'bgst_imageHeight',
		'bgst_nextSlideDelay',
		'bgst_slideShowSpeed',
		'bgst_slideShow',
		'bgst_transitionEffect',
		'bgst_slideDirection',
		'bgst_sequenceMode',
		'bgst_anchoring',
		'bgst_anchoringImg'
		) as $field){
			if(isset($_POST[$field])){
				$option[$field] = $_POST[$field];
			}
		}
		
		$_POST['cb_bgstretcher']=$option;
		$fields[]='cb_bgstretcher';
		return $fields;
	}
	
	function cb_global_options($args){
		extract($args);
		
		$option = get_post_meta($post->ID,'cb_bgstretcher',true);
		$option = is_array($option)?$option:array();
		
		$non_empty_fields_defaults = array(
			'bgst_preloadImg'=>'1',
			'bgst_resizeProportionally'=>'1',
			'bgst_resizeAnimate'=>'0',
			'bgst_anchoring'=>'left top',
			'bgst_anchoringImg'=>'left top'
		);
		foreach($non_empty_fields_defaults as $field => $value){
			$option[$field] = isset($option[$field])?$option[$field]:$value;
		}
		
		$overlay_options = array(
			''		=>'--none--',
			'custom'=>'Custom background URL'
		);
		if ($handle = opendir( CUSTBACK_PATH.'css/images/overlays/')) {
		    while (false !== ($file = readdir($handle))) {
				$path_info = pathinfo(strtolower($file));
				if(!in_array( $path_info['extension'], array('png','gif') ))continue;
				//$url = CUSTBACK_URL.'css/images/overlays/'.$file;
				$overlay_options[$file]=$file;
		    }
		    closedir($handle);
		}
?>
	<div id="bg-tab-bgstretcher-<?php echo $post->ID ?>" class="bg-tab-bgstretcher ui-widget ui-tabs ui-corner-all ui-widget-content">
		<ul>
			<li><a href="#bg-stretcher-general-settings">General Settings</a></li>
			<li><a href="#bg-stretcher-overlay">Overlay</a></li>
		</ul>
		<div id="bg-stretcher-overlay">
			<div class="bg-overlay-preview"></div>
			<div class="bg-fieldset-overlay">
				<label class="inline-label">Overlay image:</label>	
				<?php $this->dropdown('bgst_overlay','bgst_overlay', $overlay_options, @$option['bgst_overlay'],'bgst_overlay') ?>				
			</div>
			<div class="bg-fieldset-overlay bg-overlay-url-cont">
				<label class="inline-label">Custom overlay image URL:</label><br />
				<Input id="bgst_overlay_url" type='text' class="bgst_overlay_url" name="bgst_overlay_url" value="<?php  echo isset($option['bgst_overlay_url'])?$option['bgst_overlay_url']:''?>" />
			</div>
			<div class="clearer"></div>
			<div class="bg-selector-desc">
				<div class="description">
					<p>Choose Custom background URL if you wish to provide an external overlay image.</p>
					<p>If you add an overlay, the background will not be clickable.</p>
				</div>			
			</div>

			<div class="clearer"></div>
		</div>
		<div id="bg-stretcher-general-settings" class="bg-properties ui-tabs-panel">
			<div class="bg-fieldset">
				<label class="inline-label">Preload image:</label>	
				<?php $this->inline_radio('bgst_preloadImg','bgst_preloadImg',array('1'=>'Yes','0'=>'No'), @$option['bgst_preloadImg'])?>
			</div>
			
			<div class="bg-fieldset">
				<label class="inline-label">Resize Proportionally:</label>	
				<?php $this->inline_radio('bgst_resizeProportionally','bgst_resizeProportionally',array('1'=>'Yes','0'=>'No'), @$option['bgst_resizeProportionally'])?>
			</div>			
		
			<div class="bg-fieldset">
				<label class="inline-label">Resize Animate:</label>	
				<?php $this->inline_radio('bgst_resizeAnimate','bgst_resizeAnimate',array('1'=>'Yes','0'=>'No'), @$option['bgst_resizeAnimate'])?>
			</div>
		
			<div class="bg-fieldset">
				<label class="inline-label">Image Width:</label>	
				<Input type='range' min='0' max='5000' class="bgst_imageWidth" name="bgst_imageWidth" value="<?php  echo isset($option['bgst_imageWidth'])?$option['bgst_imageWidth']:1024?>" />
				<div class="clearer"></div>
			</div>
		
			<div class="bg-fieldset">
				<label class="inline-label">Image Height:</label>	
				<Input type='range' min='0' max='5000' class="bgst_imageHeight" name="bgst_imageHeight" value="<?php  echo isset($option['bgst_imageHeight'])?$option['bgst_imageHeight']:768; ?>" />
				<div class="clearer"></div>
			</div>
		
			<div class="bg-fieldset">
				<label class="inline-label">Next Slide Delay (secs):</label>	
				<Input type='range' min='0' max='100' step='0.1' class="bgst_nextSlideDelay" name="bgst_nextSlideDelay" value="<?php  echo isset($option['bgst_nextSlideDelay'])?$option['bgst_nextSlideDelay']:3; ?>" />
				<div class="clearer"></div>
			</div>
		
			<div class="bg-fieldset">
				<label class="inline-label">Slide Show Speed (secs):</label>	
				<Input type='range' min='0' max='100' step='0.1' class="bgst_slideShowSpeed" name="bgst_slideShowSpeed" value="<?php echo isset($option['bgst_slideShowSpeed'])?$option['bgst_slideShowSpeed']:3; ?>" />
				<div class="clearer"></div>
			</div>
		
			<div class="bg-fieldset">
				<label class="inline-label">Enable SlideShow:</label>	
				<?php $this->inline_radio('bgst_slideShow','bgst_slideShow',array('1'=>'Yes','0'=>'No'), @$option['bgst_slideShow'])?>
			</div>
		
			<div class="bg-fieldset">
				<label class="inline-label">Transition Effect:</label>	
				<?php $this->dropdown('bgst_transitionEffect','bgst_transitionEffect',array('none'=>'none','fade'=>'fade','superSlide'=>'superSlide'), @$option['bgst_transitionEffect'] ) ?>
			</div>
		
			<div class="bg-fieldset">
				<label class="inline-label">Slide Direction:</label>	
				<?php $this->dropdown('bgst_slideDirection','bgst_slideDirection',array('N'=>'N','S'=>'S','W'=>'W','E'=>'E','NW'=>'NW(superSlide only)','NE'=>'NE(superSlide only)','SW'=>'SW(superSlide only)','SE'=>'SE(superSlide only)'), @$option['bgst_slideDirection'] ) ?>
			</div>
		
			<div class="bg-fieldset">
				<label class="inline-label">Sequence Mode:</label>	
				<?php $this->dropdown('bgst_sequenceMode','bgst_sequenceMode',array('normal'=>'normal','back'=>'back','random'=>'random'), @$option['bgst_sequenceMode']) ?>
			</div>
		
			<div class="bg-fieldset">
				<label class="inline-label">Anchoring:</label>	
				<?php $this->dropdown('bgst_anchoring','bgst_anchoring',
				array(
					'left top'		=>'left top',
					'left center'	=>'left center',
					'left bottom'	=>'left bottom',
					'center top'	=>'center top',
					'center center'	=>'center center',
					'center bottom'	=>'center bottom',
					'right top'		=>'right top',
					'right center'	=>'right center',
					'right bottom'	=>'right bottom'
					),
				@$option['bgst_anchoring']) ?>
			</div>
			<div class="bg-fieldset">
				<label class="inline-label">Anchoring Image:</label>	
				<?php $this->dropdown('bgst_anchoringImg','bgst_anchoringImg',
				array(
					'left top'		=>'left top',
					'left center'	=>'left center',
					'left bottom'	=>'left bottom',
					'center top'	=>'center top',
					'center center'	=>'center center',
					'center bottom'	=>'center bottom',
					'right top'		=>'right top',
					'right center'	=>'right center',
					'right bottom'	=>'right bottom'
					),
				@$option['bgst_anchoringImg']) ?>
			</div>
	

		<div class="description"><p>This are general settings to control the jQuery Background Stretcher.</p></div><div class="clearer"></div>
		</div>	
	</div>	
<?php	
	}
	
	function inline_radio($id,$name,$options,$selected){
		foreach($options as $value => $label):
?>
<input type="radio" name="<?php echo $name?>" value="<?php echo $value?>" <?php echo $selected==$value?'checked="checked"':''?> />&nbsp;<?php echo $label?>&nbsp;&nbsp;
<?php	
		endforeach;
	}
	
	function dropdown($id,$name,$options,$selected,$class=''){
?>
<select id="<?php echo $id?>" name="<?php echo $name?>" class="<?php echo $class?>">
<?php foreach($options as $value => $label):?>
<option value="<?PHP echo $value?>" <?PHP echo $value==$selected?'selected="selected"':''?> ><?PHP echo $label?></option>
<?php endforeach;?>
</select>
<?php		
	}
}
?>