<?php

/**
 * 
 *
 * @version $Id$
 * @copyright 2003 
 **/
class cbg_settings {
	function cbg_settings(){
		add_filter('pop-options_cbg',array(&$this,'options'),10,1);
	}
	
	function options($t){
		$i = count($t);
		//--Default backgrounds -----------------------		
		$i++;
		$t[$i]->id 			= 'cbw-defaults'; 
		$t[$i]->label 		= __('Default Backgrounds','cbw');
		$t[$i]->right_label	= __('Home, Front, Search, Author, Archive, 404 and Default.','cbw');
		$t[$i]->page_title	= __('Default Backgrounds','cbw');
		$t[$i]->theme_option = true;
		$t[$i]->plugin_option = true;
		$t[$i]->options = array(
	
		);
		
		$background_options = $this->get_background_options();
		
		$t[$i]->options[]=(object)array(
			'id'=>'login',
			'type'=>'select',
			'options'=>$background_options,
			'label'=>__('Login page Background','cbw'),
			'description'=> __("<h4>General Backgrounds</h4>Choose a background for different sections. You can also specify specific backgrounds for pages, posts and custom post types added by plugins, by editing the specific page/post.<h4>Authors</h4>Edit the user profile to choose an individual background for a author, or set a default here for all authors that don't have a individual background.",'cbw'),
			'description_rowspan'=>8,
			'save_option'=>true,
			'load_option'=>true
		);			
		foreach(array(
				'home'=> __('Home Background','cbw'),
				'frontpage'=> __('Frontpage Background','cbw'),
				'search'=> __('Search Background','cbw'),
				'author'=> __('Author Background','cbw'),
				'archive'=> __('Archive Background','cbw'),
				'page404'=> __('404 Page Background','cbw'),
				'fallback'=> __('Default Background','cbw')
			) as $field => $label){
			$t[$i]->options[]=(object)array(
				'id'=>$field,
				'type'=>'select',
				'options'=>$background_options,
				'label'=>$label,
				'save_option'=>true,
				'load_option'=>true
			);		
		}//foreach
		$t[$i]->options[]=(object)array(
				'type'=>'clear'
			);
		$t[$i]->options[]=(object)array(
				'type'	=> 'submit',
				'label'	=> __('Save','sws'),
				'class' => 'button-primary',
				'save_option'=>false,
				'load_option'=>false
			);			
		//--Custom Post Types -----------------------		
		$i++;
		$t[$i]->id 			= 'cbw-custom-types'; 
		$t[$i]->label 		= __('Custom Post Types','cbw');
		$t[$i]->right_label	= __('Enable Custom Background for other post types.','cbw');
		$t[$i]->page_title	= __('Custom Post Types','cbw');
		$t[$i]->theme_option = true;
		$t[$i]->plugin_option = true;
		$t[$i]->options = array();
		
		//--------------
		$post_types=array();
		foreach(get_post_types(array(/*'public'=> true,*/'_builtin' => false),'objects','and') as $post_type => $pt){
			if('background'==$post_type)continue;
			$post_types[$post_type]=$pt;
		} 
		//--------------		
		if(count($post_types)==0){
			$t[$i]->options[]=(object)array(
				'id'=>'no_ctypes',
				'type'=>'description',
				'label'=>__("There are no additional Custom Post Types to enable.",'cbw')
			);
		}else{
			$j=0;
			foreach($post_types as $post_type => $pt){
				$tmp=(object)array(
					'id'	=> 'post_types_'.$post_type,
					'name'	=> 'post_types[]',
					'type'	=> 'checkbox',
					'option_value'=>$post_type,
					'label'	=> (@$pt->labels->name?$pt->labels->name:$post_type),
					'el_properties' => array(),
					'save_option'=>true,
					'load_option'=>true
				);
				if($j==0){
					$tmp->description = __("Custom Backgrounds can be enabled for plugins using WordPress 3.0 Custom Post Types",'cbw');
					$tmp->description_rowspan = count($post_types);
				}
				$t[$i]->options[]=$tmp;
				$j++;
			}
		}
		
		
		$t[$i]->options[]=(object)array(
				'type'=>'clear'
			);
		$t[$i]->options[]=(object)array(
				'type'	=> 'submit',
				'label'	=> __('Save','sws'),
				'class' => 'button-primary',
				'save_option'=>false,
				'load_option'=>false
			);	
		//--Custom Taxonomies -----------------------		
		$i++;
		$t[$i]->id 			= 'cbw-custom-taxonomies'; 
		$t[$i]->label 		= __('Custom Taxonomies','cbw');
		$t[$i]->right_label	= __('Enable Custom Taxonomies.','cbw');
		$t[$i]->page_title	= __('Custom Taxonomies','cbw');
		$t[$i]->theme_option = true;
		$t[$i]->plugin_option = true;
		$t[$i]->options = array();		
		
		$taxonomies = get_taxonomies( array(),'objects' );
		if(count($post_types)==0){
			$t[$i]->options[]=(object)array(
				'id'=>'no_taxonomies',
				'type'=>'description',
				'label'=>__("There are no Custom Taxonomies to enable.",'cbw')
			);
		}else{
			$j=0;
			foreach($taxonomies as $taxonomy => $tax){
				if($tax->_builtin==1)continue;
				if(true){	
					$tmp=(object)array(
						'id'	=> 'taxonomies_'.$taxonomy,
						'name'	=> 'taxonomies[]',
						'type'	=> 'checkbox',
						'option_value'=>$taxonomy,
						'label'	=> (@$tax->labels->name?$tax->labels->name:$taxonomy),
						'el_properties' => array(),
						'save_option'=>true,
						'load_option'=>true
					);
					if($j==0){
						$tmp->description = __("Custom Backgrounds for Custom Taxonomies can be enabled for WordPress 3.1",'cbw');
						$tmp->description_rowspan = count($post_types);
					}
					$t[$i]->options[]=$tmp;
					$j++;					
				}
			}		
		}

		//die();
		$t[$i]->options[]=(object)array(
				'type'=>'clear'
			);
		$t[$i]->options[]=(object)array(
				'type'	=> 'submit',
				'label'	=> __('Save','sws'),
				'class' => 'button-primary',
				'save_option'=>false,
				'load_option'=>false
			);			
		//--Advanced settings-----------------------		
		$i++;
		$t[$i]->id 			= 'advanced'; 
		$t[$i]->label 		= __('Advanced Settings','cbw');
		$t[$i]->right_label	= __('Advanced Settings','cbw');
		$t[$i]->page_title	= __('Advanced Settings','cbw');
		$t[$i]->theme_option = true;
		$t[$i]->plugin_option = true;
		$t[$i]->options = array(
			(object)array(
				'id'	=> 'enable_quick_edit',
				'type'	=> 'checkbox',
				'label'	=> __('Enable quick edit','cbw'),
				'description' => __('Enable Custom Backgrounds in the Quick Edit panel. Enabling this feature may conflict with other plugins that add custom fields to the quick edit panel.','cbw'),
				'el_properties' => array(),
				'save_option'=>true,
				'load_option'=>true
			),	
			(object)array(
				'id'	=> 'skip_handle_local_time_zone',
				'type'	=> 'checkbox',
				'label'	=> __('Disable adding cbg_tz to the url ','cbw'),
				'description' => __('Check this option if you don\'t want the URL of your website to show "cbg_tz=240". This is used to set the local time zone cookie the first time a visitor gets to your website. If you choose not to set the cookie your scheduled backgrounds will not show the correct backgrounds applicable to the correct local time zone.','cbw'),
				'el_properties' => array(),
				'save_option'=>true,
				'load_option'=>true
			),	
			(object)array(
				'id'	=> 'scripts_in_footer',
				'type'	=> 'checkbox',
				'label'	=> __('Javascript in footer','cbw'),
				'description' => __('Output javascript in the theme footer.','cbw'),
				'el_properties' => array(),
				'save_option'=>true,
				'load_option'=>true
			),	
//			(object)array(
//				'id'	=> 'use_bundled_jquery',
//				'type'	=> 'checkbox',
//				'label'	=> __('Use bundled jquery','cbw'),
//				'description' => __('Use the bundled jquery javascript.','cbw'),
//				'el_properties' => array(),
//				'save_option'=>true,
//				'load_option'=>true
//			),
			(object)array(
				'type'=>'clear'
			)	,
			(object)array(
				'type'	=> 'submit',
				'label'	=> __('Save','sws'),
				'class' => 'button-primary',
				'save_option'=>false,
				'load_option'=>false
			)	
		);		
		//-------------------------	
		return $t;
	}
	
	function get_background_options(){
		global $wpdb;
		$options = array(''=>__("--no custom background--","cbw"));
		$sql = "SELECT ID as value, post_title as label FROM `{$wpdb->posts}` WHERE post_type='background' AND post_status='publish'";
		if($wpdb->query($sql)&&$wpdb->num_rows>0){
			foreach($wpdb->last_result as $row){
				$options[$row->value]=$row->label;		
			}
		}
		return $options;	
	}
}
?>