<?php
if(!function_exists('property_exists')):
function property_exists($o,$p){
	return is_object($o) && 'NULL'!==gettype($o->$p);
}
endif;

class plugin_custom_backgrounds {
	var $id = 'cbg';
	var $options;
	var $show_ui = true;
	var $options_parameters = array();
	var $frontend_scripts_in_footer = false;
	var $use_bundled_jquery = true;
	function plugin_custom_backgrounds($args=array()){
		//------------
		$defaults = array(
			'options_parameters'=> array()
		);
		foreach($defaults as $property => $default){
			$this->$property = isset($args[$property])?$args[$property]:$default;
		}
		//-----------	
		$this->options = get_option('custom_background_options');
		add_action('plugins_loaded',array(&$this,'plugins_loaded'));
		add_action('init',array(&$this,'init'));
		add_action('init',array(&$this,'replace_inline_edit_post'));
		$this->frontend_scripts_in_footer = (isset($this->options['scripts_in_footer'])&&$this->options['scripts_in_footer']==1)?true:false;
		//$this->use_bundled_jquery = (isset($this->options['use_bundled_jquery'])&&$this->options['use_bundled_jquery']==1)?true:false;
		//-------
		add_action('login_head',array(&$this,'login_head'));
	}
	
	function init(){
		if(is_admin()):
			wp_enqueue_script('jquery-ui-droppable');
			wp_enqueue_script('jquery-ui-selectable');
		
			wp_register_style( 'theme-uploadify-css', CUSTBACK_URL.'uploadify/uploadify.css', array(),'2.1.0');
			wp_register_style( 'theme-colorpicker-css', CUSTBACK_URL.'js/colorpicker.css', array(),'1.0.0');
			wp_enqueue_style('cbw-toggle',CUSTBACK_URL.'css/toggle.css',array(),'1.0.0');
			wp_register_style( 'cbg-options', CUSTBACK_URL.'css/pop.css', array(),'1.0.0');
			wp_register_script( 'theme-colorpicker', CUSTBACK_URL.'js/colorpicker.js', array(),'1.0.0');
			wp_register_script( 'theme-swfobject', CUSTBACK_URL.'uploadify/swfobject.js', array(),'1.0.0');
			wp_register_script( 'theme-uploadify', CUSTBACK_URL.'uploadify/jquery.uploadify.v2.1.0.min.js', array('jquery','theme-swfobject'),'2.1.0' );
		else:
//			if($this->use_bundled_jquery){
//				wp_enqueue_script( 'cbg-jquery', CUSTBACK_URL.'js/jquery.js', array(),'1.4.4',$this->frontend_scripts_in_footer);			
//			}else{
//				wp_enqueue_script('jquery');
//			}			
			wp_enqueue_script( 'image-preloader', CUSTBACK_URL.'js/preload.js', array('jquery'),'1.0.0',$this->frontend_scripts_in_footer);			
			wp_enqueue_script( 'bg-stretcher', CUSTBACK_URL.'js/bgstretcher.js', array('jquery'),'1.0.0',$this->frontend_scripts_in_footer);
			wp_enqueue_script( 'cbg-cookie', CUSTBACK_URL.'js/cookie.js', array('jquery'),'1.0.0',$this->frontend_scripts_in_footer);
			wp_enqueue_script( 'bg-parallax', CUSTBACK_URL.'js/jquery.jparallax.js', array('jquery'),'0.9.1',$this->frontend_scripts_in_footer);
			wp_enqueue_script( 'custom-background', CUSTBACK_URL.'js/custom_background.js', array('jquery'),'1.0.1',$this->frontend_scripts_in_footer);
			wp_enqueue_style( 'cbg-css', CUSTBACK_URL.'css/cbg.css', array(),'1.0.0.1');
		endif;
	}
	
	function plugins_loaded(){
		require_once CUSTBACK_PATH.'includes/functions.php';
		if(is_admin()):
			require_once CUSTBACK_PATH.'includes/class.Backgrounds.php';
			new Backgrounds($this->options_parameters);
			require_once CUSTBACK_PATH.'includes/class.cb_bgstretcher.php';new cb_bgstretcher();
			require_once CUSTBACK_PATH.'includes/class.PostPageBackgrounds.php';
			//---------
			require_once CUSTBACK_PATH.'includes/class.cbg_settings.php';new cbg_settings();
			require_once CUSTBACK_PATH.'includes/class.plugin_registration.php';
			new plugin_registration(array('plugin_id'=>$this->id,'tdom'=>'cbw','plugin_code'=>'CBG','options_varname'=>'custom_background_options'));
			require_once CUSTBACK_PATH.'includes/class.PluginOptionsPanel.php';
			$settings = array(				
				'id'					=> $this->id,
				'plugin_id'				=> $this->id,
				'capability'			=> 'manage_options',
				'options_varname'		=> 'custom_background_options',
				'menu_id'				=> 'cbg-options',
				'page_title'			=> __('Options','cbg'),
				'menu_text'				=> __('Options','cbg'),
				'option_menu_parent'	=> 'edit.php?post_type=background',
				'notification'			=> (object)array(
					'plugin_version'=> CBG_VERSION,
					'plugin_code' 	=> 'CBG',
					'message'		=> __('Custom Backgrounds update %s is available! <a href="%s">Please update now</a>','cbg')
				),
				'theme'					=> false,
				'stylesheet'			=> 'cbg-options',
				'rangeinput'			=> false,
				'colorpicker'			=> false					
			);
			new PluginOptionsPanel($settings);
		else:

		endif;
		
		require_once CUSTBACK_PATH.'includes/class.BackgroundsFrontend.php';	
		require_once CUSTBACK_PATH.'includes/class.BackgroundsAuthor.php';	
	}
	
	function login_head(){	
		wp_print_styles('cbg-css');
		wp_print_scripts('image-preloader');
		wp_print_scripts('bg-stretcher');
		wp_print_scripts('cbg-cookie');
		wp_print_scripts('bg-parallax');
		wp_print_scripts('custom-background');
	}
	
	function replace_inline_edit_post() {
		if(is_admin()):			
			if(isset($this->options['enable_quick_edit'])&&$this->options['enable_quick_edit']==1){
	    		wp_deregister_script( 'inline-edit-post' );
	    		wp_register_script( 'inline-edit-post', CUSTBACK_URL.'js/custom-inline-edit-post-custom.js',array('jquery','suggest'),'3.1');
			}
		endif;
	}  
}  

?>