jQuery(document).ready(function($){
	$(".wrap h2").html("");
	$(".wrap h2").html("Add New Background");
	
	$("#upload-image").uploadify({
		'buttonText' : 'Add image',
		'uploader'       : custback_url+'uploadify/uploadify.swf',
		'script'         : custback_url+'uploadify/uploadAttachment.php',
		'cancelImg'      : custback_url+'uploadify/cancel.png',
		'buttonImg'		 : custback_url+'uploadify/add_image.png',
		'width'			: 87,
		'height'		: 30,
		'folder'         : 'uploads',
		'queueID'        : 'uploadQueue',
		'auto'           : true,
		'multi'          : true,
		'onComplete'	 : file_uploaded,
		'onError'		: function (a, b, c, d) {
        	alert('error '+d.type+": "+d.info);
		},
		'scriptData'	: {
			'action':'wp_handle_upload',
			'post_id':post_id,
			'auth_cookie': auth_cookie,
			'logged_in_cookie': logged_in_cookie
			}
	});		
	
	load_attachments();
		
	$('#background_type').change(function(){	
		$(this).find('option').each(function(i,o){
			$('#list-of-bg').removeClass( $(this).attr('value') );
			$('#cb_per_type_settings').removeClass( $(this).attr('value') );
		});	
		$('#list-of-bg').addClass( $(this).val() );
		$('#cb_per_type_settings').addClass( $(this).val() );
	}).change();
	
	
	$('<div id="dlg-helper-selector"></div>').append( $('#dlg-helper-content').show() ).hide().appendTo('body');
	
	$('#btn-no-image').click(function(){
		var args = {
			action: 'bg_no_image',
			post_id: post_id
		};	
		$.post(ajaxurl,args,function(data){
			if(data.R=='OK'){
				load_attachments();
			}else if(data.R=='ERR'){
				alert(data.MSG);
				return true;
			}else{
				alert('Unknown error');
				return true;
			}
		},'json');		
	});
	$('.cbg-toggle').click(function(e){
		$(this).next().toggle();
	});	
});

function dropped(ui,receptor){
	jQuery(document).ready(function($) {
		if( $(ui.helper).attr('rel') && $(ui.helper).hasClass('bg-settings-cont') ){
			var args = {
				action: 'bg_change_order',
				post_id: post_id,
				attach_1: $(ui.helper).attr('rel'),
				attach_2: $(receptor).attr('rel') 
			};
			
			$.post(ajaxurl,args,function(data){
				if(data.R=='OK'){
					
				}else if(data.R=='ERR'){
					load_attachments();
					alert(data.MSG);
					return true;
				}else{
					load_attachments();
					alert('Unknown error');
					return true;
				}
			},'json');
		}	
	});
}

function load_attachments(){
	jQuery(document).ready(function($) {
		if( $('#list-of-bg').find('input.modified, textarea.modified, select.modified').length==0 ){
			load_uploaded_attachments();
		}else{
			$('#list-of-bg').find('input.modified, textarea.modified, select.modified').each(function(i,inp){
				var args = {
					action: 'bg_save_attachment_field',
					post_id: post_id,
					name: $(inp).attr('name'),
					value: $(inp).val()
				};
				$.post(ajaxurl,args,function(data){
					if(data.R=='OK'){
						load_uploaded_attachments();
					}else{
						alert('There was an error saving your changes, save before adding new images');
					}
				},'json');
			});		
		}		
	});
}

function load_uploaded_attachments(){
	jQuery(document).ready(function($) {
		$('.bg-global-option').hide();
		
		var data = {
			action: 'bg_load_attachments',
			post_id: post_id,
			used:0
		};
	
		$('#list-of-bg').load(ajaxurl,data,function(responseText){
			if(responseText==''){
				$(this).html('<p></p>');
				return;
			}
			
			$('.bg-global-option').show();
			
			$('.ico-close').click(function(){
				$(this).parent().fadeOut();
				$.post(ajaxurl,{'post_id':'','attach_id':$(this).attr('rel'),'action':'bg_delete_attachment'},function(data){
					if(data.R=='OK'){
						load_attachments();
					}else if(data.R=='ERR'){
						alert(data.MSG);
						return true;
					}else{
						alert('Unknown error');
						return true;
					}
				},'json');
			});
						
			$('.parent_child_select .parent').change(function(){
				var me = this;
				var selected = $(this).val();
				var show_child_values = $(this).attr('rel').split('|');
				var show = false;
				$.each(show_child_values,function(i,val){
					if(val==selected){
						show=true;
						return;
					}
				});
				if(show){
					$(me).parent().find('.child').show();
				}else{
					$(me).parent().find('.child').hide();
				}
			}).change();	
			
			$('.parent_child_select_byval .parent').change(function(){
				$(this).parent().find('.child').hide();
				if(''!=$(this).val())
					$(this).parent().find('.child.'+$(this).val()).show();
			}).change();	
			
			$('.helper-selector').click(function(){
				dlg_helper_selector( $(this).attr('rel') );
			});		
			
			$(".background_color").ColorPicker({
				onSubmit: function(hsb, hex, rgb, el) {
					$(el).val("#"+hex);
					$(el).ColorPickerHide();
					$(el).trigger('change');
				},
				onBeforeShow: function () {
					$(this).ColorPickerSetColor(this.value);
				}
			}).bind('keyup', function(){
				$(this).ColorPickerSetColor(this.value);
			});			
			
			$('.bg-tabs').tabs();
				
			$('.bg-datepicker').datetimepicker({dateFormat:'yy-mm-dd',timeFormat:'hh:mm'});
			$('.jq-time').timepicker({timeFormat:'hh:mm'});
			
			$(':range').cbg_rangeinput();

			
			$(this).sortable({
				revert:true,
				handle:'.ui-tabs-nav'
			});

			$(this).find('.bg-settings-cont')
			.droppable({
				drop: function(event,ui){
					dropped(ui,this);
				}
			});
			
			$('input.background_external_url').unbind('change').change(function(){
				if( ''==$(this).val() ){
					$('.bg-image-cont[rel='+$(this).attr('rel')+'] img').attr('src', custback_url+'css/images/nobg.jpg' );
				}else{
					$('.bg-image-cont[rel='+$(this).attr('rel')+'] img').attr('src', $(this).val() );
				}
			});
			
			$(this).find('input, textarea, select').change(function(){
				$(this).addClass('modified');
			});			
		});
	});
}
function resize_iframe(){
	jQuery(document).ready(function($) {
		var h1 = $('#bg_frame').contents().find('body').outerHeight();
		var h2 = $('body').height()-$('#bg-sel-top').outerHeight();
		if(h1>h2){
			$('#bg_frame').height( h1 );
		}else{
			$('#bg_frame').height( h2 );
		}	
	});
}
function dlg_helper_selector(id){
	jQuery(document).ready(function($) {
		resize_iframe();
		
		$('.bg-browser-datepicker').datetimepicker({dateFormat:'yy-mm-dd',timeFormat:'hh:mm'});
		$('#btn_apply_filter').unbind('click').click(function(){
			 if($('#bgts').val()!=''){
				 $('#bg_frame').contents().find('body').append('<form id="bg-filter"></form>')
				  .find('#bg-filter')
				  .attr('method', 'post' )
				  .attr('action', $('#bg_url').val() )
				  .attr('target', '_self')
				  .append('<input type="hidden" name="bgts" value="'+$('#bgts').val()+'" />')
				  .submit(); 
				  resize_iframe();			 
			 }
		});	
				
		$('#bg-sel-attach-id').val(id);
		$('#btn_bg_go').unbind('click').click(function(){
			$('#bg_status').addClass('bg-status-loading').html('Please wait, page is loading...');
			var url = $('#bg_url').val();
			$('#bg_frame')
				.attr('src', url )
				.width( $('#bg_frame').parent().width())
				.height($('#bg_frame').parent().height())
				.load(function(){
					$('#bg_frame').contents().unbind('click').click(function(e){
						select_section(e,id);
					});
					$('#bg_status').removeClass('bg-status-loading').html('Page loaded.  Click on the section where you want to apply the background.');
					$('#bg_url').val( document.getElementById("bg_frame").contentWindow.location.href );
					
					resize_iframe();
				});
		});
		
		$('#btn_bg_accept').unbind('click').click(function(){
			$('input[name=background_selector_'+id+']').val( $('#bg_selector').val() ).trigger('change');
			$('#dlg-helper-selector').hide();
			restore_background();
		});
		
		$('#btn_bg_back').unbind('click').click(function(){
			$('#dlg-helper-selector').hide();
			restore_background();
		});
		
		$('#bg_selector').change(function(){
			var val = $(this).val();
			val = val.replace(' ','').toUpperCase();
			if('BODY'==val||'HTML'==val||''==val){
				$('#btn_bg_toggle').hide();
			}else{
				$('#btn_bg_toggle').show();
			}		
		});
		
		$('#btn_bg_toggle').unbind('click').click(function(e){
			if( $('#bg_selector').val()!='' ){
				var s = $('#bg_selector').val();
				$('#bg_frame').contents().find(s)
				 .css('visibility','hidden');
			}
		});
		
		$('#dlg-helper-selector').show();		
	});
}

var bgr = {};

function backup_background(sel){
	var o = jQuery('#bg_frame').contents().find(sel);
	bgr.sel = sel;
	bgr.background_image = o.css('background-image');
	bgr.background_repeat = o.css('background-repeat');
	bgr.background_position = o.css('background-position');
	bgr.background_attachment = o.css('background-attachment');
	bgr.background_color = o.css('background-color');
	bgr.background_size = o.css('background-size');
}

function restore_background(){
	jQuery(document).ready(function($) {
		if(bgr.sel){
			$('#bg_frame').contents().find(bgr.sel)	
			 .css('background-image', bgr.background_image )
			 .css('background-repeat', bgr.background_repeat )
			 .css('background-position', bgr.background_position )
			 .css('background-attachment', bgr.background_attachment )
			 .css('background-color', bgr.background_color )
			 .css('background-size', bgr.background_size )
			 ;
		}
	});
}

function change_background(e,_id,sel){
	jQuery(document).ready(function($) {
		restore_background();
		backup_background(sel);
		
		var id = $('#bg-sel-attach-id').val();
		if( $('#bg_image_'+id).length>0 ){
			var pos = $('select[name=background_position_'+id+']').val();
			if(pos=='x% y%' || pos=='xpos ypos'){
				pos = $('input[name=background_x_'+id+']').val()+' '+$('input[name=background_y_'+id+']').val();
			}
			var color = $('select[name=background_color_'+id+']').val();
			if(color=='custom'){
				color = $('input[name=background_custom_color_'+id+']').val();
			}
			var size = $('select[name=background_size_'+id+']').val();
			if(size=='percentage'||size=='length'){
				size = $('input[name=background_size_width_'+id+']').val()+' '+$('input[name=background_size_height_'+id+']').val();
			}
			var img = $('#bg_image_'+id).val();
			img = img==''?'none':'url("'+img+'")';
			$('#bg_frame').contents().find(sel)
			 .css('background-image', img )
			 .css('background-repeat', $('select[name=background_repeat_'+id+']').val() )
			 .css('background-position',pos)
			 .css('background-attachment', $('select[name=background_attachment_'+id+']').val() )
			 .css('background-color',color)
			 .css('background-size',size)
			 ;
			
		}
	});
}

function get_el_id(el){
	return jQuery(el).attr('id')?'#'+jQuery(el).attr('id'):'';
}

function get_el_class(el){
	var sel = '';
	var classes = jQuery(el).attr('class').split(' ');
	if(classes.length>0){
		jQuery.each(classes,function(i,val){
			if(val.replace(' ','')!='')
			sel = sel+'.'+val;
		})
	}
	return sel;
}

function select_section(e,id){
	jQuery(document).ready(function($) {
		var sel = '';
		$.each(['BODY','HTML'],function(i,val){
			if(e.target.nodeName==val){
				sel = val;
				return false;							
			}	
		});
		if(sel){
			$('#bg_selector').val(sel).change();
			change_background(e,id,sel);
			return true;
		}
		
		sel = $(e.target).attr('id');
		if(sel){
			$('#bg_selector').val('#'+sel).change();
			change_background(e,id,'#'+sel);
			return true;
		}
		
		sel = get_el_class(e.target);
		if(sel){
			$('#bg_selector').val(sel).change();
			change_background(e,id,sel);
			return true;
		}
		
		var p_sel = get_el_id($(e.target).parent())?get_el_id($(e.target).parent()):get_el_class($(e.target).parent());
		if(p_sel){
			sel = p_sel+' '+e.target.nodeName;
			$('#bg_selector').val(sel).change();
			change_background(e,id,'#branding img');
			return true;
		}
		
		$('#bg_selector').val('').change();
	});
}

function file_uploaded( event, queueID, fileObj, response ){
	var data = eval('('+response+')');
	
	if(data.R=='OK'){
		jQuery(document).ready(function($){ 
			load_attachments();
			return true;	
		});	
	}else if(data.R=='ERR'){
		alert(data.MSG);
		return true;
	}else{
		alert('Unknown error');
		return true;
	}
}