<?php
/**
 */


class WPBakeryShortCode_VC_Home_images_posts extends WPBakeryShortCode {

    protected function content( $atts, $content = null ) {
        $title = $grid_teasers_count = $grid_layout = $grid_link = $grid_link_target = '';
        
        $grid_content = $width = $el_position = $isotope_item = '';

        extract(shortcode_atts(array(
            'title' => 'Category title',
			'title_link' => '#',
            'grid_teasers_count' => 4,
			'cat_bg' => 'ff0000',
            'grid_layout' => 'thumbnail_title_text', 
            'grid_link' => 'link_post', 
            'grid_link_target' => '_self',
            'grid_thumb_size' => 'thumbnail',
			'title_style' => 'Modern',
            'grid_posttypes' => '',
            'grid_categories' => '',

            'width' => '1/1',
            'el_position' => ''
        ), $atts));

      

        if ( $grid_link == 'link_image' || $grid_link == 'link_image_post' ) {
            wp_enqueue_script( 'prettyphoto' );
            wp_enqueue_style( 'prettyphoto' );
        }


        $output = '';

        $width = '';//wpb_translateColumnWidthToSpan( $width );
        $li_span_class = wpb_translateColumnsCountToSpanClass( $grid_columns_count );


        $query_args = array();

        $link_target = $grid_link_target=='_blank' ? ' target="_blank"' : '';


      
        // Post teasers count
        if ( $grid_teasers_count != '' && !is_numeric($grid_teasers_count) ) $grid_teasers_count = -1;
        if ( $grid_teasers_count != '' && is_numeric($grid_teasers_count) ) $query_args['posts_per_page'] = $grid_teasers_count;

        // Post types
        $pt = array();
        if ( $grid_posttypes != '' ) {
            $grid_posttypes = explode(",", $grid_posttypes);
            foreach ( $grid_posttypes as $post_type ) {
                array_push($pt, $post_type);
            }
            $query_args['post_type'] = $pt;
        }

        // Narrow by categories
        if ( $grid_categories != '' ) {
            $grid_categories = explode(",", $grid_categories);
            $gc = array();
            foreach ( $grid_categories as $grid_cat ) {
                array_push($gc, $grid_cat);
            }
            $gc = implode(",", $gc);
            ////http://snipplr.com/view/17434/wordpress-get-category-slug/
            $query_args['category_name'] = $gc;

            $taxonomies = get_taxonomies('', 'object');
            $query_args['tax_query'] = array('relation' => 'OR');
            foreach ( $taxonomies as $t ) {
                if ( in_array($t->object_type[0], $pt) ) {
                    $query_args['tax_query'][] = array(
                        'taxonomy' => $t->name,//$t->name,//'portfolio_category',
                        'terms' => $grid_categories,
                        'field' => 'slug',
                    );
                }
            }
        }
      
        // Run query
        $my_query = new WP_Query($query_args);
        //global $_wp_additional_image_sizes;

        $teasers = '';
        $teaser_categories = Array();
       
        $posts_Ids = array();

        while ( $my_query->have_posts() ) {
            $link_title_start = $link_image_start = $p_link = $link_image_end = $p_img_large = '';

            $my_query->the_post();

            $posts_Ids[] = $my_query->post->ID;


            $categories_css = '';

           
            $post_title = the_title("", "", false);
            $post_id = $my_query->post->ID;

            $teaser_post_type = 'posts_grid_teaser_'.$my_query->post->post_type . ' ';
            if($grid_content == 'teaser') {
                $content = apply_filters('the_excerpt', get_the_excerpt());
            } else {
               
            }

            // $content = ( $grid_content == 'teaser' ) ? apply_filters('the_excerpt', get_the_excerpt()) : get_the_content(); //TODO: get_the_content() rewrite more WP native way.
            $content = wpautop($content);
            $link = '';
            $thumbnail = '';

            // Read more link
            if ( $grid_link != 'link_no' ) {
                $link = '<a class="more-link" href="'. get_permalink($post_id) .'"'.$link_target.' title="'. sprintf( esc_attr__( 'Permalink to %s', 'js_composer' ), the_title_attribute( 'echo=0' ) ).'">'. __("Read more", "js_composer") .'</a>';
            }

            // Thumbnail logic
            if ( in_array($grid_layout, array('thumbnail_title_text') ) ) {
                $post_thumbnail = $p_img_large = '';
                //$attach_id = get_post_thumbnail_id($post_id);
                $post_thumbnail = wpb_getImageBySize(array( 'post_id' => $post_id, 'thumb_size' => $grid_thumb_size ));
                $thumbnail = $post_thumbnail['thumbnail'];
                $p_img_large = $post_thumbnail['p_img_large'];
            }

            // Link logic
            if ( $grid_link != 'link_no' ) {
                $p_video = '';
                if ( $grid_link == 'link_image' || $grid_link == 'link_image_post' ) {
                    $p_video = get_post_meta($post_id, "_p_video", true);
                }

                if ( $grid_link == 'link_post' ) {
                    $link_image_start = '<a class="link_image" href="'.get_permalink($post_id).'"'.$link_target.' title="'.sprintf( esc_attr__( 'Permalink to %s', 'js_composer' ), the_title_attribute( 'echo=0' ) ).'">';
                    $link_title_start = '<a class="link_title tip" href="'.get_permalink($post_id).'"'.$link_target.' title="'.sprintf( esc_attr__( '%s', 'js_composer' ), the_title_attribute( 'echo=0' ) ).'">';
                }
                else if ( $grid_link == 'link_image' ) {
                    if ( $p_video != "" ) {
                        $p_link = $p_video;
                    } else {
                        $p_link = $p_img_large[0];
                    }
                    $link_image_start = '<a class="link_image prettyphoto" href="'.$p_link.'"'.$link_target.' title="'.the_title_attribute('echo=0').'">';
                    $link_title_start = '<a class="link_title prettyphoto" href="'.$p_link.'"'.$link_target.' title="'.the_title_attribute('echo=0').'">';
                }
                else if ( $grid_link == 'link_image_post' ) {
                    if ( $p_video != "" ) {
                        $p_link = $p_video;
                    } else {
                        $p_link = $p_img_large[0];
                    }
                    $link_image_start = '<a class="link_image prettyphoto" href="'.$p_link.'"'.$link_target.' title="'.the_title_attribute('echo=0').'">';
                    $link_title_start = '<a class="link_title" href="'.get_permalink($post_id).'"'.$link_target.' title="'.sprintf( esc_attr__( 'Permalink to %s', 'js_composer' ), the_title_attribute( 'echo=0' ) ).'">';
                }
                $link_title_end = $link_image_end = '</a>';
            } else {
                $link_image_start = '';
                $link_title_start = '';
                $link_title_end = $link_image_end = '';
            }


			// If format post
	            $format = get_post_format(); if ( false === $format ) {  
				
	            $post_format = '<div class="post_format"></div>';
				  
                }
				
			// If format video
				if(has_post_format('video')) { 
				
			    $post_format = '<div class="post_format_video"></div>';

		        } 


			// If format image
				if(has_post_format('image')) {
				
				$post_format = '<div class="post_format_image"></div>';
				
                } 
				
			// If format audio
				if(has_post_format('audio')) {
				
				$post_format = '<div class="post_format_audio"></div>';
				
                } 
			
		   $teasers .= '<div class="images_post">';
            // If grid layout is: Thumbnail + Title + Text
            if ( $grid_layout == 'thumbnail_title_text' ) {
                if ( $thumbnail ) {

				    $src = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), 'post-thumbnails', false, '' ); $thumbnailSrc = $src[0];	
		            $image = aq_resize( $thumbnailSrc, 430, 430, true); 
				
                    $to_filter =  ''  . $link_title_start  . '<div class="mediaholder_image_box"><img src="'. $image .'" alt="'.$post_title.'" style="border-color: '.$cat_bg.';" /></div>' . $link_title_end . $post_format . '

					';
                    $teasers .= apply_filters('vc_teaser_grid_thumbnail', $to_filter, array("grid_layout" => $grid_layout, "ID" => $post_id, "thumbnail" => $thumbnail, "media_link" => $p_link) );
			}
				
				global $post;
               
                if ( $post_title ) 	{
                    $to_filter = ' ';
                    $teasers .= apply_filters('vc_teaser_grid_title', $to_filter, array() );
                }
              
				$post_time = get_the_time('F d') .'';  
                $to_filter = '<div class="home_posts_time" style="background: '.$cat_bg.';">' . $post_time .'</div>';
                $teasers .= apply_filters('vc_teaser_post_meta_line', $to_filter, array("grid_layout" => $grid_layout, "ID" => $post_id, "content" => $content, "media_link" => $p_link));

            }
  
            $teasers .= '</div>' . $this->endBlockComment('image_masonry_post');
		
		
        } // endwhile loop
        wp_reset_query();

       
        if ( $teasers ) { $teasers = $categories_list_output.'
		
	    '. $teasers .'
	    '; }
	
        else { $teasers = __("Nothing found." , "js_composer"); }

        $posttypes_teasers = '';

        if ( is_array($grid_posttypes) ) {
            //$posttypes_teasers_ar = explode(",", $grid_posttypes);
            $posttypes_teasers_ar = $grid_posttypes;
            foreach ( $posttypes_teasers_ar as $post_type ) {
                $posttypes_teasers .= 'wpb_teaser_grid_'.$post_type . ' ';
            }
        }
		
		$cat_desc = category_description( get_category_by_slug(''.$grid_cat.'')->term_id );
		
		$output .= ($title != '' ) ? "\n\t\t\t".'<div class="wpb_animate_when_almost_visible wpb_bottom-to-top vc_align_left">
		<div class="home_posts_title '.$title_style.'"><h2><a href="'. $title_link .'" style="color: '.$cat_bg.';">'.$title.'</a></h2> </div> 
		<div class="car_title_descr" style="border-color: '.$cat_bg.';">'.$cat_desc.'</div>
		<div class="clear"></div>' : '';
		$output .= "\n\t\t".'<div id="home_images_posts">';
       
		$output .= $teasers;
        $output .= "\n\t\t".'</div></div>'.$this->endBlockComment('.home_posts_container');

        $output = $this->startRow($el_position) . $output . $this->endRow($el_position);
        return $output;
    }
}