<?php
if (!class_exists('TS_Lightbox_Galleries')){
	class TS_Lightbox_Galleries {
		function __construct() {
            if (function_exists('vc_is_inline')){
                if (vc_is_inline()) {
                    add_action('init',                              	array($this, 'TS_VCSC_Add_Lightbox_Gallery_Elements'), 9999999);
                } else {
                    add_action('admin_init',		                	array($this, 'TS_VCSC_Add_Lightbox_Gallery_Elements'), 9999999);
                }
            } else {
                add_action('admin_init',								array($this, 'TS_VCSC_Add_Lightbox_Gallery_Elements'), 9999999);
            }
			add_shortcode('TS_VCSC_Lightbox_Gallery',          			array($this, 'TS_VCSC_Lightbox_Gallery_Standalone'));
		}
        
		// Standalone Teaser Block
		function TS_VCSC_Lightbox_Gallery_Standalone ($atts) {
			global $VISUAL_COMPOSER_EXTENSIONS;
			ob_start();
			
			if ((get_option('ts_vcsc_extend_settings_loadHeader', 0) == 0)) {
				$FOOTER = true;
			} else {
				$FOOTER = false;
			}
			
			wp_enqueue_script('ts-extend-hammer', 								TS_VCSC_GetResourceURL('js/jquery.hammer.min.js'), array('jquery'), false, $FOOTER);
			wp_enqueue_script('ts-extend-nacho', 								TS_VCSC_GetResourceURL('js/jquery.nchlightbox.min.js'), array('jquery'), false, $FOOTER);
			wp_enqueue_style('ts-extend-nacho',									TS_VCSC_GetResourceURL('css/jquery.nchlightbox.min.css'), null, false, 'all');
			wp_enqueue_style('ts-extend-owlcarousel',				        	TS_VCSC_GetResourceURL('css/jquery.owl.carousel.css'), null, false, 'all');
			wp_enqueue_script('ts-extend-owlcarousel',			            	TS_VCSC_GetResourceURL('js/jquery.owl.carousel.min.js'), array('jquery'), false, $FOOTER);
			if (get_option('ts_vcsc_extend_settings_loadForcable', 0) == 0) {
				wp_enqueue_style('ts-extend-simptip',                 			TS_VCSC_GetResourceURL('css/jquery.simptip.css'), null, false, 'all');
				wp_enqueue_style('ts-extend-animations',                 		TS_VCSC_GetResourceURL('css/ts-visual-composer-extend-animations.min.css'), null, false, 'all');
				wp_enqueue_style('ts-visual-composer-extend-front',				TS_VCSC_GetResourceURL('css/ts-visual-composer-extend-front.min.css'), null, false, 'all');
				wp_enqueue_script('ts-visual-composer-extend-front',			TS_VCSC_GetResourceURL('js/ts-visual-composer-extend-front.min.js'), array('jquery'), false, $FOOTER);
			}
			
			extract( shortcode_atts( array(
				'content_style'				=> 'grid',
				'content_title'				=> '',
				'content_trigger_image'		=> '',
				'content_trigger_title'		=> '',
	
				'content_images'			=> '',
				'content_images_titles'		=> '',
				'content_images_size'		=> 'medium',
				
				'thumbnail_position'		=> 'bottom',
				'thumbnail_height'			=> 100,
				
				'lightbox_size'				=> 'full',
				'lightbox_effect'			=> 'random',
				'lightbox_pageload'			=> 'false',
				'lightbox_autoplay'			=> 'false',
				'lightbox_speed'			=> 5000,
				'lightbox_social'			=> 'true',
				
				'lightbox_backlight'		=> 'auto',
				'lightbox_backlight_auto'	=> 'true',
				'lightbox_backlight_color'	=> '#ffffff',
				
				'data_grid_breaks'			=> '240,480,720,960',
				'data_grid_space'			=> 2,
				'data_grid_order'			=> 'false',
	
				'number_images'				=> 1,
				'auto_height'				=> 'true',
				'auto_play'					=> 'false',
				'show_bar'					=> 'true',
				'bar_color'					=> '#dd3333',
				'show_speed'				=> 5000,
				'stop_hover'				=> 'true',
				'show_navigation'			=> 'true',
				'page_numbers'				=> 'false',
				'transitions'				=> 'backSlide',
				
				'margin_top'				=> 0,
				'margin_bottom'				=> 0,
				'el_id'						=> '',
				'el_class'					=> '',
			), $atts ));
	
			$randomizer						= mt_rand(999999, 9999999);
		
			if (!empty($el_id)) {
				$modal_id					= $el_id;
				$nacho_group				= 'nachogroup' . $randomizer;
			} else {
				$modal_id					= 'ts-vcsc-image-gallery-' . $randomizer;
				$nacho_group				= 'nachogroup' . $randomizer;
			}
			
			// Content: Gallery
			$modal_gallery					= '';
			if (!empty($content_images)) {
				$count_images 				= substr_count($content_images, ",") + 1;
			} else {
				$count_images				= 0;
			}
			if (!empty($data_grid_breaks)) {
				$data_grid_breaks 			= str_replace(' ', '', $data_grid_breaks);
				$count_columns				= substr_count($data_grid_breaks, ",") + 1;
			} else {
				$count_columns				= 0;
			}
			$content_images 				= explode(',', $content_images);
			$content_images_titles			= explode(',', $content_images_titles);
			$i 								= -1;
			$b								= 0;
			$output 						= '';
			
			$content_style 					= strtolower($content_style);
	
			$nachoLength 					= count($content_images) - 1;
			if (!empty($content)) {
				$nacho_info 				= 'data-info="' . $nacho_group . '-info"';
			} else {
				$nacho_info					= '';
			}
			if ($lightbox_backlight != "auto") {
				if ($lightbox_backlight == "custom") {
					$nacho_color			= 'data-color="' . $lightbox_backlight_color . '"';
				} else if ($lightbox_backlight == "hideit") {
					$nacho_color			= 'data-color="#000000"';
				}
			} else {
				$nacho_color			= '';
			}
			
			// Auto-Grid Layout
			if ($content_style == "grid") {
				foreach ($content_images as $single_image) {
					$i++;
					$modal_image			= wp_get_attachment_image_src($single_image, $lightbox_size);
					$image_extension		= pathinfo($modal_image[0], PATHINFO_EXTENSION);
					$modal_thumb			= preg_replace('/[^\d]/', '', $single_image);
					$modal_thumb			= wpb_getImageBySize(array( 'attach_id' => $modal_thumb, 'thumb_size' => $content_images_size, 'class' => '' ));
					if ($i == $nachoLength) {
						if ($count_images < $count_columns) {
							$data_grid_string	= explode(',', $data_grid_breaks);
							$data_grid_breaks	= array();
							foreach ($data_grid_string as $single_break) {
								$b++;
								if ($b <= $count_images) {
									array_push($data_grid_breaks, $single_break);
								} else {
									break;
								}
							}
							$data_grid_breaks	= implode(",", $data_grid_breaks);
						} else {
							$data_grid_breaks 	= $data_grid_breaks;
						}
						$modal_gallery .= '<a id="' . $nacho_group . '-' . $i .'" href="' . $modal_image[0] . '" data-title="' . (!empty($content_images_titles[$i]) ? $content_images_titles[$i] : "") . '" class="nch-lightbox-media ts-hover-image ' . $nacho_group . '" rel="' . $nacho_group . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-autoplay="' . ($lightbox_autoplay == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" data-thumbsize="' . $thumbnail_height . '" data-thumbs="' . $thumbnail_position . '" ' . $nacho_info . ' ' . $nacho_color . ' data-grid="' . $data_grid_breaks . '" data-gridspace="' . $data_grid_space . '">';
							$modal_gallery .= $modal_thumb['thumbnail'];
						$modal_gallery .= '</a>';
					} else {
						$modal_gallery .= '<a id="' . $nacho_group . '-' . $i .'" href="' . $modal_image[0] . '" data-title="' . (!empty($content_images_titles[$i]) ? $content_images_titles[$i] : "") . '" class="nch-lightbox-media ts-hover-image ' . $nacho_group . '" rel="' . $nacho_group . '" data-effect="' . $lightbox_effect . '" ' . $nacho_color . '>';
							$modal_gallery .= $modal_thumb['thumbnail'];
						$modal_gallery .= '</a>';
					}
				}
	
				?>
					<script type="text/javascript">
						jQuery(window).load(function(){
							jQuery('#<?php echo $modal_id; ?>-frame a').nchgrid({
								order:		<?php echo $data_grid_order; ?>,
							});
							<?php if ($lightbox_pageload == "true") { ?>
								jQuery('.<?php echo $nacho_group; ?>').nchlightbox('open');
							<?php } ?>
						});
					</script>
				<?php
			}
			// First Image Only Layout
			if ($content_style == "first") {
				foreach ($content_images as $single_image) {
					$i++;
					$modal_image			= wp_get_attachment_image_src($single_image, $lightbox_size);
					$image_extension		= pathinfo($modal_image[0], PATHINFO_EXTENSION);
					$modal_thumb			= preg_replace('/[^\d]/', '', $single_image);
					if ($i == 0) {
						$modal_thumb		= wpb_getImageBySize(array( 'attach_id' => $modal_thumb, 'thumb_size' => $content_images_size, 'class' => 'nachocover' ));
					} else {
						$modal_thumb		= wpb_getImageBySize(array( 'attach_id' => $modal_thumb, 'thumb_size' => $content_images_size, 'class' => 'nachohidden' ));
					}
					if (($i == 0) || ($nachoLength == 0)) {
						$modal_gallery .= '<div class="nchgrid-item nchgrid-tile nch-lightbox-trigger" style="">';
							$modal_gallery .= '<a id="' . $nacho_group . '-' . $i .'" href="' . $modal_image[0] . '" class="nch-lightbox-media" data-title="' . (!empty($content_images_titles[$i]) ? $content_images_titles[$i] : "") . '" rel="' . $nacho_group . '" data-effect="' . $lightbox_effect . '">';
								$modal_gallery .= $modal_thumb['thumbnail'];
								$modal_gallery .= '<div class="nchgrid-caption"></div>';
								if (!empty($content_images_titles[$i])) {
									$modal_gallery .= '<div class="nchgrid-caption-text">' . (!empty($content_images_titles[$i]) ? $content_images_titles[$i] : "") . '</div>';
								}
							$modal_gallery .= '</a>';
						$modal_gallery .= '</div>';
					} else if ($i == $nachoLength) {
						$modal_gallery .= '<a id="' . $nacho_group . '-' . $i .'" style="display: none;" href="' . $modal_image[0] . '" data-title="' . (!empty($content_images_titles[$i]) ? $content_images_titles[$i] : "") . '" class="nch-lightbox-media ts-hover-image ' . $nacho_group . '" rel="' . $nacho_group . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-autoplay="' . ($lightbox_autoplay == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" data-thumbsize="' . $thumbnail_height . '" data-thumbs="' . $thumbnail_position . '" ' . $nacho_info . ' ' . $nacho_color . '>';
							if ($thumbnail_position != "0") {
								$modal_gallery .= $modal_thumb['thumbnail'];
							} else {
								$modal_gallery .= 'Lightbox Image #' . ($i + 1);
							}
						$modal_gallery .= '</a>';
					} else {
						$modal_gallery .= '<a id="' . $nacho_group . '-' . $i .'" style="display: none;" href="' . $modal_image[0] . '" data-title="' . (!empty($content_images_titles[$i]) ? $content_images_titles[$i] : "") . '" class="nch-lightbox-media ts-hover-image ' . $nacho_group . '" rel="' . $nacho_group . '" data-effect="' . $lightbox_effect . '" ' . $nacho_color . '>';
							if ($thumbnail_position != "0") {
								$modal_gallery .= $modal_thumb['thumbnail'];
							} else {
								$modal_gallery .= 'Lightbox Image #' . ($i + 1);
							}
						$modal_gallery .= '</a>';
					}
				}
				
				?>
					<script type="text/javascript">
						jQuery(window).load(function(){
							<?php if ($lightbox_pageload == "true") { ?>
								jQuery('.<?php echo $nacho_group; ?>').nchlightbox('open');
							<?php } ?>
						});
					</script>
				<?php
			}
			// Custom Image Layout
			if ($content_style == "image") {
				if (!empty($content_trigger_image)) {
					$trigger_thumb 					= wp_get_attachment_image_src($content_trigger_image, 'large');
					$modal_gallery .= '<div class="nchgrid-item nchgrid-tile nch-lightbox-trigger" style="">';
						$modal_gallery .= '<a href="#" class="nch-lightbox-trigger" data-title="' . (!empty($content_trigger_title) ? $content_trigger_title : "") . '" data-group="' . $nacho_group . '">';
							$modal_gallery .= '<img src="' . $trigger_thumb[0] . '" alt="" title="" style="">';
							$modal_gallery .= '<div class="nchgrid-caption"></div>';
							if (!empty($content_trigger_title)) {
								$modal_gallery .= '<div class="nchgrid-caption-text">' . (!empty($content_trigger_title) ? $content_trigger_title : "") . '</div>';
							}
						$modal_gallery .= '</a>';
					$modal_gallery .= '</div>';
					
					foreach ($content_images as $single_image) {
						$i++;
						$modal_image			= wp_get_attachment_image_src($single_image, $lightbox_size);
						$image_extension		= pathinfo($modal_image[0], PATHINFO_EXTENSION);
						$modal_thumb			= preg_replace('/[^\d]/', '', $single_image);
						$modal_thumb			= wpb_getImageBySize(array( 'attach_id' => $modal_thumb, 'thumb_size' => $content_images_size, 'class' => 'nachohidden' ));
						if ($i == $nachoLength) {
							$modal_gallery .= '<a id="' . $nacho_group . '-' . $i .'" style="display: none;" href="' . $modal_image[0] . '" data-title="' . (!empty($content_images_titles[$i]) ? $content_images_titles[$i] : "") . '" class="nch-lightbox-media ts-hover-image ' . $nacho_group . '" rel="' . $nacho_group . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-autoplay="' . ($lightbox_autoplay == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" data-thumbsize="' . $thumbnail_height . '" data-thumbs="' . $thumbnail_position . '" ' . $nacho_info . ' ' . $nacho_color . '>';
								if ($thumbnail_position != "0") {
									$modal_gallery .= $modal_thumb['thumbnail'];
								} else {
									$modal_gallery .= 'Lightbox Image #' . ($i + 1);
								}
							$modal_gallery .= '</a>';
						} else {
							$modal_gallery .= '<a id="' . $nacho_group . '-' . $i .'" style="display: none;" href="' . $modal_image[0] . '" data-title="' . (!empty($content_images_titles[$i]) ? $content_images_titles[$i] : "") . '" class="nch-lightbox-media ts-hover-image ' . $nacho_group . '" rel="' . $nacho_group . '" data-effect="' . $lightbox_effect . '" ' . $nacho_color . '>';
								if ($thumbnail_position != "0") {
									$modal_gallery .= $modal_thumb['thumbnail'];
								} else {
									$modal_gallery .= 'Lightbox Image #' . ($i + 1);
								}
							$modal_gallery .= '</a>';
						}
					}
					
					?>
						<script type="text/javascript">
							jQuery(window).load(function(){
								<?php if ($lightbox_pageload == "true") { ?>
									jQuery('.<?php echo $nacho_group; ?>').nchlightbox('open');
								<?php } ?>
							});
						</script>
					<?php
				}
			}
			// Slider Layout
			if ($content_style == "slider") {
				$modal_gallery .= '<div id="ts-lightbox-gallery-slider-' . $randomizer . '" class="ts-lightbox-gallery-slider owl-carousel" data-id="' . $randomizer . '" data-images="' . $number_images . '" data-navigation="' . $show_navigation . '" data-transitions="' . $transitions . '" data-height="' . $auto_height . '" data-play="' . $auto_play . '" data-bar="' . $show_bar . '" data-color="' . $bar_color . '" data-speed="' . $show_speed . '" data-hover="' . $stop_hover . '" data-numbers="' . $page_numbers . '">';
					foreach ($content_images as $single_image) {
						$i++;
						$modal_image			= wp_get_attachment_image_src($single_image, $lightbox_size);
						$image_extension		= pathinfo($modal_image[0], PATHINFO_EXTENSION);
						if ($i == $nachoLength) {
							$data_grid_breaks 	= str_replace(' ', '', $data_grid_breaks);
							$modal_gallery .= '<div id="' . $nacho_group . '-' . $i .'-parent" class="' . $nacho_group . '-parent ' . $el_class . ' nchgrid-item nchgrid-tile nch-lightbox-image" style="">';
								$modal_gallery .= '<a id="' . $nacho_group . '-' . $i .'" href="' . $modal_image[0] . '" data-title="' . (!empty($content_images_titles[$i]) ? $content_images_titles[$i] : "") . '" class="nch-lightbox-media ts-hover-image ' . $nacho_group . '" rel="' . $nacho_group . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-autoplay="' . ($lightbox_autoplay == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" data-thumbsize="' . $thumbnail_height . '" data-thumbs="' . $thumbnail_position . '" ' . $nacho_info . ' ' . $nacho_color . '>';
									$modal_gallery .= '<img src="' . $modal_image[0] . '" style="">';
									$modal_gallery .= '<div class="nchgrid-caption"></div>';
									if (!empty($content_images_titles[$i])) {
										$modal_gallery .= '<div class="nchgrid-caption-text">' . $content_images_titles[$i] . '</div>';
									}
								$modal_gallery .= '</a>';
							$modal_gallery .= '</div>';
						} else {
							$modal_gallery .= '<div id="' . $nacho_group . '-' . $i .'-parent" class="' . $nacho_group . '-parent ' . $el_class . ' nchgrid-item nchgrid-tile nch-lightbox-image" style="">';
								$modal_gallery .= '<a id="' . $nacho_group . '-' . $i .'" href="' . $modal_image[0] . '" data-title="' . (!empty($content_images_titles[$i]) ? $content_images_titles[$i] : "") . '" class="nch-lightbox-media ts-hover-image ' . $nacho_group . '" rel="' . $nacho_group . '" data-effect="' . $lightbox_effect . '" ' . $nacho_color . '>';
									$modal_gallery .= '<img src="' . $modal_image[0] . '" style="">';
									$modal_gallery .= '<div class="nchgrid-caption"></div>';
									if (!empty($content_images_titles[$i])) {
										$modal_gallery .= '<div class="nchgrid-caption-text">' . $content_images_titles[$i] . '</div>';
									}
								$modal_gallery .= '</a>';
							$modal_gallery .= '</div>';
						}
					}
				$modal_gallery .= '</div>';
				?>
					<script type="text/javascript">
						jQuery(window).load(function(){
							<?php if ($lightbox_pageload == "true") { ?>
								jQuery('.<?php echo $nacho_group; ?>').nchlightbox('open');
							<?php } ?>
						});
					</script>
				<?php
			}
			
			$output .= '<div id="' . $modal_id . '-frame" class="ts-lightbox-nacho-frame" style="margin-top: '  . $margin_top . 'px; margin-bottom: ' . $margin_bottom . 'px;">';
				if (!empty($content_title)) {
					$output .= '<div id="' . $nacho_group . '-title" class="ts-lightbox-nacho-title">' . $content_title. '</div>';
				}
				if (!empty($content)) {
					$output .= '<div id="' . $nacho_group . '-info" class="ts-lightbox-nacho-info nch-hide-if-javascript">';
						if (function_exists('wpb_js_remove_wpautop')){
							$output .= wpb_js_remove_wpautop(do_shortcode($content), true);
						} else {
							$output .= do_shortcode($content);
						}
					$output .= '</div>';
				}
				$output .= $modal_gallery;
			$output .= '</div>';
	
			echo $output;
		
			$myvariable = ob_get_clean();
			return $myvariable;
		}
		
		// Add Lightbox Gallery Elements
        function TS_VCSC_Add_Lightbox_Gallery_Elements() {
			global $VISUAL_COMPOSER_EXTENSIONS;
			if (function_exists('vc_map')) {
				vc_map( array(
					"name"                          => __( "TS Lightbox Gallery", "js_composer" ),
					"base"                          => "TS_VCSC_Lightbox_Gallery",
					"icon" 	                        => "icon-wpb-ts_vcsc_lightbox_gallery",
					"class"                         => "ts_vcsc_main_lightbox_gallery",
					"category"                      => __( 'VC Extensions', 'js_composer' ),
					"description"                   => __("Place multiple images in a lightbox element", "js_composer"),
					"admin_enqueue_js"              => "",
					"admin_enqueue_css"             => "",
					"params"                        => array(
						// Gallery Content
						array(
							"type"                  => "seperator",
							"heading"               => __( "", "js_composer" ),
							"param_name"            => "seperator_1",
							"value"                 => "Gallery Content",
							"description"           => __( "", "js_composer" )
						),
						array(
							"type"                  => "attach_images",
							"heading"               => __( "Select Images", "js_composer" ),
							"param_name"            => "content_images",
							"value"                 => "",
							"admin_label"           => true,
							"description"           => __( "Select the images for your gallery overlay; move images to arrange order in which to display.", "js_composer" ),
							"dependency"            => array( 'element' => "content_type", 'value' => 'gallery' )
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Preview Image Source", "js_composer" ),
							"param_name"            => "content_images_size",
							"width"                 => 150,
							"holder"				=> "custom",
							"value"                 => array(
								__( 'Medium Size Image', "js_composer" )		=> "medium",
								__( 'Large Size Image', "js_composer" )			=> "large",
								__( 'Full Size Image', "js_composer" )			=> "full",
							),
							"admin_label"           => false,
							"description"           => __( "Select which image size based on WordPress settings should be used for the preview image.", "js_composer" ),
							"dependency"            => ""
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Lightbox Image Source", "js_composer" ),
							"param_name"            => "lightbox_size",
							"width"                 => 150,
							"holder"				=> "custom",
							"value"                 => array(
								__( 'Full Size Image', "js_composer" )			=> "full",
								__( 'Large Size Image', "js_composer" )			=> "large",
								__( 'Medium Size Image', "js_composer" )		=> "medium",
							),
							"admin_label"           => false,
							"description"           => __( "Select which image size based on WordPress settings should be used for the lightbox image.", "js_composer" ),
							"dependency"            => ""
						),
						array(
							"type"                  => "exploded_textarea",
							"heading"               => __( "Image Titles", "js_composer" ),
							"param_name"            => "content_images_titles",
							"value"                 => "",
							"description"           => __( "Enter titles for images; seperate by line break; use an empty line for image without title.", "js_composer" ),
							"dependency"            => ""
						),
						// Gallery Info
						array(
							"type"                  => "textfield",
							"heading"               => __( "Gallery Title", "js_composer" ),
							"holder"                => "div",
							"param_name"            => "content_title",
							"value"                 => "",
							"description"           => __( "Enter a title for the gallery itself; leave empty if you don't want to show a title.", "js_composer" ),
							"group" 				=> "Gallery Info",
						),
						array(
							"type"		            => "textarea_html",
							"class"		            => "",
							"heading"               => __( "Gallery Description", 'js_composer' ),
							"param_name"            => "content",
							"value"                 => "",
							"admin_label"           => false,
							"description"           => __( "Create a detailed description / summary for the gallery.", "js_composer" ),
							"dependency"            => "",
							"group" 				=> "Gallery Info",
						),
						// Display Settings
						array(
							"type"                  => "seperator",
							"heading"               => __( "", "js_composer" ),
							"param_name"            => "seperator_2",
							"value"                 => "Display Settings",
							"description"           => __( "", "js_composer" )
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Display Style", "js_composer" ),
							"param_name"            => "content_style",
							"width"                 => 150,
							"holder"				=> "custom",
							"value"                 => array(
								__( 'Auto Grid of all Images', "js_composer" )		=> "Grid",
								__( 'First Image Only', "js_composer" )				=> "First",
								__( 'Single Custom Image', "js_composer" )			=> "Image",
								__( 'Image Slider', "js_composer" )					=> "Slider",
							),
							"admin_label"           => false,
							"description"           => __( "Select how the lightbox should be previewed on your page.", "js_composer" ),
							"dependency"            => ""
						),
						// Image Settings
						array(
							"type"                  => "attach_image",
							"heading"               => __( "Select Image", "js_composer" ),
							"param_name"            => "content_trigger_image",
							"value"                 => "",
							"description"           => __( "Select the trigger image for lightbox gallery.", "js_composer" ),
							"dependency"            => array( 'element' => "content_style", 'value' => 'Image' )
						),
						array(
							"type"                  => "textfield",
							"heading"               => __( "Enter TITLE Attribute", "js_composer" ),
							"param_name"            => "content_trigger_title",
							"value"                 => "",
							"description"           => __( "Enter a title for the image that triggers the lightbox.", "js_composer" ),
							"dependency"            => array( 'element' => "content_style", 'value' => 'Image' )
						),
						// Grid Settings
						array(
							"type"                  => "textfield",
							"heading"               => __( "Grid Break Points", "js_composer" ),
							"param_name"            => "data_grid_breaks",
							"value"                 => "240,480,720,960",
							"description"           => __( "Define the break points (columns) for the grid based on available screen size; seperate by comma.", "js_composer" ),
							"dependency"            => array( 'element' => "content_style", 'value' => 'Grid' )
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Grid Space", "js_composer" ),
							"param_name"            => "data_grid_space",
							"value"                 => "2",
							"min"                   => "0",
							"max"                   => "20",
							"step"                  => "1",
							"unit"                  => 'px',
							"description"           => __( "Define the space between images in grid.", "js_composer" ),
							"dependency"            => array( 'element' => "content_style", 'value' => 'Grid' )
						),
						array(
							"type"              	=> "switch",
							"heading"			    => __( "Maintain Image Order", "js_composer" ),
							"param_name"		    => "data_grid_order",
							"value"				    => "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"		    => __( "Switch the toggle to keep original image order in grid; it is adviced to have the plugin determine order for best layout.", "js_composer" ),
							"dependency"            => array( 'element' => "content_style", 'value' => 'Grid' )
						),
						// Slider Settings
						array(
							"type"					=> "switch",
							"heading"				=> __( "Auto-Height", "js_composer" ),
							"param_name"			=> "auto_height",
							"value"					=> "true",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"			=> __( "Switch the toggle if you want the slider to auto-adjust its height.", "js_composer" ),
							"dependency"            => array( 'element' => "content_style", 'value' => 'Slider' )
						),
						array(
							"type"					=> "nouislider",
							"heading"				=> __( "Number of Images", "js_composer" ),
							"param_name"			=> "number_images",
							"value"					=> "1",
							"min"					=> "1",
							"max"					=> "10",
							"step"					=> "1",
							"unit"					=> '',
							"description"			=> __( "Define the number of images per slide.", "js_composer" ),
							"dependency"            => array( 'element' => "content_style", 'value' => 'Slider' )
						),
						array(
							"type"              	=> "switch",
							"heading"				=> __( "Auto-Play", "js_composer" ),
							"param_name"			=> "auto_play",
							"value"					=> "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"			=> __( "Switch the toggle if you want the auto-play the slider on page load.", "js_composer" ),
							"dependency"            => array( 'element' => "content_style", 'value' => 'Slider' )
						),
						array(
							"type"					=> "switch",
							"heading"				=> __( "Show Progressbar", "js_composer" ),
							"param_name"			=> "show_bar",
							"value"					=> "true",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"			=> __( "Switch the toggle if you want to show a progressbar during auto-play.", "js_composer" ),
							"dependency"            => array( 'element' => "content_style", 'value' => 'Slider' )
						),
						array(
							"type"					=> "colorpicker",
							"heading"				=> __( "Progressbar Color", "js_composer" ),
							"param_name"			=> "bar_color",
							"value"					=> "#dd3333",
							"description"			=> __( "Define the color of the animated progressbar.", "js_composer" ),
							"dependency"			=> array("element" 	=> "auto_play", "value" 	=> "true"),
						),
						array(
							"type"					=> "nouislider",
							"heading"				=> __( "Auto-Play Speed", "js_composer" ),
							"param_name"			=> "show_speed",
							"value"					=> "5000",
							"min"					=> "1000",
							"max"					=> "20000",
							"step"					=> "100",
							"unit"					=> 'ms',
							"description"			=> __( "Define the speed used to auto-play the slider.", "js_composer" ),
							"dependency"			=> array("element" 	=> "auto_play","value" 	=> "true"),
						),
						array(
							"type"					=> "switch",
							"heading"				=> __( "Stop on Hover", "js_composer" ),
							"param_name"			=> "stop_hover",
							"value"					=> "true",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"			=> __( "Switch the toggle if you want the stop the auto-play while hovering over the slider.", "js_composer" ),
							"dependency"			=> array( 'element' => "auto_play", 'value' => 'true' )
						),
						array(
							"type"					=> "switch",
							"heading"				=> __( "Show Navigation", "js_composer" ),
							"param_name"			=> "show_navigation",
							"value"					=> "true",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"			=> __( "Switch the toggle if you want to show left/right navigation buttons for the slider.", "js_composer" ),
							"dependency"            => array( 'element' => "content_style", 'value' => 'Slider' )
						),
						array(
							"type"					=> "dropdown",
							"heading"				=> __( "Transition", "js_composer" ),
							"param_name"			=> "transitions",
							"width"					=> 150,
							"value"					=> array(
								__( 'Back Slide', "js_composer" )		    => "backSlide",
								__( 'Go Down', "js_composer" )		        => "goDown",
								__( 'Fade Up', "js_composer" )		        => "fadeUp",
								__( 'Simple Fade', "js_composer" )		    => "fade",
							),
							"description"           => __( "Select how to transition between the individual slides.", "js_composer" ),
							"dependency"            => array( 'element' => "content_style", 'value' => 'Slider' )
						),
						// Lightbox Settings
						array(
							"type"                  => "seperator",
							"heading"               => __( "", "js_composer" ),
							"param_name"            => "seperator_3",
							"value"                 => "Lightbox Settings",
							"description"           => __( "", "js_composer" ),
							"group" 				=> "Lightbox Settings",
						),
						array(
							"type"              	=> "switch",
							"heading"			    => __( "Open on Pageload", "js_composer" ),
							"param_name"		    => "lightbox_pageload",
							"value"				    => "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"		    => __( "Switch the toggle if you want automatically open the lightbox gallery on page load.", "js_composer" ),
							"dependency"        	=> "",
							"group" 				=> "Lightbox Settings",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Thumbnail Position", "js_composer" ),
							"param_name"            => "thumbnail_position",
							"width"                 => 150,
							"value"                 => array(
								__( 'Bottom', "js_composer" )       => "bottom",
								__( 'Top', "js_composer" )          => "top",
								__( 'Left', "js_composer" )         => "left",
								__( 'Right', "js_composer" )        => "right",
								__( 'None', "js_composer" )         => "0",
							),
							"description"           => __( "Select the position of the thumbnails in the lightbox.", "js_composer" ),
							"dependency"            => "",
							"group" 				=> "Lightbox Settings",
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Thumbnail Height", "js_composer" ),
							"param_name"            => "thumbnail_height",
							"value"                 => "100",
							"min"                   => "50",
							"max"                   => "200",
							"step"                  => "1",
							"unit"                  => 'px',
							"description"           => __( "Define the height of the thumbnails in the lightbox.", "js_composer" ),
							"dependency"            => array( 'element' => "thumbnail_position", 'value' => array('bottom', 'top', 'left', 'right') ),
							"group" 				=> "Lightbox Settings",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Transition Effect", "js_composer" ),
							"param_name"            => "lightbox_effect",
							"width"                 => 150,
							"value"                 => array(
								__( 'Random', "js_composer" )       => "random",
								__( 'Swipe', "js_composer" )        => "swipe",
								__( 'Fade', "js_composer" )         => "fade",
								__( 'Scale', "js_composer" )        => "scale",
								__( 'Slide Up', "js_composer" )     => "slideUp",
								__( 'Slide Down', "js_composer" )   => "slideDown",
								__( 'Flip', "js_composer" )         => "flip",
								__( 'Skew', "js_composer" )         => "skew",
								__( 'Bounce Up', "js_composer" )    => "bounceUp",
								__( 'Bounce Down', "js_composer" )  => "bounceDown",
								__( 'Break In', "js_composer" )     => "breakIn",
								__( 'Rotate In', "js_composer" )    => "rotateIn",
								__( 'Rotate Out', "js_composer" )   => "rotateOut",
								__( 'Hang Left', "js_composer" )    => "hangLeft",
								__( 'Hang Right', "js_composer" )   => "hangRight",
								__( 'Cycle Up', "js_composer" )     => "cicleUp",
								__( 'Cycle Down', "js_composer" )   => "cicleDown",
								__( 'Zoom In', "js_composer" )      => "zoomIn",
								__( 'Throw In', "js_composer" )     => "throwIn",
								__( 'Fall', "js_composer" )         => "fall",
								__( 'Jump', "js_composer" )         => "jump",
							),
							"description"           => __( "Select the transition effect to be used for each image in the lightbox.", "js_composer" ),
							"dependency"            => "",
							"group" 				=> "Lightbox Settings",
						),
						array(
							"type"              	=> "switch",
							"heading"			    => __( "Autoplay Lightbox", "js_composer" ),
							"param_name"		    => "lightbox_autoplay",
							"value"				    => "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"		    => __( "Switch the toggle if you want start an autoplay of the gallery once opened.", "js_composer" ),
							"dependency"        	=> "",
							"group" 				=> "Lightbox Settings",
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Autoplay Speed", "js_composer" ),
							"param_name"            => "lightbox_speed",
							"value"                 => "5000",
							"min"                   => "1000",
							"max"                   => "20000",
							"step"                  => "100",
							"unit"                  => 'ms',
							"description"           => __( "Define the speed at which autoplay should rotate between images.", "js_composer" ),
							"dependency"            => array( 'element' => "lightbox_autoplay", 'value' => 'true' ),
							"group" 				=> "Lightbox Settings",
						),
						
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Backlight Effect", "js_composer" ),
							"param_name"            => "lightbox_backlight",
							"width"                 => 150,
							"value"                 => array(
								__( 'Auto Color', "js_composer" )       => "auto",
								__( 'Custom Color', "js_composer" )     => "custom",
								__( 'No Backlight', "js_composer" )     => "hideit",
							),
							"description"           => __( "Select the backlight effect for the gallery images.", "js_composer" ),
							"dependency"            => "",
							"group" 				=> "Lightbox Settings",
						),
						array(
							"type"                  => "colorpicker",
							"heading"               => __( "Custom Backlight Color", "js_composer" ),
							"param_name"            => "lightbox_backlight_color",
							"value"                 => "#ffffff",
							"description"           => __( "Define the backlight color for the gallery images.", "js_composer" ),
							"dependency"            => array( 'element' => "lightbox_backlight", 'value' => 'custom' ),
							"group" 				=> "Lightbox Settings",
						),
						array(
							"type"              	=> "switch",
							"heading"			    => __( "Social Share Buttons", "js_composer" ),
							"param_name"		    => "lightbox_social",
							"value"				    => "true",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"		    => __( "Switch the toggle if you want show social share buttons with deeplinking for each image.", "js_composer" ),
							"dependency"        	=> "",
							"group" 				=> "Lightbox Settings",
						),
						// Other Settings
						array(
							"type"                  => "seperator",
							"heading"               => __( "", "js_composer" ),
							"param_name"            => "seperator_4",
							"value"                 => "Other Settings",
							"description"           => __( "", "js_composer" ),
							"group" 				=> "Other Settings",
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Margin Top", "js_composer" ),
							"param_name"            => "margin_top",
							"value"                 => "0",
							"min"                   => "0",
							"max"                   => "200",
							"step"                  => "1",
							"unit"                  => 'px',
							"description"           => __( "", "js_composer" ),
							"group" 				=> "Other Settings",
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Margin Bottom", "js_composer" ),
							"param_name"            => "margin_bottom",
							"value"                 => "0",
							"min"                   => "0",
							"max"                   => "200",
							"step"                  => "1",
							"unit"                  => 'px',
							"description"           => __( "", "js_composer" ),
							"group" 				=> "Other Settings",
						),
						array(
							"type"                  => "textfield",
							"heading"               => __( "Define ID Name", "js_composer" ),
							"param_name"            => "el_id",
							"value"                 => "",
							"description"           => __( "Enter a unique ID name for the image gallery.", "js_composer" ),
							"group" 				=> "Other Settings",
						),
						array(
							"type"                  => "textfield",
							"heading"               => __( "Extra Class Name", "js_composer" ),
							"param_name"            => "el_class",
							"value"                 => "",
							"description"           => __( "Enter a class name for the image gallery.", "js_composer" ),
							"group" 				=> "Other Settings",
						),
						// Load Custom CSS/JS File
						array(
							"type"                  => "load_file",
							"heading"               => __( "", "js_composer" ),
							"param_name"            => "el_file",
							"value"                 => "",
							"file_type"             => "js",
							"file_path"             => "js/ts-visual-composer-extend-element.min.js",
							"description"           => __( "", "js_composer" )
						),
					))
				);
			}
		}
	}
}
// Register Container and Child Shortcode with Visual Composer
if (!class_exists('WPBakeryShortCode')) {
	//require_once "{PATH_TO_JS_COMPOSER}/include/classes/shortcodes/shortcodes.php";
}
if (class_exists('WPBakeryShortCode')) {
	class WPBakeryShortCode_TS_VCSC_Lightbox_Gallery extends WPBakeryShortCode {
		public function singleParamHtmlHolder($param, $value) {
			$output 		= '';
			// Compatibility fixes
			$old_names 		= array('yellow_message', 'blue_message', 'green_message', 'button_green', 'button_grey', 'button_yellow', 'button_blue', 'button_red', 'button_orange');
			$new_names 		= array('alert-block', 'alert-info', 'alert-success', 'btn-success', 'btn', 'btn-info', 'btn-primary', 'btn-danger', 'btn-warning');
			$value 			= str_ireplace($old_names, $new_names, $value);
			//$value 		= __($value, "js_composer");
			//
			$param_name 	= isset($param['param_name']) ? $param['param_name'] : '';
			$heading 		= isset($param['heading']) ? $param['heading'] : '';
			$type 			= isset($param['type']) ? $param['type'] : '';
			$class 			= isset($param['class']) ? $param['class'] : '';
			if (isset($param['holder']) == true && $param['holder'] !== 'hidden') {
				if ($param['holder'] == 'custom') {
					$output .= '' . $heading . ': <span class="wpb_vc_param_value ' . $param_name . ' ' . $type . ' ' . $class . '" data-head="' . $heading . '" name="' . $param_name . '">' . ucfirst($value) . '</span>';
				} else {
					$output .= '<'.$param['holder'].' class="wpb_vc_param_value ' . $param_name . ' ' . $type . ' ' . $class . '" data-head="' . $heading . '" name="' . $param_name . '">' . $value . '</'.$param['holder'].'>';
				}
			}
			if ($param_name == 'content_images') {
				$images_ids = empty($value) ? array() : explode(',', trim($value));
				$output .= '<ul class="attachment-thumbnails'.( empty($images_ids) ? ' image-exists' : '' ).'" data-name="' . $param_name . '">';
				foreach($images_ids as $image) {
					$img = wpb_getImageBySize(array( 'attach_id' => (int)$image, 'thumb_size' => 'thumbnail' ));
					$output .= ( $img ? '<li>'.$img['thumbnail'].'</li>' : '<li><img width="150" height="150" test="'.$image.'" src="' . WPBakeryVisualComposer::getInstance()->assetURL('vc/blank.gif') . '" class="attachment-thumbnail" alt="" title="" /></li>');
				}
				$output .= '</ul>';
				$output .= '<a href="#" class="column_edit_trigger' . ( !empty($images_ids) ? ' image-exists' : '' ) . '">' . __( 'Add or Remove Images', 'js_composer' ) . '</a>';
			}
			return $output;
		}
	}
}
// Initialize "TS Teaser Blocks" Class
if (class_exists('TS_Lightbox_Galleries')) {
	$TS_Lightbox_Galleries = new TS_Lightbox_Galleries;
}