<?php
if (!class_exists('TS_Timelines')){
	class TS_Timelines {
		function __construct() {
            if (function_exists('vc_is_inline')){
                if (vc_is_inline()) {
                    add_action('init',                              	array($this, 'TS_VCSC_Add_Timeline_Elements'), 9999999);
                } else {
                    add_action('admin_init',		                	array($this, 'TS_VCSC_Add_Timeline_Elements'), 9999999);
                }
            } else {
                add_action('admin_init',								array($this, 'TS_VCSC_Add_Timeline_Elements'), 9999999);
            }
			add_shortcode('TS_VCSC_Timeline_Single',          			array($this, 'TS_VCSC_Timeline_Function_Single'));
			add_shortcode('TS_VCSC_Timeline_Break',          			array($this, 'TS_VCSC_Timeline_Function_Break'));
			add_shortcode('TS_VCSC_Timeline_Container',         		array($this, 'TS_VCSC_Timeline_Function_Container'));
		}
		
		// Load Isotope Customization at Page End
		function TS_VCSC_Timeline_Function_Isotope () {
			echo '<script data-cfasync="false" type="text/javascript" src="' . TS_VCSC_GetResourceURL('js/jquery.isotope.custom.min.js') . '"></script>';
		}
		// Timeline Item
		function TS_VCSC_Timeline_Function_Single ($atts, $content = null) {
			global $VISUAL_COMPOSER_EXTENSIONS;
			ob_start();
	
			extract( shortcode_atts( array(
				'full_width'				=> 'false',
				'featured_media'			=> 'none',
				
				'featured_image'			=> '',
				'featured_image_alt'		=> '',
				
				'featured_youtube_url'		=> '',
				'featured_youtube_related'	=> 'false',
				'featured_youtube_play'		=> 'false',
				
				'featured_dailymotion_url'	=> '',
				'featured_dailymotion_play'	=> 'false',
				
				'featured_vimeo_url'		=> '',
				'featured_vimeo_play'		=> 'false',
				
				'featured_media_height'		=> 'height: 100%;',
				'featured_media_width'		=> 100,
				'featured_media_align'		=> 'center',
				
				'link'						=> '',
				'tooltip_css'				=> 'false',
				'tooltip_position'			=> 'ts-simptip-position-top',
				'tooltip_style'				=> '',
				
				'button_align'				=> 'center',
				'button_width'				=> 100,
				'button_type'				=> 'square',
				'button_square'				=> 'ts-button-3d',
				'button_rounded'			=> 'ts-button-3d ts-button-rounded',
				'button_pill'				=> 'ts-button-3d ts-button-pill',
				'button_circle'				=> 'ts-button-3d ts-button-circle',
				'button_size'				=> '',
				'button_wrapper'			=> 'false',
				'button_text'				=> '',
				'button_change'				=> 'false',
				'button_color'				=> '#666666',
				'button_font'				=> 18,
				
				'lightbox_featured'			=> 'true',
				'lightbox_group'			=> 'true',
				'lightbox_group_name'		=> '',
				'lightbox_size'				=> 'full',
				'lightbox_effect'			=> 'random',
				'lightbox_speed'			=> 5000,
				'lightbox_social'			=> 'true',
				'lightbox_backlight'		=> 'auto',
				'lightbox_backlight_color'	=> '#ffffff',
				
				'date_text'					=> '',
				
				'title_text'				=> '',
				'title_align'				=> 'center',
				'title_color'				=> '#7c7979',
				
				'icon'						=> '',
				'icon_color'				=> '#7c7979',

				'el_id' 					=> '',
				'el_class'                  => '',
			), $atts ));
			
			$media_string					= '';
			$output 						= '';
		
			if (!empty($el_id)) {
				$timeline_id				= $el_id;
			} else {
				$timeline_id				= 'ts-vcsc-timeline-item-' . mt_rand(999999, 9999999);
			}
			
			// Media Layout
			if ($featured_media_align == "center") {
				$image_alignment				= "margin: 5px auto; float: none;";
			} else if ($featured_media_align == "left") {
				$image_alignment				= "margin: 5px 0; float: left;";
			} else if ($featured_media_align == "right") {
				$image_alignment				= "margin: 5px 0; float: right;";
			}
			$image_dimensions					= 'width: 100%; height: auto;';
			$parent_dimensions					= 'width: ' . $featured_media_width . '%; ' . $featured_media_height;
			if ($lightbox_backlight == "auto") {
				$nacho_color					= '';
			} else if ($lightbox_backlight == "custom") {
				$nacho_color					= 'data-color="' . $lightbox_backlight_color . '"';
			} else if ($lightbox_backlight == "hideit") {
				$nacho_color					= 'data-color="#000000"';
			}
			// Featured Media: Image
			if ($featured_media == 'image') {
				if (!empty($featured_image)) {
					$media_image 				= wp_get_attachment_image_src($featured_image, 'full');
					$image_extension 			= pathinfo($media_image[0], PATHINFO_EXTENSION);
					if ($featured_image_alt != "") {
						$alt_attribute			= $featured_image_alt;
					} else {
						$alt_attribute			= basename($media_image[0], "." . $image_extension);
					}
					if ($lightbox_featured == "false") {
						$media_string .= '<div class="ts-timeline-media" style="' . $parent_dimensions . '; ' . $image_alignment . '">';
							$media_string .= '<img class="" src="' . $media_image[0] . '" alt="' . $alt_attribute . '" style="max-width: ' . $media_image[1] . 'px; padding: 0; margin: 0 auto; display: block; ' . $image_dimensions . '">';
						$media_string .= '</div>';
					} else {
						$media_string .= '<div class="ts-timeline-media nchgrid-item nchgrid-tile nch-lightbox-image" style="' . $parent_dimensions . '; ' . $image_alignment . '">';
							$media_string .= '<a href="' . $media_image[0] . '" class="nch-lightbox-media" data-title="' . $title_text . '" rel="' . ($lightbox_group == "true" ? "nachogroup" : $lightbox_group_name) . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" ' . $nacho_color . '>';
								$media_string .= '<img src="' . $media_image[0] . '" alt="' . $alt_attribute . '" title="" style="max-width: ' . $media_image[1] . 'px; padding: 0; margin: 0 auto; display: block; ' . $image_dimensions . '">';
								$media_string .= '<div class="nchgrid-caption"></div>';
								if (!empty($title_text)) {
									$media_string .= '<div class="nchgrid-caption-text">' . $title_text . '</div>';
								}
							$media_string .= '</a>';
						$media_string .= '</div>';
					}
				}
			}
			// Featured Media: YouTube
			if (($featured_media == 'youtube_default') || ($featured_media == 'youtube_custom') || ($featured_media == 'youtube_embed')) {
				if (preg_match('~((http|https|ftp|ftps)://|www.)(.+?)~', $featured_youtube_url)) {
					$featured_youtube_url		= $featured_youtube_url;
				} else {
					$featured_youtube_url		= 'https://www.youtube.com/watch?v=' . $featured_youtube_url;
				}
				if ($featured_youtube_play == "true") {
					$video_autoplay				= '?autoplay=1';
				} else {
					$video_autoplay				= '?autoplay=0';
				}
				if ($featured_youtube_related == "true") {
					$video_related				= '&rel=1';
				} else {
					$video_related				= '&rel=0';
				}
				if (($featured_media == 'youtube_default')) {
					$media_image 				= TS_VCSC_VideoImage_Youtube($featured_youtube_url);
					$media_string .= '<div class="nch-holder nchgrid-item nchgrid-tile nch-lightbox-youtube" style="' . $parent_dimensions . '; ' . $image_alignment . '">';
						$media_string .= '<a href="' . $featured_youtube_url . '" class="nch-lightbox-media" data-title="' . $title_text . '" data-related="' . $video_related . '" data-play="' . $video_autoplay . '" data-type="youtube" rel="' . $lightbox_group_name . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" ' . $nacho_color . '>';
							$media_string .= '<img src="' . $media_image . '" title="" style="display: block; ' . $image_dimensions . '">';
							$media_string .= '<div class="nchgrid-caption"></div>';
							if (!empty($title_text)) {
								$media_string .= '<div class="nchgrid-caption-text">' . $title_text . '</div>';
							}
						$media_string .= '</a>';
					$media_string .= '</div>';
				} else if ($featured_media == 'youtube_custom') {
					if (!empty($featured_image)) {
						$media_image			= wp_get_attachment_image_src($featured_image, 'full');
						$media_image			= $media_image[0];
						$image_extension		= pathinfo($media_image, PATHINFO_EXTENSION);
						if ($featured_image_alt != "") {
							$alt_attribute		= $featured_image_alt;
						} else {
							$alt_attribute		= basename($media_image, "." . $image_extension);
						}
					} else {
						$media_image			= TS_VCSC_GetResourceURL('images/Default_Youtube.jpg');
						$image_extension		= pathinfo($media_image, PATHINFO_EXTENSION);
						if ($featured_image_alt != "") {
							$alt_attribute		= $featured_image_alt;
						} else {
							$alt_attribute		= basename($media_image, "." . $image_extension);
						}
					}
					$media_string .= '<div class="nch-holder nchgrid-item nchgrid-tile nch-lightbox-youtube" style="' . $parent_dimensions . '; ' . $image_alignment . '">';
						$media_string .= '<a href="' . $featured_youtube_url . '" class="nch-lightbox-media" data-title="' . $title_text . '" data-related="' . $video_related . '" data-play="' . $video_autoplay . '" data-type="youtube" rel="' . $lightbox_group_name . '" data-effect="' . $lightbox_effect . '" data-share="' . ($lightbox_social == "true" ? 1 : 0) . '" data-duration="' . $lightbox_speed . '" ' . $nacho_color . '>';
							$media_string .= '<img src="' . $media_image . '" title="" style="display: block; ' . $image_dimensions . '">';
							$media_string .= '<div class="nchgrid-caption"></div>';
							if (!empty($title_text)) {
								$media_string .= '<div class="nchgrid-caption-text">' . $title_text . '</div>';
							}
						$media_string .= '</a>';
					$media_string .= '</div>';
				} else if ($featured_media == 'youtube_embed') {
					$video_id 					= TS_VCSC_VideoID_Youtube($featured_youtube_url);
					$media_string .= '<div class="ts-video-container" style="' . $parent_dimensions . '; ' . $image_alignment . '">';
						$media_string .= '<iframe width="100%" height="auto" src="//www.youtube.com/embed/' . $video_id . $video_autoplay . $video_related . '&wmode=opaque" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>';
					$media_string .= '</div>';
				}
			}
			// Featured Media: DailyMotion
			if (($featured_media == 'dailymotion_default') || ($featured_media == 'dailymotion_custom') || ($featured_media == 'dailymotion_embed')) {
				
			}
			// Featured Media: Vimeo
			if (($featured_media == 'vimeo_default') || ($featured_media == 'vimeo_custom') || ($featured_media == 'vimeo_embed')) {
				
			}
			
			// Link Button
			if (!empty($link)) {
				// Link Values
				$link 							= ($link=='||') ? '' : $link;
				$link 							= vc_build_link($link);
				$a_href							= $link['url'];
				$a_title 						= $link['title'];
				$a_target 						= $link['target'];
				// Tooltip
				if ($tooltip_css == "true") {
					if (strlen($a_title) != 0) {
						$button_tooltipclasses	= " ts-simptip-multiline " . $tooltip_style . " " . $tooltip_position;
						$button_tooltipcontent	= ' data-tooltip="' . $a_title . '"';
					} else {
						$button_tooltipclasses	= "";
						$button_tooltipcontent	= "";
					}
				} else {
					$button_tooltipclasses		= "";
					if (strlen($a_title) != 0) {
						$button_tooltipcontent	= ' title="' . $a_title . '"';
					} else {
						$button_tooltipcontent	= "";
					}
				}
				// Button Type
				if ($button_type == "square") {
					$button_style				= $button_square;
					$button_font				= '';
				} else if ($button_type == "rounded") {
					$button_style				= $button_rounded;
					$button_font				= '';
				} else if ($button_type == "pill"){
					$button_style				= $button_pill;
					$button_font				= '';
				} else if ($button_type == "circle") {
					$button_style				= $button_circle;
					$button_font				= 'font-size: ' . $button_font . 'px;';
				}
				// Button Alignment
				if ($button_align == "center") {
					$button_align				= 'text-align: center;';
				} else if ($button_align == "left") {
					$button_align				= 'text-align: left';
				} else if ($button_align == "right") {
					$button_align				= 'text-align: right';
				}
				// Button Text Color
				if ($button_change == "true") {
					$button_color				= 'color: ' . $button_color . ';';
				} else {
					$button_color				= '';
				}
				$button_string					= '';
				
				if (!empty($a_href)) {
					$button_string .= '<div class="ts-button-parent ts-button-type-' . $button_type . '" style="' . $button_align . '">';
						if ($button_wrapper == "true") {
							$button_string .= '<div class="ts-button-wrap" style="">';
						}
							$button_string .= '<a href="' . $a_href . '" target="' . trim($a_target) . '" style="' . $button_font . ' width: ' . $button_width . '%;" class="ts-button ' . $button_style . ' ' . $button_size . ' ' . $button_tooltipclasses . '" ' . $button_tooltipcontent . '>';
								$button_string .= '<span class="ts-button-text" style="display: inline; ' . $button_color . '">' . $button_text . '</span>';
							$button_string .= '</a>';
						if ($button_wrapper == "true") {
							$button_string .= '</div>';
						}
					$button_string .= '</div>';
				} else {
					$link						= '';
				}
			} else {
				$button_string					= '';
			}
			// Event Icon	
			if ((empty($icon)) && (empty($content)) && (empty($featured_image))) {
				$title_margin					= 'margin: 0;';
			} else {
				$title_margin					= '';
			}
			// Column Adjustment for Fill Width Event
			if (($full_width == "true") && (empty($title_text)) && (empty($icon) || ($icon == "transparent")) && (empty($content)) && (empty($button_string))) {
				$columnA_adjust					= 'width: 100%; margin: 0;';
				$columnB_adjust					= 'display: none; width: 0;';
			} else if (($full_width == "true") && ($featured_media == "none")) {
				$columnA_adjust					= 'display: none; width: 0; margin: 0;';
				$columnB_adjust					= 'width: 100%; margin: 0;';
			} else {
				$columnA_adjust					= '';
				$columnB_adjust					= '';
			}
			
            $output .= '<li id="' . $timeline_id . '" class="ts-timeline-list-item ' . $el_class . ' ' . ($full_width == "true" ? "ts-timeline-full" : "") . ' ' . (!empty($date_text) ? "ts-timeline-date-true" : "ts-timeline-date-false") . '" style="' . ($full_width == "true" ? "width: 100%;" : "") . '">';
                $output .= '<div class="ts-timeline-column">';
                    $output .= '<div class="ts-timeline-text-wrap" style="' . ($full_width == "true" ? "margin: 0 10px;" : "") . '">';
						if (!empty($date_text)) {
							$output .= '<div class="ts-timeline-date"><span class="ts-timeline-date-connect"><span class="ts-timeline-date-text">' . $date_text . '</span></span></div>';
						}
						if ($full_width == "true") {
							$output .= '<div class="ts-timeline-full-colA" style="' . $columnA_adjust . '">';
								$output .= $media_string;
							$output .= '</div>';
							$output .= '<div class="ts-timeline-full-colB" style="' . $columnB_adjust . '">';
								if (!empty($title_text)) {
									$output .= '<h3 class="ts-timeline-title" style="color: ' . $title_color . '; text-align: ' . $title_align . '; ' . (empty($content) && (empty($icon)) ? "border: none; margin-bottom: 0; padding-bottom: 0;" : "") . ' ' . $title_margin . '">' . $title_text . '</h3>';
								}
								if (((!empty($icon)) && (($icon) != "transparent")) || (!empty($content)) || (!empty($link))) {
									$output .= '<div style="width: 100%; display: block; float: left; position: relative; padding-bottom: 15px; ' . (empty($content) && !empty($icon) ? "height: 60px;" : "") . '">';
										if (!empty($content)) {
											$output .= '<div class="ts-timeline-text-wrap-inner" style="' . (empty($icon) ? "width: 100%; height: 100%; left: 0;" : " left: 0;") . '">';
												if (function_exists('wpb_js_remove_wpautop')){
													$output .= '<div class="ts-timeline-text" style="">' . wpb_js_remove_wpautop(do_shortcode($content), true) . '</div>';
												} else {
													$output .= '<div class="ts-timeline-text" style="">' . do_shortcode($content) . '</div>';
												}
											$output .= '</div>';
										}
										if ((!empty($icon)) && (($icon) != "transparent")) {
											$output .= '<div class="ts-timeline-icon ts-timeline-icon-full" style="' . (empty($content) ? "display: inline-block; width: 100%; left: 0; margin: 0 0 0 2%;" : "left: 80%;") . '"><i class="' . $icon . '" style="color: ' . $icon_color . ';"></i></div>';
										}
										if (!empty($button_string)) {
											$output .= '<div class="ts-timeline-button">';
												$output .= $button_string;
											$output .= '</div>';
										}
									$output .= '</div>';
								}
							$output .= '</div>';
							
						} else {
							$output .= $media_string;
							if (!empty($title_text)) {
								$output .= '<h3 class="ts-timeline-title" style="color: ' . $title_color . '; text-align: ' . $title_align . '; ' . (empty($content) && (empty($icon)) ? "border: none; margin-bottom: 0; padding-bottom: 0;" : "") . ' ' . $title_margin . '">' . $title_text . '</h3>';
							}
							if (((!empty($icon)) && (($icon) != "transparent")) || (!empty($content))) {
								$output .= '<div style="width: 100%; display: block; float: left; position: relative; padding-bottom: 15px; ' . (empty($content) && !empty($icon) ? "height: 60px;" : "") . '">';
									if ((!empty($icon)) && (($icon) != "transparent")) {
										$output .= '<div class="ts-timeline-icon ts-timeline-icon-half" style="' . (empty($content) ? "display: inline-block; width: 100%; left: 0;" : "") . '"><i class="' . $icon . '" style="color: ' . $icon_color . ';"></i></div>';
									}
									if (!empty($content)) {
										$output .= '<div class="ts-timeline-text-wrap-inner" style="' . (empty($icon) ? "width: 100%; height: 100%; left: 0;" : "") . '">';
											if (function_exists('wpb_js_remove_wpautop')){
												$output .= '<div class="ts-timeline-text" style="">' . wpb_js_remove_wpautop(do_shortcode($content), true) . '</div>';
											} else {
												$output .= '<div class="ts-timeline-text" style="">' . do_shortcode($content) . '</div>';
											}
										$output .= '</div>';
									}
								$output .= '</div>';
								if (!empty($link)) {
									$output .= '<div class="ts-timeline-button">';
										$output .= $button_string;
									$output .= '</div>';
								}
							}
						}
                        $output .= '<div class="clearFixMe"></div>';
                    $output .= '</div>';
                $output .= '</div>';
            $output .= '</li>';
			
			echo $output;
			
			$myvariable = ob_get_clean();
			return $myvariable;
		}		
		// Timeline Break
		function TS_VCSC_Timeline_Function_Break ($atts, $content = null) {
			global $VISUAL_COMPOSER_EXTENSIONS;
			ob_start();

			extract( shortcode_atts( array(
				'color_background'			=> '#ededed',
				'title_text'				=> '',
				'title_align'				=> 'center',
				'title_color'				=> '#7c7979',
				'content_text'				=> '',
				'content_align'				=> 'center',
				'content_color'				=> '#7c7979',
				'el_id' 					=> '',
				'el_class'                  => '',
			), $atts ));
		
			if (!empty($el_id)) {
				$timeline_id				= $el_id;
			} else {
				$timeline_id				= 'ts-vcsc-timeline-item-' . mt_rand(999999, 9999999);
			}
			
			if (empty($content_text)) {
				$title_margin				= ' margin: 0 !important; padding: 0;';
			} else {
				$title_margin				= '';
			}
			
			$output = '';
			
            $output .= '<li id="' . $timeline_id . '" class="ts-timeline-list-item ts-timeline-break ' . $el_class . '" style="">';
                $output .= '<div class="ts-timeline-column" style="margin: 0;">';
                    $output .= '<div class="ts-timeline-text-wrap" style="background-color: ' . $color_background . ';">';
                        $output .= '<div class="ts-timeline-text-wrap-inner" style="width: 100%; left: 0; ' . $title_margin . '">';
							if (!empty($title_text)) {
								$output .= '<h3 class="ts-timeline-title" style="text-align: ' . $title_align . '; color: ' . $title_color . ';' . $title_margin . '">' . $title_text . '</h3>';
							}
							if (!empty($content_text)) {
								$output .= '<div class="ts-timeline-text" style="text-align: ' . $content_align . '; color: ' . $content_color . ';">' . rawurldecode(base64_decode(strip_tags($content_text))) . '</div>';
							}
                        $output .= '</div>';
                        $output .= '<div class="clearFixMe"></div>';
                    $output .= '</div>';
                $output .= '</div>';
            $output .= '</li>';
			
			echo $output;
			
			$myvariable = ob_get_clean();
			return $myvariable;
		}
        // Timeline Container
        function TS_VCSC_Timeline_Function_Container ($atts, $content = null){
            global $VISUAL_COMPOSER_EXTENSIONS;
            ob_start();
            
            if ((get_option('ts_vcsc_extend_settings_loadHeader', 0) == 0)) {
                $FOOTER = true;
            } else {
                $FOOTER = false;
            }
			
			wp_enqueue_script('ts-extend-hammer', 								TS_VCSC_GetResourceURL('js/jquery.hammer.min.js'), array('jquery'), false, $FOOTER);
			wp_enqueue_script('ts-extend-nacho', 								TS_VCSC_GetResourceURL('js/jquery.nchlightbox.min.js'), array('jquery'), false, $FOOTER);
			wp_enqueue_style('ts-extend-nacho',									TS_VCSC_GetResourceURL('css/jquery.nchlightbox.min.css'), null, false, 'all');
            if (get_option('ts_vcsc_extend_settings_loadForcable', 0) == 0) {
				wp_enqueue_style('ts-extend-simptip',                 			TS_VCSC_GetResourceURL('css/jquery.simptip.css'), null, false, 'all');
				wp_enqueue_style('ts-extend-buttons',                 			TS_VCSC_GetResourceURL('css/jquery.buttons.css'), null, false, 'all');
				wp_enqueue_style('ts-extend-animations',                 		TS_VCSC_GetResourceURL('css/ts-visual-composer-extend-animations.min.css'), null, false, 'all');
				wp_enqueue_style('ts-visual-composer-extend-front',				TS_VCSC_GetResourceURL('css/ts-visual-composer-extend-front.min.css'), null, false, 'all');
				wp_enqueue_script('ts-extend-isotope',							TS_VCSC_GetResourceURL('js/jquery.isotope.min.js'), array('jquery'), false, $FOOTER);
				wp_enqueue_script('ts-visual-composer-extend-front',			TS_VCSC_GetResourceURL('js/ts-visual-composer-extend-front.min.js'), array('jquery'), false, $FOOTER);
            }
			add_action('wp_footer', 											array($this, 'TS_VCSC_Timeline_Function_Isotope'), 9999);
            
            extract( shortcode_atts( array(
				'timeline_order'				=> 'asc',
				'timeline_sort'					=> 'true',
				'timeline_lazy'					=> 'false',
				'timeline_trigger'				=> 'scroll',
				'timeline_count'				=> '10',
				'timeline_break'				=> '600',
				
				'timeline_title'				=> '',
				'timeline_title_color'			=> '#7c7979',
				'timeline_load'					=> 'Load More',
				'timeline_start'				=> '',
				'timeline_end'					=> '',
				'timeline_description'			=> '',
				'timeline_description_align'	=> 'center',
				'timeline_description_color'	=> '#7c7979',
				
				'margin_bottom'					=> '0',
				'margin_top' 					=> '0',
				'el_id' 						=> '',
				'el_class'                  	=> '',
            ), $atts ));
            
            $timeline_random                 	= mt_rand(999999, 9999999);
            
            if (!empty($el_id)) {
                $timeline_container_id			= $el_id;
            } else {
                $timeline_container_id			= 'ts-vcsc-timeline-container-' . $timeline_random;
            }
            
            $output 							= '';
		
			$output .= '<div id="' . $timeline_container_id . '" class="ts-timeline-container ts-timeline ts-timeline-' . $timeline_order . ' clearFixMe ' . $el_class . '" data-order="' . $timeline_order .'" data-lazy="' . $timeline_lazy . '" data-count="' . $timeline_count . '" data-trigger="' . $timeline_trigger . '" data-break="' . $timeline_break . '" style="margin-top: ' . $margin_top . 'px; margin-bottom: ' . $margin_bottom . 'px; width: 100%;">';
				
				$output .= '<div class="ts-timeline-controls">';
					$output .= '<div class="ts-timeline-controls-title" style="color: ' . $timeline_title_color . ';">' . $timeline_title . '</div>';
					if ($timeline_sort == "true") {
						$output .= '<div class="ts-button ts-button-flat ts-timeline-controls-desc ' . ($timeline_order == "desc" ? "active" : "") . '"><span class="ts-timeline-controls-desc-image"></span></div>';
						$output .= '<div class="ts-button ts-button-flat ts-timeline-controls-asc ' . ($timeline_order == "asc" ? "active" : "") . '"><span class="ts-timeline-controls-asc-image"></span></div>';
					}
				$output .= '</div>';
				
				if (!empty($timeline_end)) {
					$output .= '<div class="ts-timeline-begin ts-timeline-begin-top">';
						$output .= '<span class="begin-text">' . $timeline_end . '</span>';
					$output .= '</div>';
				}
				if ((!empty($timeline_title)) || (!empty($timeline_description)) || (!empty($timeline_end))) {
					$output .= '<div class="ts-timeline-header-wrap">';
						if ((!empty($timeline_title)) || (!empty($timeline_description))) {
							$output .= '<div class="ts-timeline-header">';
								if (!empty($timeline_title)) {
									$output .= '<h4 class="ts-timeline-header-title" style="color: ' . $timeline_title_color . ';">' . $timeline_title . '</h4>';
								}
								if (!empty($timeline_description)) {
									$output .= '<p class="ts-timeline-header-description" style="color: ' . $timeline_description_color . '; text-align: ' . $timeline_description_align . ';">' . rawurldecode(base64_decode(strip_tags($timeline_description))) . '</p>';
								}
							$output .= '</div>';
						}
						if (!empty($timeline_start)) {
							$output .= '<div class="ts-timeline-end">';
								$output .= '<span class="end-text">' . $timeline_start . '</span>';
							$output .= '</div>';
						}
					$output .= '</div>';
				}
				
				$output .= '<div class="ts-timeline-content">';
					$output .= '<div id="ts-timeline-spine-' . $timeline_random . '" class="ts-timeline-spine"></div>';
					$output .= '<ul class="ts-timeline-list">';
						$output .= do_shortcode($content);
					$output .= '</ul>';
				$output .= '</div>';
				if ($timeline_lazy == "true") {
					$output .= '<div class="ts-load-more-wrap">';
						$output .= '<span class="ts-timeline-load-more">' . $timeline_load . '</span>';
					$output .= '</div>';
				}
				
				if ((!empty($timeline_title)) || (!empty($timeline_description)) || (!empty($timeline_end))) {
					$output .= '<div class="ts-timeline-footer-wrap">';
						if (!empty($timeline_start)) {
							$output .= '<div class="ts-timeline-end">';
								$output .= '<span class="end-text">' . $timeline_start . '</span>';
							$output .= '</div>';
						}
						if ((!empty($timeline_title)) || (!empty($timeline_description))) {
							$output .= '<div class="ts-timeline-footer">';
								if (!empty($timeline_title)) {
									$output .= '<h4 class="ts-timeline-footer-title" style="color: ' . $timeline_title_color . ';">' . $timeline_title . '</h4>';
								}
								if (!empty($timeline_description)) {
									$output .= '<p class="ts-timeline-footer-description" style="color: ' . $timeline_description_color . '; text-align: ' . $timeline_description_align . ';">' . rawurldecode(base64_decode(strip_tags($timeline_description))) . '</p>';
								}
							$output .= '</div>';
						}
					$output .= '</div>';
				}
				if (!empty($timeline_end)) {
					$output .= '<div class="ts-timeline-begin ts-timeline-begin-bottom">';
						$output .= '<span class="begin-text">' . $timeline_end . '</span>';
					$output .= '</div>';
				}

			$output .= '</div>';
            
            echo $output;
            
            $myvariable = ob_get_clean();
            return $myvariable;
        }
		
		// Add Timeline Elements
        function TS_VCSC_Add_Timeline_Elements() {
			global $VISUAL_COMPOSER_EXTENSIONS;
			// Add Single Timeline Element
			if (function_exists('vc_map')) {
				vc_map( array(
					"name"                      	=> __( "TS Timeline Item", "js_composer" ),
					"base"                      	=> "TS_VCSC_Timeline_Single",
					"icon" 	                    	=> "icon-wpb-ts_vcsc_timeline_single",
					"class"                     	=> "ts_vcsc_main_isotope_timeline",
					"category"                  	=> __( 'VC Extensions', 'js_composer' ),
					"description"               	=> __("Place a timeline item element", "js_composer"),
                    "content_element"				=> true,
                    "as_child"						=> array('only' => 'TS_VCSC_Timeline_Container'),
					//"admin_enqueue_js"        	=> array(ts_fb_get_resource_url('/Core/JS/jquery.js-composer.fb-album.js')),
					//"admin_enqueue_css"       	=> array(ts_fb_get_resource_url('/Core/CSS/jquery.js-composer.fb-album.css')),
					"params"                    	=> array(
						// Featured Media
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_1",
							"value"             	=> "Featured Media",
							"description"       	=> __( "", "js_composer" )
						),
						array(
							"type"              	=> "switch",
							"heading"			    => __( "Featured Event", "js_composer" ),
							"param_name"		    => "full_width",
							"value"             	=> "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"admin_label"           => true,
							"description"		    => __( "Switch the toggle if you want this timeline event to be a featured event, displayed full width over both columns.", "js_composer" ),
							"dependency"            => ""
						),
						array(
							"type"              	=> "dropdown",
							"heading"           	=> __( "Featured Media", "js_composer" ),
							"param_name"        	=> "featured_media",
							"width"             	=> 200,
							"value"             	=> array(
								__( 'None', "js_composer" )      							=> "none",
								__( 'Image', "js_composer" )      							=> "image",
								__( 'YouTube Video (Auto Cover)', "js_composer" )			=> "youtube_default",
								__( 'YouTube Video (Custom Cover)', "js_composer" )			=> "youtube_custom",
								__( 'YouTube Video (Direct iFrame)', "js_composer" )		=> "youtube_embed",
								__( 'DailyMotion Video (Auto Cover)', "js_composer" )		=> "dailymotion_default",
								__( 'DailyMotion Video (Custom Cover)', "js_composer" )		=> "dailymotion_custom",
								__( 'DailyMotion Video (Direct iFrame)', "js_composer" )	=> "dailymotion_embed",
								__( 'Vimeo Video (Auto Cover)', "js_composer" )				=> "vimeo_default",
								__( 'Vimeo Video (Custom Cover)', "js_composer" )			=> "vimeo_custom",
								__( 'Vimeo Video (Direct iFrame)', "js_composer" )			=> "vimeo_embed",
							),
							"admin_label"			=> true,
							"description"       	=> __( "Select the Featured Media Type for the timeline item.", "js_composer" )
						),
						// YouTube Video
						array(
							"type"                  => "textfield",
							"heading"               => __( "YouTube Video URL", "js_composer" ),
							"param_name"            => "featured_youtube_url",
							"value"                 => "",
							"admin_label"           => true,
							"description"           => __( "Enter the URL for the YouTube video.", "js_composer" ),
							"dependency"            => array( 'element' => "featured_media", 'value' => array('youtube_default','youtube_custom','youtube_embed') )
						),
						array(
							"type"              	=> "switch",
							"heading"			    => __( "Show Related Videos", "js_composer" ),
							"param_name"		    => "featured_youtube_related",
							"value"             	=> "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"		    => __( "Switch the toggle if you want to show related videos at the end of the video.", "js_composer" ),
							"dependency"            => array( 'element' => "featured_media", 'value' => array('youtube_default','youtube_custom','youtube_embed') )
						),
						array(
							"type"              	=> "switch",
							"heading"			    => __( "Autoplay Video", "js_composer" ),
							"param_name"		    => "featured_youtube_play",
							"value"             	=> "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"		    => __( "Switch the toggle if you want to auto-play the video once opened in the lightbox or on pageload (iFrame).", "js_composer" ),
							"dependency"            => array( 'element' => "featured_media", 'value' => array('youtube_default','youtube_custom','youtube_embed') )
						),	
						// Image
						array(
							"type"					=> "attach_image",
							"holder"				=> "img",
							"heading"				=> __( "Select Image", "js_composer" ),
							"param_name"			=> "featured_image",
							"class"					=> "ts_vcsc_holder_image",
							"value"					=> "",
							"admin_label"			=> false,
							"description"			=> __( "Select an image for the timeline item.", "js_composer" ),
							"dependency"            => array( 'element' => "featured_media", 'value' => array('image','youtube_custom','dailymotion_custom','vimeo_custom') )
						),
						array(
							"type"					=> "textfield",
							"heading"				=> __( "Enter ALT Attribute", "js_composer" ),
							"param_name"			=> "attribute_alt_value",
							"value"					=> "",
							"description"			=> __( "Enter a custom value for the ALT attribute for the image, otherwise file name will be set.", "js_composer" ),
							"dependency"            => array( 'element' => "featured_media", 'value' => array('image','youtube_custom','dailymotion_custom','vimeo_custom') )
						),
						array(
							"type"					=> "switch",
							"heading"           	=> __( "Open in Lightbox", "js_composer" ),
							"param_name"        	=> "lightbox_featured",
							"value"             	=> "true",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"       	=> __( "Switch the toggle if you want to apply a lightbox to the image.", "js_composer" ),
							"dependency"            => array('element' => "featured_media", 'value' => array('image'))
						),
						// Media Dimensions
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_2",
							"value"             	=> "Media Dimensions",
							"description"       	=> __( "", "js_composer" ),
							"dependency"            => array( 'element' => "featured_media", 'value' => array('image','youtube_default','youtube_custom','youtube_embed','dailymotion_default','dailymotion_custom','dailymotion_embed','vimeo_default','vimeo_custom','vimeo_embed') )
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Auto Height Setting", "js_composer" ),
							"param_name"            => "featured_media_height",
							"width"                 => 150,
							"value"                 => array(
								__( '100% Height Setting', "js_composer" )		=> "height: 100%;",
								__( 'Auto Height Setting', "js_composer" )     	=> "height: auto;",
							),
							"description"           => __( "Select what height setting should be applied to the media element (change only if image height does not display correctly).", "js_composer" ),
							"dependency"            => array( 'element' => "featured_media", 'value' => array('image','youtube_default','youtube_custom','youtube_embed','dailymotion_default','dailymotion_custom','dailymotion_embed','vimeo_default','vimeo_custom','vimeo_embed') )
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Media Width", "js_composer" ),
							"param_name"            => "featured_media_width",
							"value"                 => "100",
							"min"                   => "1",
							"max"                   => "100",
							"step"                  => "1",
							"unit"                  => '%',
							"description"           => __( "Define the media element width in percent (%).", "js_composer" ),
							"dependency"            => array( 'element' => "featured_media", 'value' => array('image','youtube_default','youtube_custom','youtube_embed','dailymotion_default','dailymotion_custom','dailymotion_embed','vimeo_default','vimeo_custom','vimeo_embed') )
						),
						array(
							"type"              	=> "dropdown",
							"heading"           	=> __( "Media Alignment", "js_composer" ),
							"param_name"        	=> "featured_media_align",
							"width"             	=> 200,
							"value"             	=> array(
								__( 'Center', "js_composer" )      	=> "center",
								__( 'Left', "js_composer" )         => "left",
								__( 'Right', "js_composer" )       	=> "right",
							),
							"description"       	=> __( "If not full width, select how the media element should be aligned.", "js_composer" ),
							"dependency"            => array( 'element' => "featured_media", 'value' => array('image','youtube_default','youtube_custom','youtube_embed','dailymotion_default','dailymotion_custom','dailymotion_embed','vimeo_default','vimeo_custom','vimeo_embed') )
						),					
						// Main Content
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_3",
							"value"             	=> "Main Content",
							"description"       	=> __( "", "js_composer" ),
							"group"					=> "Main Content",
						),
						array(
							"type"              	=> "textfield",
							"heading"           	=> __( "Date / Time", "js_composer" ),
							"param_name"        	=> "date_text",
							"value"             	=> "",
							"admin_label"			=> true,
							"description"       	=> __( "Enter a date and/or time for the timeline item.", "js_composer" ),
							"group"					=> "Main Content",
						),
						array(
							"type"              	=> "textfield",
							"heading"           	=> __( "Title", "js_composer" ),
							"param_name"        	=> "title_text",
							"value"             	=> "",
							"admin_label"			=> true,
							"description"       	=> __( "Enter the title for the timeline item.", "js_composer" ),
							"group"					=> "Main Content",
						),
						array(
							"type"              	=> "dropdown",
							"heading"           	=> __( "Alignment", "js_composer" ),
							"param_name"        	=> "title_align",
							"width"             	=> 200,
							"value"             	=> array(
								__( 'Center', "js_composer" )      	=> "center",
								__( 'Left', "js_composer" )         => "left",
								__( 'Right', "js_composer" )       	=> "right",
								__( 'Justify', "js_composer" )		=> "justify",
							),
							"description"       	=> __( "Select how the title in the timeline item should be aligned.", "js_composer" ),
							"group"					=> "Main Content",
						),
						array(
							"type"              	=> "colorpicker",
							"heading"           	=> __( "Title Color", "js_composer" ),
							"param_name"        	=> "title_color",
							"value"             	=> "#7c7979",
							"description"       	=> __( "Define the font color for the title in the timeline item.", "js_composer" ),
							"dependency"        	=> "",
							"group"					=> "Main Content",
						),
						array(
							"type"					=> "textarea_html",
							//"holder"				=> "div",
							"class"					=> "",
							"heading"				=> __( "Content", 'js_composer' ),
							"param_name"			=> "content",
							"value"					=> "",
							"admin_label"			=> false,
							"description"			=> __( "Enter the main content for the timeline item.", "js_composer" ),
							"dependency"			=> "",
							"group"					=> "Main Content",
						),
						array(
							"type"              	=> "icons_panel",
							"heading"           	=> __( "Icon", "js_composer" ),
							"param_name"        	=> "icon",
							"value"             	=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_List_Icons_Full,
							"admin_label"       	=> true,
							"description"       	=> __( "Select an icon for timeline element.", "js_composer" ),
							"dependency"        	=> "",
							"group"					=> "Main Content",
						),
						array(
							"type"              	=> "colorpicker",
							"heading"           	=> __( "Icon Color", "js_composer" ),
							"param_name"        	=> "icon_color",
							"value"             	=> "#7c7979",
							"description"       	=> __( "Define the icon color to be used in the timeline item.", "js_composer" ),
							"dependency"       	 	=> "",
							"group"					=> "Main Content",
						),
						// Link Settings
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_4",
							"value"             	=> "Link Settings",
							"description"       	=> __( "", "js_composer" ),
							"group"					=> "Link Settings",
						),
						array(
							"type" 					=> "vc_link",
							"heading" 				=> __("Link + Title", "js_composer"),
							"param_name" 			=> "link",
							"description" 			=> __("Provide a link to another site/page for the Icon Button.", "js_composer"),
							"admin_label"           => true,
							"group"					=> "Link Settings",
						),
						array(
							"type"					=> "switch",
							"heading"				=> __( "Use CSS3 Tooltip", "js_composer" ),
							"param_name"			=> "tooltip_css",
							"value"					=> "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"       	=> __( "Switch the toggle if you want to apply a CSS3 tooltip to the image.", "js_composer" ),
							"dependency"        	=> "",
							"group"					=> "Link Settings",
						),
						array(
							"type"					=> "dropdown",
							"class"					=> "",
							"heading"				=> __( "Tooltip Position", 'js_composer' ),
							"param_name"			=> "tooltip_position",
							"value"					=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_ImageTooltip_Position,
							"description"			=> __( "Select the tooltip position in relation to the image.", "js_composer" ),
							"dependency"			=> array( 'element' => "tooltip_css", 'value' => 'true' ),
							"group"					=> "Link Settings",
						),
						array(
							"type"					=> "dropdown",
							"class"					=> "",
							"heading"				=> __( "Tooltip Style", 'js_composer' ),
							"param_name"			=> "tooltip_style",
							"value"					=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Tooltip_Style,
							"description"			=> __( "Select the tooltip style.", "js_composer" ),
							"dependency"			=> array( 'element' => "tooltip_css", 'value' => 'true' ),
							"group"					=> "Link Settings",
						),
						// Button Settings
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_5",
							"value"             	=> "Button Settings",
							"description"       	=> __( "", "js_composer" ),
							"group"					=> "Link Settings",
						),
						array(
							"type"              	=> "dropdown",
							"heading"           	=> __( "Button Align", "js_composer" ),
							"param_name"        	=> "button_align",
							"width"             	=> 300,
							"value"             	=> array(
								__( 'Center', "js_composer" )      	=> "center",
								__( 'Left', "js_composer" )			=> "left",
								__( 'Right', "js_composer" )  		=> "right",
							),
							"description"       	=> __( "Select how the icon button should be aligned.", "js_composer" ),
							"group"					=> "Link Settings",
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Button Width", "js_composer" ),
							"param_name"            => "button_width",
							"value"                 => "100",
							"min"                   => "0",
							"max"                   => "100",
							"step"                  => "1",
							"unit"                  => '%',
							"description"       	=> __( "Define the button width in percent (responsive).", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => array('square', 'rounded', 'pill') ),
							"group"					=> "Link Settings",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Type", "js_composer" ),
							"param_name"            => "button_type",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Types,
							"description"           => __( "Select the general button type for the 'Read More' Link.", "js_composer" ),
							"dependency"        	=> "",
							"group"					=> "Link Settings",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_square",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Square,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'square' ),
							"group"					=> "Link Settings",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_rounded",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Rounded,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'rounded' ),
							"group"					=> "Link Settings",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_pill",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Pill,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'pill' ),
							"group"					=> "Link Settings",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_circle",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Circle,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'circle' ),
							"group"					=> "Link Settings",
						),
						array(
							"type"              	=> "dropdown",
							"heading"           	=> __( "Button Size", "js_composer" ),
							"param_name"        	=> "button_size",
							"width"             	=> 300,
							"value"             	=> array(
								__( 'Normal', "js_composer" )		=> "ts-button-normal",
								__( 'Small', "js_composer" )      	=> "ts-button-small",
								__( 'Tiny', "js_composer" )  		=> "ts-button-tiny",
								__( 'Large', "js_composer" )  		=> "ts-button-large",
								__( 'Jumbo', "js_composer" )  		=> "ts-button-jumbo",
							),
							"description"       	=> __( "Select the size for the icon button.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => array('square', 'rounded', 'pill') ),
							"group"					=> "Link Settings",
						),
						array(
							"type"					=> "switch",
							"heading"           	=> __( "Add Button Wrapper", "js_composer" ),
							"param_name"        	=> "button_wrapper",
							"value"             	=> "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"       	=> __( "Switch the toggle to add a wrapper frame around the 'Read More' button (most suited for 'pill' and 'circle' buttons).", "js_composer" ),
							"dependency"        	=> "",
							"group"					=> "Link Settings",
						),
						array(
							"type"              	=> "textfield",
							"heading"           	=> __( "Button Text", "js_composer" ),
							"param_name"        	=> "button_text",
							"value"             	=> "Read More",
							"description"       	=> __( "Enter a text for the 'Read More' button.", "js_composer" ),
							"dependency"        	=> "",
							"group"					=> "Link Settings",
						),
						array(
							"type"					=> "switch",
							"heading"           	=> __( "Change Font Color", "js_composer" ),
							"param_name"        	=> "button_change",
							"value"             	=> "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"       	=> __( "Switch the toggle to apply a custom font color to the button text.", "js_composer" ),
							"dependency"        	=> "",
							"group"					=> "Link Settings",
						),
						array(
							"type"              	=> "colorpicker",
							"heading"           	=> __( "Text Color", "js_composer" ),
							"param_name"        	=> "button_color",
							"value"             	=> "#666666",
							"description"       	=> __( "Define the color of the text for the button.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_change", 'value' => 'true' ),
							"group"					=> "Link Settings",
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Font Size", "js_composer" ),
							"param_name"            => "button_font",
							"value"                 => "18",
							"min"                   => "4",
							"max"                   => "100",
							"step"                  => "1",
							"unit"                  => 'px',
							"description"       	=> __( "Define the font size for the icon / text in the button.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'circle' ),
							"group"					=> "Link Settings",
						),
						// Lightbox Settings
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_6",
							"value"             	=> "Lightbox Settings",
							"description"       	=> __( "", "js_composer" ),
							"group"					=> "Lightbox Settings",
						),
						array(
							"type"              	=> "switch",
							"heading"			    => __( "Create AutoGroup", "js_composer" ),
							"param_name"		    => "lightbox_group",
							"value"				    => "true",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"		    => __( "Switch the toggle if you want the plugin to group this image with all other non-gallery images on the page.", "js_composer" ),
							"dependency"        	=> "",
							"group"					=> "Lightbox Settings",
						),
						array(
							"type"                  => "textfield",
							"heading"               => __( "Group Name", "js_composer" ),
							"param_name"            => "lightbox_group_name",
							"value"                 => "",
							"description"           => __( "Enter a custom group name to manually build group with other non-gallery items.", "js_composer" ),
							"dependency"            => array( 'element' => "lightbox_group", 'value' => 'false' ),
							"group"					=> "Lightbox Settings",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Transition Effect", "js_composer" ),
							"param_name"            => "lightbox_effect",
							"width"                 => 150,
							"value"                 => array(
								__( 'Random', "js_composer" )       => "random",
								__( 'Swipe', "js_composer" )        => "swipe",
								__( 'Fade', "js_composer" )         => "fade",
								__( 'Scale', "js_composer" )        => "scale",
								__( 'Slide Up', "js_composer" )     => "slideUp",
								__( 'Slide Down', "js_composer" )   => "slideDown",
								__( 'Flip', "js_composer" )         => "flip",
								__( 'Skew', "js_composer" )         => "skew",
								__( 'Bounce Up', "js_composer" )    => "bounceUp",
								__( 'Bounce Down', "js_composer" )  => "bounceDown",
								__( 'Break In', "js_composer" )     => "breakIn",
								__( 'Rotate In', "js_composer" )    => "rotateIn",
								__( 'Rotate Out', "js_composer" )   => "rotateOut",
								__( 'Hang Left', "js_composer" )    => "hangLeft",
								__( 'Hang Right', "js_composer" )   => "hangRight",
								__( 'Cycle Up', "js_composer" )     => "cicleUp",
								__( 'Cycle Down', "js_composer" )   => "cicleDown",
								__( 'Zoom In', "js_composer" )      => "zoomIn",
								__( 'Throw In', "js_composer" )     => "throwIn",
								__( 'Fall', "js_composer" )         => "fall",
								__( 'Jump', "js_composer" )         => "jump",
							),
							"description"           => __( "Select the transition effect to be used for the image in the lightbox.", "js_composer" ),
							"dependency"            => "",
							"group"					=> "Lightbox Settings",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Backlight Effect", "js_composer" ),
							"param_name"            => "lightbox_backlight",
							"width"                 => 150,
							"value"                 => array(
								__( 'Auto Color', "js_composer" )       => "auto",
								__( 'Custom Color', "js_composer" )     => "custom",
								__( 'No Backlight', "js_composer" )     => "hideit",
							),
							"description"           => __( "Select the backlight effect for the image.", "js_composer" ),
							"dependency"            => "",
							"group"					=> "Lightbox Settings",
						),
						array(
							"type"                  => "colorpicker",
							"heading"               => __( "Custom Backlight Color", "js_composer" ),
							"param_name"            => "lightbox_backlight_color",
							"value"                 => "#ffffff",
							"description"           => __( "Define the backlight color for the lightbox image.", "js_composer" ),
							"dependency"            => array( 'element' => "lightbox_backlight", 'value' => 'custom' ),
							"group"					=> "Lightbox Settings",
						),
						/*array(
							"type"              	=> "switch",
							"heading"			    => __( "Social Share Buttons", "js_composer" ),
							"param_name"		    => "lightbox_social",
							"value"				    => "true",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"		    => __( "Switch the toggle if you want show social share buttons with deeplinking for each image.", "js_composer" ),
							"dependency"        	=> "",
							"group" 				=> "Lightbox Settings",
						),*/
						// Other Settings
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_7",
							"value"             	=> "Other Settings",
							"description"       	=> __( "", "js_composer" ),
							"group"					=> "Other Settings",
						),
						array(
							"type"              	=> "textfield",
							"heading"           	=> __( "Define ID Name", "js_composer" ),
							"param_name"        	=> "el_id",
							"value"             	=> "",
							"description"       	=> __( "Enter a unique ID name for the timeline / process element.", "js_composer" ),
							"group"					=> "Other Settings",
						),
						array(
							"type"              	=> "textfield",
							"heading"           	=> __( "Extra Class Name", "js_composer" ),
							"param_name"        	=> "el_class",
							"value"             	=> "",
							"description"       	=> __( "Enter a class name for the timeline / process element.", "js_composer" ),
							"group"					=> "Other Settings",
						),
						// Load Custom CSS/JS File
						array(
							"type"              	=> "load_file",
							"heading"           	=> __( "", "js_composer" ),
							"value"             	=> "Timeline Files",
							"param_name"        	=> "el_file",
							"file_type"         	=> "js",
							"file_path"         	=> "js/ts-visual-composer-extend-element.min.js",
							"description"       	=> __( "", "js_composer" )
						),
					))
				);
			}
			// Add Break Timeline Element
			if (function_exists('vc_map')) {
				vc_map( array(
					"name"                      => __( "TS Timeline Break", "js_composer" ),
					"base"                      => "TS_VCSC_Timeline_Break",
					"icon" 	                    => "icon-wpb-ts_vcsc_timeline_break",
					"class"                     => "",
					"category"                  => __( 'VC Extensions', 'js_composer' ),
					"description"               => __("Place a timeline break element", "js_composer"),
                    "content_element"			=> true,
                    "as_child"					=> array('only' => 'TS_VCSC_Timeline_Container'),
					//"admin_enqueue_js"        => array(ts_fb_get_resource_url('/Core/JS/jquery.js-composer.fb-album.js')),
					//"admin_enqueue_css"       => array(ts_fb_get_resource_url('/Core/CSS/jquery.js-composer.fb-album.css')),
					"params"                    => array(
						// Timeline Settings
						array(
							"type"              => "seperator",
							"heading"           => __( "", "js_composer" ),
							"param_name"        => "seperator_1",
							"value"             => "Timeline Break Settings",
							"description"       => __( "", "js_composer" )
						),
						array(
							"type"              => "colorpicker",
							"heading"           => __( "Background Color", "js_composer" ),
							"param_name"        => "color_background",
							"value"             => "#ededed",
							"description"       => __( "Define the background color for the timeline break item.", "js_composer" ),
							"dependency"        => ""
						),
						array(
							"type"              => "textfield",
							"heading"           => __( "Title", "js_composer" ),
							"param_name"        => "title_text",
							"value"             => "",
							"admin_label"		=> true,
							"description"       => __( "Enter the title for the timeline break item.", "js_composer" )
						),
						array(
							"type"              => "dropdown",
							"heading"           => __( "Alignment", "js_composer" ),
							"param_name"        => "title_align",
							"width"             => 200,
							"value"             => array(
								__( 'Center', "js_composer" )      	=> "center",
								__( 'Left', "js_composer" )         => "left",
								__( 'Right', "js_composer" )       	=> "right",
								__( 'Justify', "js_composer" )		=> "justify",
							),
							"description"       => __( "Select how the title in the timeline break item should be aligned.", "js_composer" )
						),
						array(
							"type"              => "colorpicker",
							"heading"           => __( "Title Color", "js_composer" ),
							"param_name"        => "title_color",
							"value"             => "#7c7979",
							"description"       => __( "Define the font color for the title in the timeline break item.", "js_composer" ),
							"dependency"        => ""
						),
						array(
							"type"              => "textarea_raw_html",
							"heading"           => __( "Content", "js_composer" ),
							"param_name"        => "content_text",
							"value"             => base64_encode(""),
							"description"       => __( "Enter the timeline break item content; HTML code can be used.", "js_composer" ),
							"dependency"        => ""
						),
						array(
							"type"              => "dropdown",
							"heading"           => __( "Alignment", "js_composer" ),
							"param_name"        => "content_align",
							"width"             => 200,
							"value"             => array(
								__( 'Center', "js_composer" )      	=> "center",
								__( 'Left', "js_composer" )         => "left",
								__( 'Right', "js_composer" )       	=> "right",
								__( 'Justify', "js_composer" )		=> "justify",
							),
							"description"       => __( "Select how the content in the timeline break item should be aligned.", "js_composer" )
						),
						array(
							"type"              => "colorpicker",
							"heading"           => __( "Content Color", "js_composer" ),
							"param_name"        => "content_color",
							"value"             => "#7c7979",
							"description"       => __( "Define the font color for the content in the timeline break item.", "js_composer" ),
							"dependency"        => ""
						),
						// Other Settings
						array(
							"type"              => "seperator",
							"heading"           => __( "", "js_composer" ),
							"param_name"        => "seperator_8",
							"value"             => "Other Box Settings",
							"description"       => __( "", "js_composer" ),
							"group" 			=> "Other Settings",
						),
						array(
							"type"              => "textfield",
							"heading"           => __( "Define ID Name", "js_composer" ),
							"param_name"        => "el_id",
							"value"             => "",
							"description"       => __( "Enter an unique ID for the timeline break item.", "js_composer" ),
							"group" 			=> "Other Settings",
						),
						array(
							"type"              => "textfield",
							"heading"           => __( "Extra Class Name", "js_composer" ),
							"param_name"        => "el_class",
							"value"             => "",
							"description"       => __( "Enter a class name for the icon box.", "js_composer" ),
							"group" 			=> "Other Settings",
						),
						// Load Custom CSS/JS File
						array(
							"type"              => "load_file",
							"heading"           => __( "", "js_composer" ),
							"value"             => "Timeline Files",
							"param_name"        => "el_file",
							"file_type"         => "js",
							"file_path"         => "js/ts-visual-composer-extend-element.min.js",
							"description"       => __( "", "js_composer" )
						),
					))
				);
			}
			// Add Timeline Container Element
            if (function_exists('vc_map')) {
                vc_map(array(
                   "name"                               => __("TS Isotope Timeline", "js_composer"),
                   "base"                               => "TS_VCSC_Timeline_Container",
                   "class"                              => "",
                   "icon"                               => "icon-wpb-ts_vcsc_timeline_container",
                   "category"                           => __("VC Extensions", "js_composer"),
                   "as_parent"                          => array('only' => 'TS_VCSC_Timeline_Single,TS_VCSC_Timeline_Break'),
                   "description"                        => __("Build a custom Timeline with Isotope", "js_composer"),
                   "content_element"                    => true,
                   "show_settings_on_create"            => false,
                   "params"                             => array(
						// General Settings
                        array(
                            "type"                      => "seperator",
                            "heading"                   => __( "", "js_composer" ),
                            "param_name"                => "seperator_0",
                            "value"                     => "General Setup",
                            "description"               => __( "", "js_composer" )
                        ),
						array(
							"type"              		=> "dropdown",
							"heading"           		=> __( "Initial Order", "js_composer" ),
							"param_name"        		=> "timeline_order",
							"width"             		=> 200,
							"value"             		=> array(
								__( 'Oldest (Top) to Newest (Bottom)', "js_composer" )		=> "asc",
								__( 'Newest (Top) to Oldest (Bottom)', "js_composer" )		=> "desc",
							),
							"description"       		=> __( "Select in which order the timeline events are arranged in Visual Composer.", "js_composer" )
						),
						array(
							"type"              		=> "switch",
							"heading"			    	=> __( "Sort Buttons", "js_composer" ),
							"param_name"		    	=> "timeline_sort",
							"value"             		=> "true",
							"on"						=> __( 'Yes', "js_composer" ),
							"off"						=> __( 'No', "js_composer" ),
							"style"						=> "select",
							"design"					=> "toggle-light",
							"admin_label"           	=> true,
							"description"		    	=> __( "Switch the toggle if you want to provide sort controls (up/down) for the timeline.", "js_composer" ),
							"dependency"            	=> ""
						),
                        array(
                            "type"                      => "nouislider",
                            "heading"                   => __( "Masonry Breakpoint", "js_composer" ),
                            "param_name"                => "timeline_break",
                            "value"                     => "600",
                            "min"                       => "100",
                            "max"                       => "2048",
                            "step"                      => "1",
                            "unit"                      => 'px',
                            "description"               => __( "Define a breakpoint in pixels at which the timeline should switch to a one column layout.", "js_composer" )
                        ),
						array(
							"type"              		=> "switch",
							"heading"			    	=> __( "Lazy-Load Effect", "js_composer" ),
							"param_name"		    	=> "timeline_lazy",
							"value"             		=> "false",
							"on"						=> __( 'Yes', "js_composer" ),
							"off"						=> __( 'No', "js_composer" ),
							"style"						=> "select",
							"design"					=> "toggle-light",
							"admin_label"           	=> true,
							"description"		    	=> __( "Switch the toggle if you want to show a limited number of events at a time, showing more the further you scroll.", "js_composer" ),
							"dependency"            	=> ""
						),
                        array(
                            "type"                      => "nouislider",
                            "heading"                   => __( "Number of Events", "js_composer" ),
                            "param_name"                => "timeline_count",
                            "value"                     => "10",
                            "min"                       => "1",
                            "max"                       => "200",
                            "step"                      => "1",
                            "unit"                      => '',
                            "description"               => __( "Define how many events should be shown per Lazy-Load Event.", "js_composer" ),
							"dependency"            	=> array( 'element' => "timeline_lazy", 'value' => 'true' )
                        ),
						array(
							"type"              		=> "dropdown",
							"heading"           		=> __( "Lazy-Load Trigger", "js_composer" ),
							"param_name"        		=> "timeline_trigger",
							"width"             		=> 200,
							"value"             		=> array(
								__( 'Scroll', "js_composer" )      		=> "scroll",
								__( 'Click', "js_composer" )         	=> "click",
							),
							"description"       		=> __( "Select how the Lazy-Load Effect should be triggered for the timeline.", "js_composer" ),
							"dependency"            	=> array( 'element' => "timeline_lazy", 'value' => 'true' )
						),
                        array(
                            "type"                      => "textfield",
                            "heading"                   => __( "Text for 'Load More' Button", "js_composer" ),
                            "param_name"                => "timeline_load",
                            "value"                     => "Load More",
                            "description"               => __( "Enter a text to be shown inside the 'Load More' trigger button.", "js_composer" ),
							"dependency"            	=> array( 'element' => "timeline_lazy", 'value' => 'true' )
                        ),
                        // Additional Info Settings
                        array(
                            "type"                      => "seperator",
                            "heading"                   => __( "", "js_composer" ),
                            "param_name"                => "seperator_2",
                            "value"                     => "Additional Information",
                            "description"               => __( "", "js_composer" ),
							"group" 			        => "Additional Info",
                        ),
						array(
							"type"              		=> "textfield",
							"heading"           		=> __( "Timeline Title", "js_composer" ),
							"param_name"        		=> "timeline_title",
							"value"             		=> "",
							"description"       		=> __( "Enter a title for the Isotope Timeline.", "js_composer" ),
							"group" 			        => "Additional Info",
						),
						array(
							"type"              		=> "colorpicker",
							"heading"           		=> __( "Title Color", "js_composer" ),
							"param_name"        		=> "timeline_title_color",
							"value"             		=> "#7c7979",
							"description"       		=> __( "Define the font color for the title in the timeline break item.", "js_composer" ),
							"dependency"        		=> "",
							"group" 			        => "Additional Info",
						),
						array(
							"type"              		=> "textfield",
							"heading"           		=> __( "Start Term", "js_composer" ),
							"param_name"        		=> "timeline_start",
							"value"             		=> "",
							"description"       		=> __( "Enter an optional start term for the Isotope Timeline.", "js_composer" ),
							"group" 			        => "Additional Info",
						),
						array(
							"type"              		=> "textfield",
							"heading"           		=> __( "End Term", "js_composer" ),
							"param_name"        		=> "timeline_end",
							"value"             		=> "",
							"description"       		=> __( "Enter an optional end term for the Isotope Timeline.", "js_composer" ),
							"group" 			        => "Additional Info",
						),
						array(
							"type"              		=> "dropdown",
							"heading"           		=> __( "Alignment", "js_composer" ),
							"param_name"        		=> "title_align",
							"width"             		=> 200,
							"value"             		=> array(
								__( 'Center', "js_composer" )      	=> "center",
								__( 'Left', "js_composer" )         => "left",
								__( 'Right', "js_composer" )       	=> "right",
								__( 'Justify', "js_composer" )		=> "justify",
							),
							"description"       		=> __( "Select how the title in the timeline break item should be aligned.", "js_composer" ),
							"group" 			        => "Additional Info",
						),
						array(
							"type"              		=> "textarea_raw_html",
							"heading"           		=> __( "Description", "js_composer" ),
							"param_name"        		=> "timeline_description",
							"value"             		=> base64_encode(""),
							"description"       		=> __( "Enter a description for the the overall timeline, shown at the beginning; HTML code can be used.", "js_composer" ),
							"dependency"        		=> "",
							"group" 			        => "Additional Info",
						),
						array(
							"type"              		=> "dropdown",
							"heading"           		=> __( "Alignment", "js_composer" ),
							"param_name"        		=> "timeline_description_align",
							"width"             		=> 200,
							"value"             		=> array(
								__( 'Center', "js_composer" )      	=> "center",
								__( 'Left', "js_composer" )         => "left",
								__( 'Right', "js_composer" )       	=> "right",
								__( 'Justify', "js_composer" )		=> "justify",
							),
							"description"       		=> __( "Select how the description text should be aligned.", "js_composer" ),
							"group" 			        => "Additional Info",
						),
						array(
							"type"              		=> "colorpicker",
							"heading"           		=> __( "Content Color", "js_composer" ),
							"param_name"        		=> "timeline_description_color",
							"value"             		=> "#7c7979",
							"description"       		=> __( "Define the font color for the content in the timeline break item.", "js_composer" ),
							"dependency"        		=> "",
							"group" 			        => "Additional Info",
						),
                        // Other Settings
                        array(
                            "type"                      => "seperator",
                            "heading"                   => __( "", "js_composer" ),
                            "param_name"                => "seperator_3",
                            "value"                     => "Other Settings",
                            "description"               => __( "", "js_composer" ),
							"group" 			        => "Other Settings",
                        ),
                        array(
                            "type"                      => "nouislider",
                            "heading"                   => __( "Margin Top", "js_composer" ),
                            "param_name"                => "margin_top",
                            "value"                     => "0",
                            "min"                       => "0",
                            "max"                       => "200",
                            "step"                      => "1",
                            "unit"                      => 'px',
                            "description"               => __( "", "js_composer" ),
							"group" 			        => "Other Settings",
                        ),
                        array(
                            "type"                      => "nouislider",
                            "heading"                   => __( "Margin Bottom", "js_composer" ),
                            "param_name"                => "margin_bottom",
                            "value"                     => "0",
                            "min"                       => "0",
                            "max"                       => "200",
                            "step"                      => "1",
                            "unit"                      => 'px',
                            "description"               => __( "", "js_composer" ),
							"group" 			        => "Other Settings",
                        ),
                        array(
                            "type"                      => "textfield",
                            "heading"                   => __( "Define ID Name", "js_composer" ),
                            "param_name"                => "el_id",
                            "value"                     => "",
                            "description"               => __( "Enter an unique ID for the Isotope Timeline Container.", "js_composer" ),
							"group" 			        => "Other Settings",
                        ),
                        array(
                            "type"                      => "textfield",
                            "heading"                   => __( "Extra Class Name", "js_composer" ),
                            "param_name"                => "el_class",
                            "value"                     => "",
                            "description"               => __( "Enter a class name for the Isotope Timeline Container.", "js_composer" ),
							"group" 			        => "Other Settings",
                        ),
                        // Load Custom CSS/JS File
                        array(
                            "type"                      => "load_file",
                            "heading"                   => __( "", "js_composer" ),
                            "param_name"                => "el_file",
                            "value"                     => "",
                            "file_type"                 => "js",
                            "file_path"                 => "js/ts-visual-composer-extend-element.min.js",
                            "description"               => __( "", "js_composer" )
                        ),
                    ),
                    "js_view"                           => 'VcColumnView'
                ));
            }
		}
	}
}
// Register Container and Child Shortcode with Visual Composer
if (class_exists('WPBakeryShortCodesContainer')) {
    class WPBakeryShortCode_TS_VCSC_Timeline_Container extends WPBakeryShortCodesContainer {}
}
if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_TS_VCSC_Timeline_Single extends WPBakeryShortCode {}
}
// Initialize "TS Teaser Blocks" Class
if (class_exists('TS_Timelines')) {
	$TS_Timelines = new TS_Timelines;
}