<?php
    if (function_exists('vc_map')) {
        vc_map( array(
            "name"                      => __( "TS Circle Counter", "js_composer" ),
            "base"                      => "TS-VCSC-Circliful",
            "icon" 	                    => "icon-wpb-ts_vcsc_circliful",
            "class"                     => "",
            "category"                  => __( 'VC Extensions', 'js_composer' ),
            "description"               => __("Place a circle counter element", "js_composer"),
            //"admin_enqueue_js"        => array(ts_fb_get_resource_url('/Core/JS/jquery.js-composer.fb-album.js')),
            //"admin_enqueue_css"       => array(ts_fb_get_resource_url('/Core/CSS/jquery.js-composer.fb-album.css')),
            "params"                    => array(
                // Circliful Settings
                array(
                    "type"              => "seperator",
                    "heading"           => __( "", "js_composer" ),
                    "param_name"        => "seperator_1",
                    "value"             => "Circle Counter Settings",
                    "description"       => __( "", "js_composer" )
                ),
				array(
					"type"              => "colorpicker",
					"heading"           => __( "Foreground Color", "js_composer" ),
					"param_name"        => "color_foreground",
					"value"             => "#117d8b",
					"description"       => __( "Define the foreground color of the counter (displaying the animated value).", "js_composer" ),
					"dependency"        => ""
				),
				array(
					"type"              => "colorpicker",
					"heading"           => __( "Background Color", "js_composer" ),
					"param_name"        => "color_background",
					"value"             => "#eeeeee",
					"description"       => __( "Define the background color of the counter (displaying the line on which the animation occurs).", "js_composer" ),
					"dependency"        => ""
				),
				
                array(
                    "type"              => "dropdown",
                    "heading"           => __( "Line Border Type", "js_composer" ),
                    "param_name"        => "circle_border",
                    "width"             => 150,
                    "value"             => array(
                        __( 'Default', "js_composer" )        	=> "default",
                        __( 'Inline', "js_composer" )          	=> "inline",
                        __( 'Outline', "js_composer" )        	=> "outline",
                    ),
                    "description"       => __( "Select what kind of animated line border should be used.", "js_composer" )
                ),
				
				array(
					"type"				=> "switch",
                    "heading"           => __( "Add Inner Circle Color", "js_composer" ),
                    "param_name"        => "circle_fill",
                    "value"             => "false",
					"on"				=> __( 'Yes', "js_composer" ),
					"off"				=> __( 'No', "js_composer" ),
					"style"				=> "select",
					"design"			=> "toggle-light",
                    "description"       => __( "Switch the toggle if you want to add a color to the inner circle area.", "js_composer" ),
                    "dependency"        => ""
				),
				array(
					"type"              => "colorpicker",
					"heading"           => __( "Circle Background Color", "js_composer" ),
					"param_name"        => "circle_inside",
					"value"             => "#ffffff",
					"description"       => __( "Define the background color for the inner circle area.", "js_composer" ),
					"dependency"        => array( 'element' => "circle_fill", 'value' => 'true' )
				),
				array(
					"type"				=> "switch",
                    "heading"           => __( "Responsive Circle Counter", "js_composer" ),
                    "param_name"        => "circle_responsive",
                    "value"             => "true",
					"on"				=> __( 'Yes', "js_composer" ),
					"off"				=> __( 'No', "js_composer" ),
					"style"				=> "select",
					"design"			=> "toggle-light",
                    "description"       => __( "Switch the toggle if you want the circle counter to be responsive", "js_composer" ),
                    "dependency"        => ""
				),
                array(
                    "type"              => "nouislider",
                    "heading"           => __( "Maximum Circle Size", "js_composer" ),
                    "param_name"        => "circle_maxsize",
                    "value"             => "250",
                    "min"               => "1",
                    "max"               => "1024",
                    "step"              => "1",
                    "unit"              => 'px',
                    "description"       => __( "Define the maximum allowed size of the circle counter; otherwise maximum available column space will be used.", "js_composer" ),
					"dependency"        => array( 'element' => "circle_responsive", 'value' => 'true' )
                ),
                array(
                    "type"              => "nouislider",
                    "heading"           => __( "Circle Size", "js_composer" ),
                    "param_name"        => "circle_dimension",
                    "value"             => "200",
                    "min"               => "1",
                    "max"               => "1024",
                    "step"              => "1",
                    "unit"              => 'px',
                    "description"       => __( "Define the fixed size of the circle counter in pixel.", "js_composer" ),
					"dependency"        => array( 'element' => "circle_responsive", 'value' => 'false' )
                ),
                array(
                    "type"              => "nouislider",
                    "heading"           => __( "Circle Thickness in px", "js_composer" ),
                    "param_name"        => "circle_thickness",
                    "value"             => "5",
                    "min"               => "1",
                    "max"               => "25",
                    "step"              => "1",
                    "unit"              => 'px',
                    "description"       => __( "Define the thickness of the circle lines.", "js_composer" )
                ),
				array(
					"type"				=> "switch",
                    "heading"           => __( "Show as Half-Circle", "js_composer" ),
                    "param_name"        => "circle_half",
                    "value"             => "false",
					"on"				=> __( 'Yes', "js_composer" ),
					"off"				=> __( 'No', "js_composer" ),
					"style"				=> "select",
					"design"			=> "toggle-light",
                    "description"       => __( "Switch the toggle if you want to show the circle counter as half-circle.", "js_composer" ),
                    "dependency"        => ""
				),
                // Circliful Values
                array(
                    "type"              => "seperator",
                    "heading"           => __( "", "js_composer" ),
                    "param_name"        => "seperator_2",
                    "value"             => "Animated Label",
                    "description"       => __( "", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
                array(
                    "type"              => "nouislider",
                    "heading"           => __( "Animated Circle Value", "js_composer" ),
                    "param_name"        => "circle_percent",
                    "value"             => "15",
                    "min"               => "1",
                    "max"               => "100",
                    "step"              => "1",
                    "unit"              => '%',
					"admin_label"       => true,
                    "description"       => __( "Define the value in percent the circle should animate to.", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
                array(
                    "type"              => "nouislider",
                    "heading"           => __( "Animation Speed", "js_composer" ),
                    "param_name"        => "circle_speed",
                    "value"             => "1",
                    "min"               => "0",
                    "max"               => "10",
                    "step"              => "1",
                    "unit"              => '',
                    "description"       => __( "Define the speed of the circle counter animation.", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
                array(
                    "type"              => "textfield",
                    "heading"           => __( "Animated Label Value", "js_composer" ),
                    "param_name"        => "circle_value_text",
                    "value"             => "",
                    "admin_label"       => true,
                    "description"       => __( "Enter an optional integer (numeric) value to be used as circle label; can be different from 'Animated Circle Value'.", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
				array(
                    "type"              => "nouislider",
                    "heading"           => __( "Font Size", "js_composer" ),
                    "param_name"        => "circle_font_size",
                    "value"             => "30",
                    "min"               => "10",
                    "max"               => "100",
                    "step"              => "1",
                    "unit"              => 'px',
                    "description"       => __( "Define the font-size in px for the animated label value.", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
                array(
                    "type"              => "textfield",
                    "heading"           => __( "Main Text - Prefix Unit", "js_composer" ),
                    "param_name"        => "circle_value_pre",
                    "value"             => "",
                    "description"       => __( "Enter a prefix (i.e. $) for the animated circle label.", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
                array(
                    "type"              => "textfield",
                    "heading"           => __( "Main Text - Postfix Unit", "js_composer" ),
                    "param_name"        => "circle_value_post",
                    "value"             => "",
                    "description"       => __( "Enter a postfix (i.e. %) for the animated circle label.", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
                array(
                    "type"              => "dropdown",
                    "heading"           => __( "Thousand Seperator", "js_composer" ),
                    "param_name"        => "circle_value_group",
                    "width"             => 150,
                    "value"             => array(
                        __( 'Comma', "js_composer" )        => ",",
                        __( 'Dot', "js_composer" )          => ".",
                        __( 'Space', "js_composer" )        => " ",
                    ),
                    "description"       => __( "Select a character to seperate thousands in the circle label number.", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
                array(
                    "type"              => "dropdown",
                    "heading"           => __( "Decimals Seperator", "js_composer" ),
                    "param_name"        => "circle_value_seperator",
                    "width"             => 150,
                    "value"             => array(
						__( 'Dot', "js_composer" )          => ".",
                        __( 'Comma', "js_composer" )        => ",",
                        __( 'Space', "js_composer" )        => " ",
                    ),
                    "description"       => __( "Select a character to seperate thousands in the circle label number.", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
                /*array(
                    "type"              => "nouislider",
                    "heading"           => __( "Number of Decimals", "js_composer" ),
                    "param_name"        => "circle_value_decimals",
                    "value"             => "0",
                    "min"               => "0",
                    "max"               => "4",
                    "step"              => "1",
                    "unit"              => '',
                    "description"       => __( "Define the number of decimals for the circle label number.", "js_composer" ),
					"group" 			=> "Counter Values",
                ),*/
                array(
                    "type"              => "seperator",
                    "heading"           => __( "", "js_composer" ),
                    "param_name"        => "seperator_3",
                    "value"             => "Info Label",
                    "description"       => __( "", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
                array(
                    "type"              => "textfield",
                    "heading"           => __( "Info Label", "js_composer" ),
                    "param_name"        => "circle_value_info",
                    "value"             => "",
                    "admin_label"       => true,
                    "description"       => __( "Enter an optional text the inner circle info label; usually what the animated value represents.", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
				array(
                    "type"              => "nouislider",
                    "heading"           => __( "Font Size (Info)", "js_composer" ),
                    "param_name"        => "circle_info_size",
                    "value"             => "15",
                    "min"               => "10",
                    "max"               => "100",
                    "step"              => "1",
                    "unit"              => 'px',
                    "description"       => __( "Define the font-size in px for the inner circle info label.", "js_composer" ),
					"group" 			=> "Counter Values",
                ),
				// Circliful Icon / Image
                array(
                    "type"              => "seperator",
                    "heading"           => __( "", "js_composer" ),
                    "param_name"        => "seperator_4",
                    "value"             => "Circle Counter Icon / Image",
                    "description"       => __( "", "js_composer" ),
					"group" 			=> "Icon / Image",
                ),
				array(
					"type"				=> "switch",
                    "heading"           => __( "Use Normal Image", "js_composer" ),
                    "param_name"        => "circle_icon_replace",
                    "value"             => "false",
					"on"				=> __( 'Yes', "js_composer" ),
					"off"				=> __( 'No', "js_composer" ),
					"style"				=> "select",
					"design"			=> "toggle-light",
                    "description"       => __( "Switch the toggle if you want to use an image instead of a font icon.", "js_composer" ),
                    "dependency"        => "",
					"group" 			=> "Icon / Image",
				),
                array(
                    "type"              => "icons_panel",
                    "heading"           => __( "Select Icon", "js_composer" ),
                    "param_name"        => "circle_icon",
                    "value"             => $this->TS_VCSC_List_Icons_Full,
                    "admin_label"       => true,
                    "description"       => __( "Select the an icon for the circle counter.", "js_composer" ),
                    "dependency"        => "",
					"dependency"        => array( 'element' => "circle_icon_replace", 'value' => 'false' ),
					"group" 			=> "Icon / Image",
                ),
				array(
					"type"              => "attach_image",
					"heading"           => __( "Select Image", "js_composer" ),
					"param_name"        => "circle_image",
					"value"             => "false",
					"description"       => __( "Image must have equal dimensions for scaling purposes (i.e. 100x100)", "js_composer" ),
					"dependency"        => array( 'element' => "circle_icon_replace", 'value' => 'true' ),
					"group" 			=> "Icon / Image",
				),
				array(
					"type"              => "colorpicker",
					"heading"           => __( "Icon Color", "js_composer" ),
					"param_name"        => "circle_icon_color",
					"value"             => "#eeeeee",
					"description"       => __( "Define the color for the circle icon.", "js_composer" ),
					"dependency"        => array( 'element' => "circle_icon_replace", 'value' => 'false' ),
					"group" 			=> "Icon / Image",
				),
                array(
                    "type"              => "dropdown",
                    "heading"           => __( "Icon / Image Position", "js_composer" ),
                    "param_name"        => "circle_icon_position",
                    "width"             => 150,
                    "value"             => array(
                        __( 'Left', "js_composer" )     => "left",
                        __( 'Right', "js_composer" )    => "right",
					),
                    "description"       => __( "Select how to position the icon / image in relation to the main text.", "js_composer" ),
					"group" 			=> "Icon / Image",
                ),
				array(
					"type"              => "nouislider",
					"heading"           => __( "Icon / Image Size", "js_composer" ),
					"param_name"        => "circle_icon_size",
					"value"             => "30",
					"min"               => "10",
					"max"               => "200",
					"step"              => "1",
					"unit"              => 'px',
					"description"       => __( "Select the size for the icon / image used for the circle counter element.", "js_composer" ),
					"group" 			=> "Icon / Image",
				),
				// Other Settings
				array(
					"type"              => "seperator",
					"heading"           => __( "", "js_composer" ),
					"param_name"        => "seperator_5",
					"value"             => "Other Settings",
					"description"       => __( "", "js_composer" ),
					"group" 			=> "Other Settings",
				),
				array(
					"type"              => "nouislider",
					"heading"           => __( "Margin Top", "js_composer" ),
					"param_name"        => "margin_top",
					"value"             => "0",
					"min"               => "-50",
					"max"               => "200",
					"step"              => "1",
					"unit"              => 'px',
					"description"       => __( "Select the top margin for the circle counter element.", "js_composer" ),
					"group" 			=> "Other Settings",
				),
				array(
					"type"              => "nouislider",
					"heading"           => __( "Margin Bottom", "js_composer" ),
					"param_name"        => "margin_bottom",
					"value"             => "0",
					"min"               => "-50",
					"max"               => "200",
					"step"              => "1",
					"unit"              => 'px',
					"description"       => __( "Select the bottom margin for the circle counter element.", "js_composer" ),
					"group" 			=> "Other Settings",
				),
				array(
					"type"              => "textfield",
					"heading"           => __( "Define ID Name", "js_composer" ),
					"param_name"        => "el_id",
					"value"             => "",
					"description"       => __( "Enter a unique ID name for the circle counter element.", "js_composer" ),
					"group" 			=> "Other Settings",
				),
				array(
					"type"              => "textfield",
					"heading"           => __( "Extra Class Name", "js_composer" ),
					"param_name"        => "el_class",
					"value"             => "",
					"description"       => __( "Enter a class name for the circle counter element.", "js_composer" ),
					"group" 			=> "Other Settings",
				),
				// Load Custom CSS/JS File
				array(
					"type"              => "load_file",
					"heading"           => __( "", "js_composer" ),
                    "param_name"        => "el_file",
					"value"             => "",
					"file_type"         => "js",
					"file_path"         => "js/ts-visual-composer-extend-element.min.js",
					"description"       => __( "", "js_composer" )
				),
            ))
        );
    }
?>