<?php
    if (function_exists('vc_map')) {
        vc_map( array(
            "name"                      	=> __( "TS Icon Button", "js_composer" ),
            "base"                      	=> "TS_VCSC_Icon_Button",
            "icon" 	                    	=> "icon-wpb-ts_vcsc_icon_button",
            "class"                     	=> "",
            "category"                  	=> __( 'VC Extensions', 'js_composer' ),
            "description"               	=> __("Place an icon button element", "js_composer"),
            //"admin_enqueue_js"        	=> array(ts_fb_get_resource_url('/Core/JS/jquery.js-composer.fb-album.js')),
            //"admin_enqueue_css"       	=> array(ts_fb_get_resource_url('/Core/CSS/jquery.js-composer.fb-album.css')),
            "params"                    	=> array(
                // Link Settings
                array(
                    "type"              	=> "seperator",
                    "heading"           	=> __( "", "js_composer" ),
                    "param_name"        	=> "seperator_1",
                    "value"             	=> "Link + Title Settings",
                    "description"       	=> __( "", "js_composer" )
                ),
				array(
					"type" 					=> "vc_link",
					"heading" 				=> __("Link + Title", "js_composer"),
					"param_name" 			=> "link",
					"description" 			=> __("Provide a link to another site/page for the Icon Button.", "js_composer")
				),
				array(
					"type"					=> "switch",
					"heading"				=> __( "Use CSS3 Tooltip", "js_composer" ),
					"param_name"			=> "tooltip_css",
					"value"					=> "false",
					"on"					=> __( 'Yes', "js_composer" ),
					"off"					=> __( 'No', "js_composer" ),
					"style"					=> "select",
					"design"				=> "toggle-light",
					"description"       	=> __( "Switch the toggle if you want to apply a CSS3 tooltip to the image.", "js_composer" ),
                    "dependency"        	=> ""
				),
				array(
					"type"					=> "dropdown",
					"class"					=> "",
					"heading"				=> __( "Tooltip Position", 'js_composer' ),
					"param_name"			=> "tooltip_position",
					"value"					=> $this->TS_VCSC_ImageTooltip_Position,
					"description"			=> __( "Select the tooltip position in relation to the image.", "js_composer" ),
					"dependency"			=> array( 'element' => "tooltip_css", 'value' => 'true' )
				),
				array(
					"type"					=> "dropdown",
					"class"					=> "",
					"heading"				=> __( "Tooltip Style", 'js_composer' ),
					"param_name"			=> "tooltip_style",
					"value"					=> $this->TS_VCSC_Tooltip_Style,
					"description"			=> __( "Select the tooltip style.", "js_composer" ),
					"dependency"			=> array( 'element' => "tooltip_css", 'value' => 'true' )
				),
				// Button Settings
                array(
                    "type"              	=> "seperator",
                    "heading"           	=> __( "", "js_composer" ),
                    "param_name"        	=> "seperator_2",
                    "value"             	=> "Button Settings",
                    "description"       	=> __( "", "js_composer" )
                ),
				array(
					"type"              	=> "dropdown",
					"heading"           	=> __( "Button Align", "js_composer" ),
					"param_name"        	=> "button_align",
					"width"             	=> 300,
					"value"             	=> array(
						__( 'Center', "js_composer" )      	=> "center",
						__( 'Left', "js_composer" )			=> "left",
						__( 'Right', "js_composer" )  		=> "right",
					),
					"description"       	=> __( "Select how the icon button should be aligned.", "js_composer" ),
				),
                array(
                    "type"                  => "nouislider",
                    "heading"               => __( "Button Width", "js_composer" ),
                    "param_name"            => "button_width",
                    "value"                 => "100",
                    "min"                   => "0",
                    "max"                   => "100",
                    "step"                  => "1",
                    "unit"                  => '%',
					"description"       	=> __( "Define the button width in percent (responsive).", "js_composer" ),
                    "dependency"			=> array( 'element' => "button_type", 'value' => array('square', 'rounded', 'pill') )
                ),
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Button Type", "js_composer" ),
                    "param_name"            => "button_type",
                    "width"                 => 300,
                    "value"                 => $this->TS_VCSC_Button_Types,
                    "admin_label"           => true,
                    "description"           => __( "Select the general button type for the 'Read More' Link.", "js_composer" ),
					"dependency"        	=> ""
                ),
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Button Style", "js_composer" ),
                    "param_name"            => "button_square",
                    "width"                 => 300,
                    "value"                 => $this->TS_VCSC_Button_Square,
                    "admin_label"           => true,
                    "description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
					"dependency"			=> array( 'element' => "button_type", 'value' => 'square' )
                ),
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Button Style", "js_composer" ),
                    "param_name"            => "button_rounded",
                    "width"                 => 300,
                    "value"                 => $this->TS_VCSC_Button_Rounded,
                    "admin_label"           => true,
                    "description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
					"dependency"			=> array( 'element' => "button_type", 'value' => 'rounded' )
                ),
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Button Style", "js_composer" ),
                    "param_name"            => "button_pill",
                    "width"                 => 300,
                    "value"                 => $this->TS_VCSC_Button_Pill,
                    "admin_label"           => true,
                    "description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
					"dependency"			=> array( 'element' => "button_type", 'value' => 'pill' )
                ),
                array(
                    "type"                  => "dropdown",
                    "heading"               => __( "Button Style", "js_composer" ),
                    "param_name"            => "button_circle",
                    "width"                 => 300,
                    "value"                 => $this->TS_VCSC_Button_Circle,
                    "admin_label"           => true,
                    "description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
					"dependency"			=> array( 'element' => "button_type", 'value' => 'circle' )
                ),
				array(
					"type"              	=> "dropdown",
					"heading"           	=> __( "Button Size", "js_composer" ),
					"param_name"        	=> "button_size",
					"width"             	=> 300,
					"value"             	=> array(
						__( 'Normal', "js_composer" )		=> "ts-button-normal",
						__( 'Small', "js_composer" )      	=> "ts-button-small",
						__( 'Tiny', "js_composer" )  		=> "ts-button-tiny",
						__( 'Large', "js_composer" )  		=> "ts-button-large",
						__( 'Jumbo', "js_composer" )  		=> "ts-button-jumbo",
					),
					"description"       	=> __( "Select the size for the icon button.", "js_composer" ),
					"dependency"			=> array( 'element' => "button_type", 'value' => array('square', 'rounded', 'pill') )
				),
				array(
					"type"					=> "switch",
                    "heading"           	=> __( "Add Button Wrapper", "js_composer" ),
                    "param_name"        	=> "button_wrapper",
                    "value"             	=> "false",
					"on"					=> __( 'Yes', "js_composer" ),
					"off"					=> __( 'No', "js_composer" ),
					"style"					=> "select",
					"design"				=> "toggle-light",
					"description"       	=> __( "Switch the toggle to add a wrapper frame around the 'Read More' button (most suited for 'pill' and 'circle' buttons).", "js_composer" ),
                    "dependency"        	=> ""
				),
				array(
					"type"              	=> "textfield",
					"heading"           	=> __( "Button Text", "js_composer" ),
					"param_name"        	=> "button_text",
					"value"             	=> "Read More",
					"description"       	=> __( "Enter a text for the 'Read More' button.", "js_composer" ),
					"dependency"        	=> ""
				),
				array(
					"type"					=> "switch",
                    "heading"           	=> __( "Change Font Color", "js_composer" ),
                    "param_name"        	=> "button_change",
                    "value"             	=> "false",
					"on"					=> __( 'Yes', "js_composer" ),
					"off"					=> __( 'No', "js_composer" ),
					"style"					=> "select",
					"design"				=> "toggle-light",
					"description"       	=> __( "Switch the toggle to apply a custom font color to the button text.", "js_composer" ),
                    "dependency"        	=> ""
				),
				array(
					"type"              	=> "colorpicker",
					"heading"           	=> __( "Text Color", "js_composer" ),
					"param_name"        	=> "button_color",
					"value"             	=> "#666666",
					"description"       	=> __( "Define the color of the text for the button.", "js_composer" ),
					"dependency"			=> array( 'element' => "button_change", 'value' => 'true' )
				),
                array(
                    "type"                  => "nouislider",
                    "heading"               => __( "Font Size", "js_composer" ),
                    "param_name"            => "button_font",
                    "value"                 => "18",
                    "min"                   => "4",
                    "max"                   => "100",
                    "step"                  => "1",
                    "unit"                  => 'px',
					"description"       	=> __( "Define the font size for the icon / text in the button.", "js_composer" ),
                    "dependency"			=> array( 'element' => "button_type", 'value' => 'circle' )
                ),
				// Icon Settings
                array(
                    "type"              	=> "seperator",
                    "heading"           	=> __( "", "js_composer" ),
                    "param_name"        	=> "seperator_3",
                    "value"             	=> "Icon Settings",
                    "description"       	=> __( "", "js_composer" ),
					"group" 				=> "Icon Settings",
                ),
				array(
					"type"              	=> "icons_panel",
					"heading"           	=> __( "Button Icon", "js_composer" ),
					"param_name"        	=> "icon",
					"value"             	=> $this->TS_VCSC_List_Icons_Full,
					"admin_label"       	=> true,
					"description"       	=> __( "Select the icon you want to display in button.", "js_composer" ),
					"dependency"        	=> "",
					"group" 				=> "Icon Settings",
				),
				array(
					"type"					=> "switch",
                    "heading"           	=> __( "Change Icon Color", "js_composer" ),
                    "param_name"        	=> "icon_change",
                    "value"             	=> "false",
					"on"					=> __( 'Yes', "js_composer" ),
					"off"					=> __( 'No', "js_composer" ),
					"style"					=> "select",
					"design"				=> "toggle-light",
					"description"       	=> __( "Switch the toggle to apply a custom color to the button icon.", "js_composer" ),
                    "dependency"        	=> "",
					"group" 				=> "Icon Settings",
				),
				array(
					"type"              	=> "colorpicker",
					"heading"           	=> __( "Icon Color", "js_composer" ),
					"param_name"        	=> "icon_color",
					"value"             	=> "#666666",
					"description"       	=> __( "Define the color of the icon for the button.", "js_composer" ),
					"dependency"			=> array( 'element' => "icon_change", 'value' => 'true' ),
					"group" 				=> "Icon Settings",
				),
				// Other Settings
				array(
					"type"				    => "seperator",
					"heading"			    => __( "", "js_composer" ),
					"param_name"		    => "seperator_4",
					"value"				    => "Other Settings",
					"description"		    => __( "", "js_composer" ),
					"group" 				=> "Other Settings",
				),
                array(
                    "type"                  => "nouislider",
                    "heading"               => __( "Margin Top", "js_composer" ),
                    "param_name"            => "margin_top",
                    "value"                 => "20",
                    "min"                   => "0",
                    "max"                   => "200",
                    "step"                  => "1",
                    "unit"                  => 'px',
                    "description"           => __( "", "js_composer" ),
					"group" 				=> "Other Settings",
                ),
                array(
                    "type"                  => "nouislider",
                    "heading"               => __( "Margin Bottom", "js_composer" ),
                    "param_name"            => "margin_bottom",
                    "value"                 => "20",
                    "min"                   => "0",
                    "max"                   => "200",
                    "step"                  => "1",
                    "unit"                  => 'px',
                    "description"           => __( "", "js_composer" ),
					"group" 				=> "Other Settings",
                ),
				array(
					"type"                  => "textfield",
					"heading"               => __( "Define ID Name", "js_composer" ),
					"param_name"            => "el_id",
					"value"                 => "",
					"description"           => __( "Enter a unique ID name for the icon button element.", "js_composer" ),
					"group" 				=> "Other Settings",
				),
				array(
					"type"                  => "textfield",
					"heading"               => __( "Extra Class Name", "js_composer" ),
					"param_name"            => "el_class",
					"value"                 => "",
					"description"           => __( "Enter a class name for the icon button element.", "js_composer" ),
					"group" 				=> "Other Settings",
				),
				// Load Custom CSS/JS File
				array(
					"type"              	=> "load_file",
					"heading"           	=> __( "", "js_composer" ),
                    "param_name"        	=> "el_file",
					"value"             	=> "",
					"file_type"         	=> "js",
					"file_path"         	=> "js/ts-visual-composer-extend-element.min.js",
					"description"       	=> __( "", "js_composer" )
				),
            ))
        );
    }
?>