<?php
    if (function_exists('vc_map')) {
        vc_map( array(
            "name"                          		=> __( "TS Image Full", 'js_composer' ),
            "base"                          		=> "TS_VCSC_Image_Full",
            "icon"                          		=> "icon-wpb-ts_vcsc_image_full",
            "class"                         		=> "ts_vcsc_main_image_full",
            "category"                      		=> __( "VC Extensions", "js_composer" ),
            "description" 		            		=> __("Place a full width image", "js_composer"),
            "animation"                     		=> "",
            //"admin_enqueue_js"            		=> array(ts_fb_get_resource_url('/js/...')),
            //"admin_enqueue_css"           		=> array(ts_fb_get_resource_url('/css/...')),
            "params"                        		=> array(
                // Image Selection and Breakout
                array(
                    "type"                  		=> "seperator",
                    "heading"               		=> __( "", "js_composer" ),
                    "param_name"            		=> "seperator_1",
                    "value"                 		=> "Image Selection",
                    "description"           		=> __( "", "js_composer" )
                ),
                array(
                    "type"                  		=> "attach_image",
					"holder" 						=> "img",
                    "heading"               		=> __( "Image", "js_composer" ),
                    "param_name"            		=> "image",
					"class"							=> "ts_vcsc_holder_image",
                    "value"                 		=> "",
                    "admin_label"           		=> false,
                    "description"           		=> __( "Select the image you want to use.", "js_composer" )
                ),
				array(
					"type"             	 				=> "switch",
					"heading"			    		=> __( "Add Custom ALT Attribute", "js_composer" ),
					"param_name"		    		=> "attribute_alt",
					"value"				    		=> "false",
					"on"							=> __( 'Yes', "js_composer" ),
					"off"							=> __( 'No', "js_composer" ),
					"style"							=> "select",
					"design"						=> "toggle-light",
                    "description"       			=> __( "Switch the toggle if you want to add a custom ALT attribute value, otherwise file name will be set.", "js_composer" ),
                    "dependency"        			=> ""
				),
                array(
                    "type"                  		=> "textfield",
                    "heading"               		=> __( "Enter ALT Value", "js_composer" ),
                    "param_name"            		=> "attribute_alt_value",
                    "value"                 		=> "",
                    "description"           		=> __( "Enter a custom value for the ALT attribute for this image.", "js_composer" ),
                    "dependency"            		=> array( 'element' => "attribute_alt", 'value' => 'true' )
                ),
				array(
					"type"                  		=> "nouislider",
					"heading"               		=> __( "Full Width Breakouts", "js_composer" ),
					"param_name"            		=> "break_parents",
					"value"                 		=> "5",
					"min"                   		=> "0",
					"max"                   		=> "99",
					"step"                  		=> "1",
					"unit"                  		=> '',
					"admin_label"           		=> true,
					"description"           		=> __( "Define the number of Parent Containers the Background should attempt to break away from.", "js_composer" ),
				),
				// Margin Settings
                array(
                    "type"                  		=> "seperator",
                    "heading"               		=> __( "", "js_composer" ),
                    "param_name"            		=> "seperator_2",
                    "value"                 		=> "Other Settings",
                    "description"           		=> __( "", "js_composer" ),
					"group" 						=> "Image Margins",
                ),
				array(
					"type"                  		=> "nouislider",
					"heading"               		=> __( "Margin: Left", "js_composer" ),
					"param_name"            		=> "margin_left",
					"value"                 		=> "0",
					"min"                   		=> "-100",
					"max"                   		=> "100",
					"step"                  		=> "1",
					"unit"                  		=> 'px',
					"description"           		=> __( "If the image isn't exactly aligned, use left/right margins to adjust position.", "js_composer" ),
					"group" 						=> "Image Margins",
				),
				array(
					"type"                  		=> "nouislider",
					"heading"               		=> __( "Margin: Right", "js_composer" ),
					"param_name"            		=> "margin_right",
					"value"                 		=> "0",
					"min"                   		=> "-100",
					"max"                   		=> "100",
					"step"                  		=> "1",
					"unit"                  		=> 'px',
					"description"           		=> __( "If the image isn't exactly aligned, use left/right margins to adjust position.", "js_composer" ),
					"group" 						=> "Image Margins",
				),
                array(
                    "type"                  		=> "nouislider",
                    "heading"               		=> __( "Margin: Top", "js_composer" ),
                    "param_name"            		=> "margin_top",
                    "value"                 		=> "0",
                    "min"                   		=> "0",
                    "max"                   		=> "200",
                    "step"                  		=> "1",
                    "unit"                  		=> 'px',
                    "description"           		=> __( "Select the top margin for your image.", "js_composer" ),
					"group" 						=> "Image Margins",
                ),
                array(
                    "type"                  		=> "nouislider",
                    "heading"               		=> __( "Margin: Bottom", "js_composer" ),
                    "param_name"            		=> "margin_bottom",
                    "value"                 		=> "0",
                    "min"                   		=> "0",
                    "max"                   		=> "200",
                    "step"                  		=> "1",
                    "unit"                  		=> 'px',
                    "description"           		=> __( "Select the bottom margin for your image.", "js_composer" ),
					"group" 						=> "Image Margins",
                ),
                // Other Settings
                array(
                    "type"                  		=> "seperator",
                    "heading"               		=> __( "", "js_composer" ),
                    "param_name"            		=> "seperator_3",
                    "value"                 		=> "Other Settings",
                    "description"           		=> __( "", "js_composer" ),
					"group" 						=> "Other Settings",
                ),
                array(
                    "type"                  		=> "textfield",
                    "heading"               		=> __( "Define ID Name", "js_composer" ),
                    "param_name"            		=> "el_id",
                    "value"                 		=> "",
                    "description"           		=> __( "Enter an unique ID for the image.", "js_composer" ),
					"group" 						=> "Other Settings",
                ),
                array(
                    "type"                  		=> "textfield",
                    "heading"               		=> __( "Extra Class Name", "js_composer" ),
                    "param_name"            		=> "el_class",
                    "value"                 		=> "",
                    "description"           		=> __( "Enter a class name for the image.", "js_composer" ),
					"group" 						=> "Other Settings",
                ),
                // Load Custom CSS/JS File
                array(
                    "type"                  		=> "load_file",
                    "heading"               		=> __( "", "js_composer" ),
                    "param_name"            		=> "el_file",
                    "value"                 		=> "",
                    "file_type"             		=> "js",
                    "file_path"             		=> "js/ts-visual-composer-extend-element.min.js",
                    "description"           		=> __( "", "js_composer" )
                ),
            )
        ));
    }
?>