<?php
if (!class_exists('TS_Teaser_Blocks')){
	class TS_Teaser_Blocks {
		function __construct() {
            if (function_exists('vc_is_inline')){
                if (vc_is_inline()) {
                    add_action('init',                              	array($this, 'TS_VCSC_Add_Teaser_Block_Elements'), 9999999);
                } else {
                    add_action('admin_init',		                	array($this, 'TS_VCSC_Add_Teaser_Block_Elements'), 9999999);
                }
            } else {
                add_action('admin_init',								array($this, 'TS_VCSC_Add_Teaser_Block_Elements'), 9999999);
            }
			add_shortcode('TS_VCSC_Teaser_Block_Standalone',          	array($this, 'TS_VCSC_Teaser_Block_Standalone'));
			add_shortcode('TS_VCSC_Teaser_Block_Single',              	array($this, 'TS_VCSC_Teaser_Block_Single'));
			add_shortcode('TS_VCSC_Teaser_Block_Slider_Custom',       	array($this, 'TS_VCSC_Teaser_Block_Slider_Custom'));
		}
        
		// Standalone Teaser Block
		function TS_VCSC_Teaser_Block_Standalone ($atts) {
			global $VISUAL_COMPOSER_EXTENSIONS;
			ob_start();
		
			if ((get_option('ts_vcsc_extend_settings_loadHeader', 0) == 0)) {
				$FOOTER = true;
			} else {
				$FOOTER = false;
			}
	
			if (get_option('ts_vcsc_extend_settings_loadForcable', 0) == 0) {
				wp_enqueue_style('ts-extend-simptip',                 			TS_VCSC_GetResourceURL('css/jquery.simptip.css'), null, false, 'all');
				wp_enqueue_style('ts-extend-animations',                 		TS_VCSC_GetResourceURL('css/ts-visual-composer-extend-animations.min.css'), null, false, 'all');
				wp_enqueue_style('ts-extend-buttons',                 			TS_VCSC_GetResourceURL('css/jquery.buttons.css'), null, false, 'all');
				wp_enqueue_style('ts-visual-composer-extend-front',				TS_VCSC_GetResourceURL('css/ts-visual-composer-extend-front.min.css'), null, false, 'all');
				wp_enqueue_script('ts-visual-composer-extend-front',			TS_VCSC_GetResourceURL('js/ts-visual-composer-extend-front.min.js'), array('jquery'), false, $FOOTER);
			}
		
			extract( shortcode_atts( array(
				'image'							=> '',
				'image_responsive'				=> 'true',
				'image_width'					=> 300,
				'image_height'					=> 200,
				'attribute_alt'					=> 'false',
				'attribute_alt_value'			=> '',
				'overlay'						=> 'rgba(0,148,255,0.5)',
				'title'							=> '',
				
				'icon_position'					=> '',
				'icon'							=> '',
				'icon_size'						=> 18,
				'icon_color'					=> '#aaaaaa',
				'subtitle'						=> '',
				'link'							=> '',
				'button_type'					=> '',
				'button_square'					=> 'ts-button-3d',
				'button_rounded'				=> 'ts-button-3d ts-button-rounded',
				'button_pill'					=> 'ts-button-3d ts-button-pill',
				'button_circle'					=> 'ts-button-3d ts-button-circle',
				'button_wrapper'				=> 'false',
				'button_text'					=> 'Read More',
				'button_font'					=> 18,
				
				'margin_top'                    => 0,
				'margin_bottom'                 => 0,
				'el_id'                         => '',
				'el_class'                      => '',
			), $atts ));
	
			if (!empty($el_id)) {
				$image_teaser_id				= $el_id;
			} else {
				$image_teaser_id				= 'ts-vcsc-image-teaser-' . mt_rand(999999, 9999999);
			}
			
			// Teaser Link
			$link 								= ($link=='||') ? '' : $link;
			$link 								= vc_build_link($link);
			$a_href								= $link['url'];
			$a_title 							= $link['title'];
			$a_target 							= $link['target'];
	
			// Teaser Image
			if ($image_responsive == "true") {
				$teaser_image				= wp_get_attachment_image_src($image, 'full');
			} else {
				$teaser_image				= wp_get_attachment_image_src($image, array($image_width, $image_height));
			}
			$image_extension 				= pathinfo($teaser_image[0], PATHINFO_EXTENSION);
			if ($attribute_alt == "true") {
				$alt_attribute				= $attribute_alt_value;
			} else {
				$alt_attribute				= basename($teaser_image[0], "." . $image_extension);
			}
			
			// Teaser Button Type
			if ($button_type == "square") {
				$button_style				= $button_square;
				$button_font				= '';
			} else if ($button_type == "rounded") {
				$button_style				= $button_rounded;
				$button_font				= '';
			} else if ($button_type == "pill"){
				$button_style				= $button_pill;
				$button_font				= '';
			} else if ($button_type == "circle") {
				$button_style				= $button_circle;
				$button_font				= 'font-size: ' . $button_font . 'px;';
			} else {
				$button_style				= '';
				$button_font				= '';
			}
			
			// Teaser Icon Settings
			if ((!empty($icon)) && ($icon != "transparent") && ($icon_position != "")) {
				$icon_style                 = 'color: ' . $icon_color . '; width:' . $icon_size . 'px; height:' . $icon_size . 'px; font-size:' . $icon_size . 'px; line-height:' . $icon_size . 'px;';
			} else {
				$icon_style					= '';
			}
			
			$output = '';
		
			$output .= '<div id="' . $image_teaser_id . '" class="ts-teaser ' . $el_class . '" style="margin-top: ' . $margin_top . 'px; margin-bottom: ' . $margin_bottom . 'px;">';
				$output .= '<div class="ts-teaser-item">';
					$output .= '<div class="ts-teaser-padding">';
						$output .= '<div class="ts-teaser-image-container">';
							$output .= '<div class="ts-teaser-overlay"><div class="css-loader"></div></div>';
							$output .= '<a href="' . $a_href . '" target="' . $a_target . '">';
								$output .= '<img src="' . $teaser_image[0] . '" alt="' . $alt_attribute . '" class="ts-teaser-image">';
								$output .= '<span class="ts-teaser-hovercontent"></span>';
								$output .= '<span class="ts-teaser-hoverimage"></span>';
							$output .= '</a>';
						$output .= '</div>';
						$output .= '<div class="ts-teaser-head">';
							$output .= '<h2 class="ts-teaser-title">';
								if ((!empty($icon)) && ($icon != "transparent") && ($icon_position == "top")) {
									$output .= '<span style="display: block; width: 100%; text-align: center; margin-top: 15px; margin-bottom: 5px;"><i style="' . $icon_style . '" class="' . $icon . '"></i></span>';
								} else if ((!empty($icon)) && ($icon != "transparent") && ($icon_position == "left")) {
									$output .= '<i style="margin-right: 5px; ' . $icon_style . '" class="' . $icon . '"></i>';
								}
								$output .= '<a href="' . $a_href . '" target="' . $a_target . '">' . $title . '</a>';
								if ((!empty($icon)) && ($icon != "transparent") && ($icon_position == "right")) {
									$output .= '<i style="margin-left: 5px; ' . $icon_style . '" class="' . $icon . '"></i>';
								} else if ((!empty($icon)) && ($icon != "transparent") && ($icon_position == "bottom")) {
									$output .= '<span style="display: block; width: 100%; text-align: center; margin-top: 15px; margin-bottom: 5px;"><i style="' . $icon_style . '" class="' . $icon . '"></i></span>';
								}
							$output .= '</h2>';
						$output .= '</div>';
						$output .= '<div class="ts-teaser-seperator"></div>';
						$output .= '<div class="ts-teaser-text">';
							$output .= $subtitle;
						$output .= '</div>';
						if ($button_type != "") {
							if($button_wrapper == "true") {
								$output .= '<div class="ts-readmore-wrap"><span class="ts-button-wrap">';
							}
							$output .= '<a href="' . $a_href . '" target="' . trim($a_target) . '" class="ts-readmore ts-button ' . $button_style . '"><span>' . $button_text . '</span></a>';
							if($button_wrapper == "true") {
								$output .= '</span></div>';
							}
						}
					$output .= '</div>';
				$output .= '</div>';
			$output .= '</div>';
	
			echo $output;
			
			$myvariable = ob_get_clean();
			return $myvariable;
		}
		
		// Single Teaser Block for Custom Slider
		function TS_VCSC_Teaser_Block_Single ($atts) {
			global $VISUAL_COMPOSER_EXTENSIONS;
			ob_start();
		
			if ((get_option('ts_vcsc_extend_settings_loadHeader', 0) == 0)) {
				$FOOTER = true;
			} else {
				$FOOTER = false;
			}
	
			if (get_option('ts_vcsc_extend_settings_loadForcable', 0) == 0) {
				wp_enqueue_style('ts-extend-simptip',                 			TS_VCSC_GetResourceURL('css/jquery.simptip.css'), null, false, 'all');
				wp_enqueue_style('ts-extend-animations',                 		TS_VCSC_GetResourceURL('css/ts-visual-composer-extend-animations.min.css'), null, false, 'all');
				wp_enqueue_style('ts-extend-buttons',                 			TS_VCSC_GetResourceURL('css/jquery.buttons.css'), null, false, 'all');
				wp_enqueue_style('ts-visual-composer-extend-front',				TS_VCSC_GetResourceURL('css/ts-visual-composer-extend-front.min.css'), null, false, 'all');
				wp_enqueue_script('ts-visual-composer-extend-front',			TS_VCSC_GetResourceURL('js/ts-visual-composer-extend-front.min.js'), array('jquery'), false, $FOOTER);
			}
		
			extract( shortcode_atts( array(
				'image'							=> '',
				'image_responsive'				=> 'true',
				'image_width'					=> 300,
				'image_height'					=> 200,
				'attribute_alt'					=> 'false',
				'attribute_alt_value'			=> '',
				'overlay'						=> 'rgba(0,148,255,0.5)',
				'title'							=> '',
				
				'icon_position'					=> '',
				'icon'							=> '',
				'icon_size'						=> 18,
				'icon_color'					=> '#aaaaaa',
				'subtitle'						=> '',
				'link'							=> '',
				'button_type'					=> '',
				'button_square'					=> 'ts-button-3d',
				'button_rounded'				=> 'ts-button-3d ts-button-rounded',
				'button_pill'					=> 'ts-button-3d ts-button-pill',
				'button_circle'					=> 'ts-button-3d ts-button-circle',
				'button_wrapper'				=> 'false',
				'button_text'					=> 'Read More',
				'button_font'					=> 18,
			), $atts ));
			
			// Teaser Link
			$link 								= ($link=='||') ? '' : $link;
			$link 								= vc_build_link($link);
			$a_href								= $link['url'];
			$a_title 							= $link['title'];
			$a_target 							= $link['target'];
	
			// Teaser Image
			if ($image_responsive == "true") {
				$teaser_image				= wp_get_attachment_image_src($image, 'full');
			} else {
				$teaser_image				= wp_get_attachment_image_src($image, array($image_width, $image_height));
			}
			$image_extension 				= pathinfo($teaser_image[0], PATHINFO_EXTENSION);
			if ($attribute_alt == "true") {
				$alt_attribute				= $attribute_alt_value;
			} else {
				$alt_attribute				= basename($teaser_image[0], "." . $image_extension);
			}
			
			// Teaser Button Type
			if ($button_type == "square") {
				$button_style				= $button_square;
				$button_font				= '';
			} else if ($button_type == "rounded") {
				$button_style				= $button_rounded;
				$button_font				= '';
			} else if ($button_type == "pill"){
				$button_style				= $button_pill;
				$button_font				= '';
			} else if ($button_type == "circle") {
				$button_style				= $button_circle;
				$button_font				= 'font-size: ' . $button_font . 'px;';
			} else {
				$button_style				= '';
				$button_font				= '';
			}
			
			// Teaser Icon Settings
			if ((!empty($icon)) && ($icon != "transparent") && ($icon_position != "")) {
				$icon_style                 = 'color: ' . $icon_color . '; width:' . $icon_size . 'px; height:' . $icon_size . 'px; font-size:' . $icon_size . 'px; line-height:' . $icon_size . 'px;';
			} else {
				$icon_style					= '';
			}
			
			$output = '';
		
			$output .= '<div class="ts-teaser" style="width: 99%; margin: 0px auto; padding: 0px;">';
				$output .= '<div class="ts-teaser-item">';
					$output .= '<div class="ts-teaser-padding">';
						$output .= '<div class="ts-teaser-image-container">';
							$output .= '<div class="ts-teaser-overlay"><div class="css-loader"></div></div>';
							$output .= '<a href="' . $a_href . '" target="' . $a_target . '">';
								$output .= '<img src="' . $teaser_image[0] . '" alt="' . $alt_attribute . '" class="ts-teaser-image">';
								$output .= '<span class="ts-teaser-hovercontent"></span>';
								$output .= '<span class="ts-teaser-hoverimage"></span>';
							$output .= '</a>';
						$output .= '</div>';
						$output .= '<div class="ts-teaser-head">';
							$output .= '<h2 class="ts-teaser-title">';
								if ((!empty($icon)) && ($icon != "transparent") && ($icon_position == "top")) {
									$output .= '<span style="display: block; width: 100%; text-align: center; margin-top: 15px; margin-bottom: 5px;"><i style="' . $icon_style . '" class="' . $icon . '"></i></span>';
								} else if ((!empty($icon)) && ($icon != "transparent") && ($icon_position == "left")) {
									$output .= '<i style="margin-right: 5px; ' . $icon_style . '" class="' . $icon . '"></i>';
								}
								$output .= '<a href="' . $a_href . '" target="' . $a_target . '">' . $title . '</a>';
								if ((!empty($icon)) && ($icon != "transparent") && ($icon_position == "right")) {
									$output .= '<i style="margin-left: 5px; ' . $icon_style . '" class="' . $icon . '"></i>';
								} else if ((!empty($icon)) && ($icon != "transparent") && ($icon_position == "bottom")) {
									$output .= '<span style="display: block; width: 100%; text-align: center; margin-top: 15px; margin-bottom: 5px;"><i style="' . $icon_style . '" class="' . $icon . '"></i></span>';
								}
							$output .= '</h2>';
						$output .= '</div>';
						$output .= '<div class="ts-teaser-seperator"></div>';
						$output .= '<div class="ts-teaser-text">';
							$output .= $subtitle;
						$output .= '</div>';
						if ($button_type != "") {
							if($button_wrapper == "true") {
								$output .= '<div class="ts-readmore-wrap"><span class="ts-button-wrap">';
							}
							$output .= '<a href="' . $a_href . '" target="' . trim($a_target) . '" class="ts-readmore ts-button ' . $button_style . '"><span>' . $button_text . '</span></a>';
							if($button_wrapper == "true") {
								$output .= '</span></div>';
							}
						}
					$output .= '</div>';
				$output .= '</div>';
			$output .= '</div>';
	
			echo $output;
			
			$myvariable = ob_get_clean();
			return $myvariable;
		}
		
		// Custom Teaser Block Slider
		function TS_VCSC_Teaser_Block_Slider_Custom ($atts, $content = null){
			global $VISUAL_COMPOSER_EXTENSIONS;
			ob_start();
			
			if ((get_option('ts_vcsc_extend_settings_loadHeader', 0) == 0)) {
				$FOOTER = true;
			} else {
				$FOOTER = false;
			}
	
			if (get_option('ts_vcsc_extend_settings_loadForcable', 0) == 0) {
				wp_enqueue_style('ts-extend-owlcarousel',				        TS_VCSC_GetResourceURL('css/jquery.owl.carousel.css'), null, false, 'all');
				wp_enqueue_script('ts-extend-owlcarousel',			            TS_VCSC_GetResourceURL('js/jquery.owl.carousel.min.js'), array('jquery'), false, $FOOTER);
				wp_enqueue_style('ts-extend-simptip',                 			TS_VCSC_GetResourceURL('css/jquery.simptip.css'), null, false, 'all');
				wp_enqueue_style('ts-extend-animations',                 		TS_VCSC_GetResourceURL('css/ts-visual-composer-extend-animations.min.css'), null, false, 'all');
				wp_enqueue_style('ts-extend-buttons',                 			TS_VCSC_GetResourceURL('css/jquery.buttons.css'), null, false, 'all');
				wp_enqueue_style('ts-visual-composer-extend-front',				TS_VCSC_GetResourceURL('css/ts-visual-composer-extend-front.min.css'), null, false, 'all');
				wp_enqueue_script('ts-visual-composer-extend-front',			TS_VCSC_GetResourceURL('js/ts-visual-composer-extend-front.min.js'), array('jquery'), false, $FOOTER);
			}
			
			extract( shortcode_atts( array(
				'number_teasers'				=> 1,
				'auto_height'                   => 'true',
				'auto_play'                     => 'false',
				'show_bar'                      => 'true',
				'bar_color'                     => '#dd3333',
				'show_speed'                    => 5000,
				'stop_hover'                    => 'true',
				'show_navigation'               => 'true',
				'page_numbers'                  => 'false',
				'transitions'                   => 'backSlide',
				'margin_top'                    => 0,
				'margin_bottom'                 => 0,
				'el_id'                         => '',
				'el_class'                      => '',
			), $atts ));
			
			$teaser_random                    	= mt_rand(999999, 9999999);
			
			if (!empty($el_id)) {
				$teaser_slider_id			    = $el_id;
			} else {
				$teaser_slider_id			    = 'ts-vcsc-image-teaser-slider-' . $teaser_random;
			}
			
			$output = '';
			
			$output .= '<div id="' . $teaser_slider_id . '" class="ts-teaser-block-slider owl-carousel" data-id="' . $teaser_random . '" data-teasers="' . $number_teasers . '" data-navigation="' . $show_navigation . '" data-transitions="' . $transitions . '" data-height="' . $auto_height . '" data-play="' . $auto_play . '" data-bar="' . $show_bar . '" data-color="' . $bar_color . '" data-speed="' . $show_speed . '" data-hover="' . $stop_hover . '" data-numbers="' . $page_numbers . '">';
				$output .= do_shortcode($content);
			$output .= '</div>';
			
			echo $output;
			
			$myvariable = ob_get_clean();
			return $myvariable;
		}
	
	
		// Add Teaser Block Elements
        function TS_VCSC_Add_Teaser_Block_Elements() {
			global $VISUAL_COMPOSER_EXTENSIONS;
			// Add Standalone Teaser Block
			if (function_exists('vc_map')) {
				vc_map( array(
					"name"                      	=> __( "TS Single Teaser Block", "js_composer" ),
					"base"                      	=> "TS_VCSC_Teaser_Block_Standalone",
					"icon" 	                    	=> "icon-wpb-ts_vcsc_teaser_block_standalone",
					"class"                     	=> "ts_vcsc_main_teaser_block",
					"category"                  	=> __( 'VC Extensions', 'js_composer' ),
					"description"               	=> __("Place a teaser block element", "js_composer"),
					//"admin_enqueue_js"        	=> array(ts_fb_get_resource_url('/Core/JS/jquery.js-composer.fb-album.js')),
					//"admin_enqueue_css"       	=> array(ts_fb_get_resource_url('/Core/CSS/jquery.js-composer.fb-album.css')),
					"params"                    	=> array(
						// Teaser Settings
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_1",
							"value"             	=> "Teaser Content",
							"description"       	=> __( "", "js_composer" )
						),
						array(
							"type"                  => "attach_image",
							"holder" 				=> "img",
							"heading"               => __( "Image", "js_composer" ),
							"param_name"            => "image",
							"class"					=> "ts_vcsc_holder_image",
							"value"                 => "",
							"admin_label"           => false,
							"description"           => __( "Select the image you want to use for the teaser.", "js_composer" )
						),
						/*array(
							"type"              	=> "colorpicker",
							"heading"           	=> __( "Overlay Color", "js_composer" ),
							"param_name"        	=> "overlay",
							"value"             	=> "rgba(0,148,255,0.5)",
							"description"       	=> __( "Define the hover overlay color for the teaser image.", "js_composer" ),
							"dependency"        	=> ""
						),*/
						array(
							"type" 					=> "vc_link",
							"heading" 				=> __("Link", "js_composer"),
							"param_name" 			=> "link",
							"description" 			=> __("Provide a link to another site/page for the Image Teaser.", "js_composer")
						),
						array(
							"type"              	=> "textfield",
							"holder" 				=> "div",
							"heading"           	=> __( "Header", "js_composer" ),
							"param_name"        	=> "title",
							"class"					=> "ts_vcsc_holder_text_main",
							"value"             	=> "",
							"admin_label"           => false,
							"description"       	=> __( "Enter a title for the image teaser.", "js_composer" )
						),
						array(
							"type"              	=> "textfield",
							"holder" 				=> "div",
							"heading"           	=> __( "Description", "js_composer" ),
							"param_name"        	=> "subtitle",
							"class"					=> "ts_vcsc_holder_text_sub",
							"value"             	=> "",
							"admin_label"           => false,
							"description"       	=> __( "Enter a short description for the image teaser.", "js_composer" )
						),
						// Icon Settings
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_2",
							"value"             	=> "Icon Settings",
							"description"       	=> __( "", "js_composer" ),
							"group" 				=> "Icon Settings",
						),
						array(
							"type"              	=> "dropdown",
							"heading"           	=> __( "Icon Position", "js_composer" ),
							"param_name"        	=> "icon_position",
							"width"             	=> 300,
							"value"             	=> array(
								__( 'No Icon', "js_composer" )      	=> "",
								__( 'Left Icon', "js_composer" )		=> "left",
								__( 'Right Icon', "js_composer" )		=> "right",
								__( 'Top Icon', "js_composer" )			=> "top",
								__( 'Bottom Icon', "js_composer" )		=> "bottom",
							),
							"description"       	=> __( "Select if and where an icon should be shown in the teaser title.", "js_composer" ),
							"group" 				=> "Icon Settings",
						),
						array(
							"type"              	=> "icons_panel",
							"heading"           	=> __( "Title Icon", "js_composer" ),
							"param_name"        	=> "icon",
							"value"             	=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_List_Icons_Full,
							"admin_label"       	=> true,
							"description"       	=> __( "Select the icon you want to display in the teaser title.", "js_composer" ),
							"dependency"			=> array( 'element' => "icon_position", 'value' => array('left', 'right', 'top', 'bottom') ),
							"group" 				=> "Icon Settings",
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Icon Size", "js_composer" ),
							"param_name"            => "icon_size",
							"value"                 => "18",
							"min"                   => "4",
							"max"                   => "256",
							"step"                  => "1",
							"unit"                  => 'px',
							"description"       	=> __( "Define the size for the icon in the image teaser.", "js_composer" ),
							"dependency"			=> array( 'element' => "icon_position", 'value' => array('left', 'right', 'top', 'bottom') ),
							"group" 				=> "Icon Settings",
						),
						array(
							"type"              	=> "colorpicker",
							"heading"           	=> __( "Icon Color", "js_composer" ),
							"param_name"        	=> "icon_color",
							"value"             	=> "#aaaaaa",
							"description"       	=> __( "Define the color of the icon for the image teaser.", "js_composer" ),
							"dependency"			=> array( 'element' => "icon_change", 'value' => 'true' ),
							"group" 				=> "Icon Settings",
						),
						// Button Settings
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_3",
							"value"             	=> "Button Settings",
							"description"       	=> __( "", "js_composer" ),
							"group" 				=> "Link Button",
						),
						array(
							"type"              	=> "dropdown",
							"heading"           	=> __( "Button Type", "js_composer" ),
							"param_name"        	=> "button_type",
							"width"             	=> 300,
							"value"             	=> array(
								__( 'None', "js_composer" )      	=> "",
								__( 'Square', "js_composer" )		=> "square",
								__( 'Rounded', "js_composer" )		=> "rounded",
								__( 'Pill', "js_composer" )			=> "pill",
								__( 'Circle', "js_composer" )		=> "circle",
							),
							"admin_label"           => true,
							"description"       	=> __( "Select if and what type of link button should be shown.", "js_composer" ),
							"group" 				=> "Link Button",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_square",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Square,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'square' ),
							"group" 				=> "Link Button",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_rounded",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Rounded,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'rounded' ),
							"group" 				=> "Link Button",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_pill",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Pill,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'pill' ),
							"group" 				=> "Link Button",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_circle",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Circle,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'circle' ),
							"group" 				=> "Link Button",
						),
						array(
							"type"              	=> "dropdown",
							"heading"           	=> __( "Button Size", "js_composer" ),
							"param_name"        	=> "button_size",
							"width"             	=> 300,
							"value"             	=> array(
								__( 'Normal', "js_composer" )		=> "ts-button-normal",
								__( 'Small', "js_composer" )      	=> "ts-button-small",
								__( 'Tiny', "js_composer" )  		=> "ts-button-tiny",
								__( 'Large', "js_composer" )  		=> "ts-button-large",
								__( 'Jumbo', "js_composer" )  		=> "ts-button-jumbo",
							),
							"description"       	=> __( "Select the size for the icon button.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => array('square', 'rounded', 'pill') ),
							"group" 				=> "Link Button",
						),
						array(
							"type"					=> "switch",
							"heading"           	=> __( "Add Button Wrapper", "js_composer" ),
							"param_name"        	=> "button_wrapper",
							"value"             	=> "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"       	=> __( "Switch the toggle to add a wrapper frame around the 'Read More' button (most suited for 'pill' and 'circle' buttons).", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => array('square', 'rounded', 'pill', 'circle') ),
							"group" 				=> "Link Button",
						),
						array(
							"type"              	=> "textfield",
							"heading"           	=> __( "Button Text", "js_composer" ),
							"param_name"        	=> "button_text",
							"value"             	=> "Read More",
							"description"       	=> __( "Enter a text for the 'Read More' button.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => array('square', 'rounded', 'pill', 'circle') ),
							"group" 				=> "Link Button",
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Font Size", "js_composer" ),
							"param_name"            => "button_font",
							"value"                 => "18",
							"min"                   => "4",
							"max"                   => "100",
							"step"                  => "1",
							"unit"                  => 'px',
							"description"       	=> __( "Define the font size for the icon / text in the button.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'circle' ),
							"group" 				=> "Link Button",
						),
						// Load Custom CSS/JS File
						array(
							"type"              	=> "load_file",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "el_file",
							"value"             	=> "",
							"file_type"         	=> "js",
							"file_path"         	=> "js/ts-visual-composer-extend-element.min.js",
							"description"       	=> __( "", "js_composer" )
						),
					))
				);
			}
			// Add Single Teaser Block (for Custom Slider)
			if (function_exists('vc_map')) {
				vc_map( array(
					"name"                      	=> __( "TS Teaser Block Slide", "js_composer" ),
					"base"                      	=> "TS_VCSC_Teaser_Block_Single",
					"icon" 	                    	=> "icon-wpb-ts_vcsc_teaser_block_single",
					"class"                     	=> "ts_vcsc_main_teaser_block",
					"content_element"                => true,
					"as_child"                       => array('only' => 'TS_VCSC_Teaser_Block_Slider_Custom'),
					"category"                  	=> __( 'VC Extensions', 'js_composer' ),
					"description"               	=> __("Place a teaser block element", "js_composer"),
					//"admin_enqueue_js"        	=> array(ts_fb_get_resource_url('/Core/JS/jquery.js-composer.fb-album.js')),
					//"admin_enqueue_css"       	=> array(ts_fb_get_resource_url('/Core/CSS/jquery.js-composer.fb-album.css')),
					"params"                    	=> array(
						// Teaser Settings
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_1",
							"value"             	=> "Teaser Content",
							"description"       	=> __( "", "js_composer" )
						),
						array(
							"type"                  => "attach_image",
							"holder" 				=> "img",
							"heading"               => __( "Image", "js_composer" ),
							"param_name"            => "image",
							"class"					=> "ts_vcsc_holder_image",
							"value"                 => "",
							"admin_label"           => false,
							"description"           => __( "Select the image you want to use for the teaser.", "js_composer" )
						),
						/*array(
							"type"              	=> "colorpicker",
							"heading"           	=> __( "Overlay Color", "js_composer" ),
							"param_name"        	=> "overlay",
							"value"             	=> "rgba(0,148,255,0.5)",
							"description"       	=> __( "Define the hover overlay color for the teaser image.", "js_composer" ),
							"dependency"        	=> ""
						),*/
						array(
							"type" 					=> "vc_link",
							"heading" 				=> __("Link", "js_composer"),
							"param_name" 			=> "link",
							"description" 			=> __("Provide a link to another site/page for the Image Teaser.", "js_composer")
						),
						array(
							"type"              	=> "textfield",
							"holder" 				=> "div",
							"heading"           	=> __( "Header", "js_composer" ),
							"param_name"        	=> "title",
							"class"					=> "ts_vcsc_holder_text_main",
							"value"             	=> "",
							"admin_label"           => false,
							"description"       	=> __( "Enter a title for the image teaser.", "js_composer" )
						),
						array(
							"type"              	=> "textfield",
							"holder" 				=> "div",
							"heading"           	=> __( "Description", "js_composer" ),
							"param_name"        	=> "subtitle",
							"class"					=> "ts_vcsc_holder_text_sub",
							"value"             	=> "",
							"admin_label"           => false,
							"description"       	=> __( "Enter a short description for the image teaser.", "js_composer" )
						),
						// Icon Settings
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_2",
							"value"             	=> "Icon Settings",
							"description"       	=> __( "", "js_composer" ),
							"group" 				=> "Icon Settings",
						),
						array(
							"type"              	=> "dropdown",
							"heading"           	=> __( "Icon Position", "js_composer" ),
							"param_name"        	=> "icon_position",
							"width"             	=> 300,
							"value"             	=> array(
								__( 'No Icon', "js_composer" )      	=> "",
								__( 'Left Icon', "js_composer" )		=> "left",
								__( 'Right Icon', "js_composer" )		=> "right",
								__( 'Top Icon', "js_composer" )			=> "top",
								__( 'Bottom Icon', "js_composer" )		=> "bottom",
							),
							"description"       	=> __( "Select if and where an icon should be shown in the teaser title.", "js_composer" ),
							"group" 				=> "Icon Settings",
						),
						array(
							"type"              	=> "icons_panel",
							"heading"           	=> __( "Title Icon", "js_composer" ),
							"param_name"        	=> "icon",
							"value"             	=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_List_Icons_Full,
							"admin_label"       	=> true,
							"description"       	=> __( "Select the icon you want to display in the teaser title.", "js_composer" ),
							"dependency"			=> array( 'element' => "icon_position", 'value' => array('left', 'right', 'top', 'bottom') ),
							"group" 				=> "Icon Settings",
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Icon Size", "js_composer" ),
							"param_name"            => "icon_size",
							"value"                 => "18",
							"min"                   => "4",
							"max"                   => "256",
							"step"                  => "1",
							"unit"                  => 'px',
							"description"       	=> __( "Define the size for the icon in the image teaser.", "js_composer" ),
							"dependency"			=> array( 'element' => "icon_position", 'value' => array('left', 'right', 'top', 'bottom') ),
							"group" 				=> "Icon Settings",
						),
						array(
							"type"              	=> "colorpicker",
							"heading"           	=> __( "Icon Color", "js_composer" ),
							"param_name"        	=> "icon_color",
							"value"             	=> "#aaaaaa",
							"description"       	=> __( "Define the color of the icon for the image teaser.", "js_composer" ),
							"dependency"			=> array( 'element' => "icon_change", 'value' => 'true' ),
							"group" 				=> "Icon Settings",
						),
						// Button Settings
						array(
							"type"              	=> "seperator",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "seperator_3",
							"value"             	=> "Button Settings",
							"description"       	=> __( "", "js_composer" ),
							"group" 				=> "Link Button",
						),
						array(
							"type"              	=> "dropdown",
							"heading"           	=> __( "Button Type", "js_composer" ),
							"param_name"        	=> "button_type",
							"width"             	=> 300,
							"value"             	=> array(
								__( 'None', "js_composer" )      	=> "",
								__( 'Square', "js_composer" )		=> "square",
								__( 'Rounded', "js_composer" )		=> "rounded",
								__( 'Pill', "js_composer" )			=> "pill",
								__( 'Circle', "js_composer" )		=> "circle",
							),
							"admin_label"           => true,
							"description"       	=> __( "Select if and what type of link button should be shown.", "js_composer" ),
							"group" 				=> "Link Button",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_square",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Square,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'square' ),
							"group" 				=> "Link Button",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_rounded",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Rounded,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'rounded' ),
							"group" 				=> "Link Button",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_pill",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Pill,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'pill' ),
							"group" 				=> "Link Button",
						),
						array(
							"type"                  => "dropdown",
							"heading"               => __( "Button Style", "js_composer" ),
							"param_name"            => "button_circle",
							"width"                 => 300,
							"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Button_Circle,
							"description"           => __( "Select the actual button style for the 'Read More' Link.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'circle' ),
							"group" 				=> "Link Button",
						),
						array(
							"type"              	=> "dropdown",
							"heading"           	=> __( "Button Size", "js_composer" ),
							"param_name"        	=> "button_size",
							"width"             	=> 300,
							"value"             	=> array(
								__( 'Normal', "js_composer" )		=> "ts-button-normal",
								__( 'Small', "js_composer" )      	=> "ts-button-small",
								__( 'Tiny', "js_composer" )  		=> "ts-button-tiny",
								__( 'Large', "js_composer" )  		=> "ts-button-large",
								__( 'Jumbo', "js_composer" )  		=> "ts-button-jumbo",
							),
							"description"       	=> __( "Select the size for the icon button.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => array('square', 'rounded', 'pill') ),
							"group" 				=> "Link Button",
						),
						array(
							"type"					=> "switch",
							"heading"           	=> __( "Add Button Wrapper", "js_composer" ),
							"param_name"        	=> "button_wrapper",
							"value"             	=> "false",
							"on"					=> __( 'Yes', "js_composer" ),
							"off"					=> __( 'No', "js_composer" ),
							"style"					=> "select",
							"design"				=> "toggle-light",
							"description"       	=> __( "Switch the toggle to add a wrapper frame around the 'Read More' button (most suited for 'pill' and 'circle' buttons).", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => array('square', 'rounded', 'pill', 'circle') ),
							"group" 				=> "Link Button",
						),
						array(
							"type"              	=> "textfield",
							"heading"           	=> __( "Button Text", "js_composer" ),
							"param_name"        	=> "button_text",
							"value"             	=> "Read More",
							"description"       	=> __( "Enter a text for the 'Read More' button.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => array('square', 'rounded', 'pill', 'circle') ),
							"group" 				=> "Link Button",
						),
						array(
							"type"                  => "nouislider",
							"heading"               => __( "Font Size", "js_composer" ),
							"param_name"            => "button_font",
							"value"                 => "18",
							"min"                   => "4",
							"max"                   => "100",
							"step"                  => "1",
							"unit"                  => 'px',
							"description"       	=> __( "Define the font size for the icon / text in the button.", "js_composer" ),
							"dependency"			=> array( 'element' => "button_type", 'value' => 'circle' ),
							"group" 				=> "Link Button",
						),
						// Load Custom CSS/JS File
						array(
							"type"              	=> "load_file",
							"heading"           	=> __( "", "js_composer" ),
							"param_name"        	=> "el_file",
							"value"             	=> "",
							"file_type"         	=> "js",
							"file_path"         	=> "js/ts-visual-composer-extend-element.min.js",
							"description"       	=> __( "", "js_composer" )
						),
					))
				);
			}
			// Add Teaser Block Slider 1 (Custom Build)
			if (function_exists('vc_map')) {
				vc_map(array(
				   "name"                               => __("TS Teaser Block Slider", "js_composer"),
				   "base"                               => "TS_VCSC_Teaser_Block_Slider_Custom",
				   "class"                              => "",
				   "icon"                               => "icon-wpb-ts_vcsc_teaser_block_slider_custom",
				   "category"                           => __("VC Extensions", "js_composer"),
				   "as_parent"                          => array('only' => 'TS_VCSC_Teaser_Block_Single'),
				   "description"                        => __("Build a custom Teaser Block Slider", "js_composer"),
				   "content_element"                    => true,
				   "show_settings_on_create"            => false,
				   "params"                             => array(
						// Slider Settings
						array(
							"type"                      => "seperator",
							"heading"                   => __( "", "js_composer" ),
							"param_name"                => "seperator_1",
							"value"                     => "Slider Settings",
							"description"               => __( "", "js_composer" )
						),
						array(
							"type"              	    => "switch",
							"heading"                   => __( "Auto-Height", "js_composer" ),
							"param_name"                => "auto_height",
							"value"                     => "true",
							"on"					    => __( 'Yes', "js_composer" ),
							"off"					    => __( 'No', "js_composer" ),
							"style"					    => "select",
							"design"				    => "toggle-light",
							"admin_label"		        => true,
							"description"               => __( "Switch the toggle if you want the slider to auto-adjust its height.", "js_composer" ),
							"dependency"                => ""
						),
						array(
							"type"                      => "nouislider",
							"heading"                   => __( "Number of Teasers", "js_composer" ),
							"param_name"                => "number_teasers",
							"value"                     => "1",
							"min"                       => "1",
							"max"                       => "10",
							"step"                      => "1",
							"unit"                      => '',
							"description"               => __( "Define the number of Teaser Blocks per slide.", "js_composer" ),
							"dependency" 				=> ""
						),
						array(
							"type"              	    => "switch",
							"heading"                   => __( "Auto-Play", "js_composer" ),
							"param_name"                => "auto_play",
							"value"                     => "false",
							"on"					    => __( 'Yes', "js_composer" ),
							"off"					    => __( 'No', "js_composer" ),
							"style"					    => "select",
							"design"				    => "toggle-light",
							"admin_label"		        => true,
							"description"               => __( "Switch the toggle if you want the auto-play the slider on page load.", "js_composer" ),
							"dependency"                => ""
						),
						array(
							"type"              	    => "switch",
							"heading"                   => __( "Show Progressbar", "js_composer" ),
							"param_name"                => "show_bar",
							"value"                     => "true",
							"on"					    => __( 'Yes', "js_composer" ),
							"off"					    => __( 'No', "js_composer" ),
							"style"					    => "select",
							"design"				    => "toggle-light",
							"description"               => __( "Switch the toggle if you want to show a progressbar during auto-play.", "js_composer" ),
							"dependency" 				=> array("element" 	=> "auto_play", "value" 	=> "true"),
						),
						array(
							"type"                      => "colorpicker",
							"heading"                   => __( "Progressbar Color", "js_composer" ),
							"param_name"                => "bar_color",
							"value"                     => "#dd3333",
							"description"               => __( "Define the color of the animated progressbar.", "js_composer" ),
							"dependency" 				=> array("element" 	=> "auto_play", "value" 	=> "true"),
						),
						array(
							"type"                      => "nouislider",
							"heading"                   => __( "Auto-Play Speed", "js_composer" ),
							"param_name"                => "show_speed",
							"value"                     => "5000",
							"min"                       => "1000",
							"max"                       => "20000",
							"step"                      => "100",
							"unit"                      => 'ms',
							"description"               => __( "Define the speed used to auto-play the slider.", "js_composer" ),
							"dependency" 				=> array("element" 	=> "auto_play","value" 	=> "true"),
						),
						array(
							"type"              	    => "switch",
							"heading"                   => __( "Stop on Hover", "js_composer" ),
							"param_name"                => "stop_hover",
							"value"                     => "true",
							"on"					    => __( 'Yes', "js_composer" ),
							"off"					    => __( 'No', "js_composer" ),
							"style"					    => "select",
							"design"				    => "toggle-light",
							"description"               => __( "Switch the toggle if you want the stop the auto-play while hovering over the slider.", "js_composer" ),
							"dependency"                => array( 'element' => "auto_play", 'value' => 'true' )
						),
						array(
							"type"              	    => "switch",
							"heading"                   => __( "Show Navigation", "js_composer" ),
							"param_name"                => "show_navigation",
							"value"                     => "true",
							"on"					    => __( 'Yes', "js_composer" ),
							"off"					    => __( 'No', "js_composer" ),
							"style"					    => "select",
							"design"				    => "toggle-light",
							"description"               => __( "Switch the toggle if you want to show left/right navigation buttons for the slider.", "js_composer" ),
							"dependency"                => ""
						),
						array(
							"type"                      => "dropdown",
							"heading"                   => __( "Transition", "js_composer" ),
							"param_name"                => "transitions",
							"width"                     => 150,
							"value"                     => array(
								__( 'Back Slide', "js_composer" )		    => "backSlide",
								__( 'Go Down', "js_composer" )		        => "goDown",
								__( 'Fade Up', "js_composer" )		        => "fadeUp",
								__( 'Simple Fade', "js_composer" )		    => "fade",
							),
							"description"               => __( "Select how to transition between the individual slides.", "js_composer" ),
							"admin_label"		        => true,
						),
						// Other Settings
						array(
							"type"                      => "seperator",
							"heading"                   => __( "", "js_composer" ),
							"param_name"                => "seperator_2",
							"value"                     => "Other Settings",
							"description"               => __( "", "js_composer" ),
							"group" 			        => "Other Settings",
						),
						array(
							"type"                      => "nouislider",
							"heading"                   => __( "Margin Top", "js_composer" ),
							"param_name"                => "margin_top",
							"value"                     => "0",
							"min"                       => "0",
							"max"                       => "200",
							"step"                      => "1",
							"unit"                      => 'px',
							"description"               => __( "", "js_composer" ),
							"group" 			        => "Other Settings",
						),
						array(
							"type"                      => "nouislider",
							"heading"                   => __( "Margin Bottom", "js_composer" ),
							"param_name"                => "margin_bottom",
							"value"                     => "0",
							"min"                       => "0",
							"max"                       => "200",
							"step"                      => "1",
							"unit"                      => 'px',
							"description"               => __( "", "js_composer" ),
							"group" 			        => "Other Settings",
						),
						array(
							"type"                      => "textfield",
							"heading"                   => __( "Define ID Name", "js_composer" ),
							"param_name"                => "el_id",
							"value"                     => "",
							"description"               => __( "Enter an unique ID for the Testimonial Slider.", "js_composer" ),
							"group" 			        => "Other Settings",
						),
						array(
							"type"                      => "textfield",
							"heading"                   => __( "Extra Class Name", "js_composer" ),
							"param_name"                => "el_class",
							"value"                     => "",
							"description"               => __( "Enter a class name for the Testimonial Slider.", "js_composer" ),
							"group" 			        => "Other Settings",
						),
						// Load Custom CSS/JS File
						array(
							"type"                      => "load_file",
							"heading"                   => __( "", "js_composer" ),
							"param_name"                => "el_file",
							"value"                     => "",
							"file_type"                 => "js",
							"file_path"                 => "js/ts-visual-composer-extend-element.min.js",
							"description"               => __( "", "js_composer" )
						),
					),
					"js_view"                           => 'VcColumnView'
				));
			}
		}
	}
}
// Register Container and Child Shortcode with Visual Composer
if (class_exists('WPBakeryShortCodesContainer')) {
	class WPBakeryShortCode_TS_VCSC_Teaser_Block_Slider_Custom extends WPBakeryShortCodesContainer {}
}
if (class_exists('WPBakeryShortCode')) {
	class WPBakeryShortCode_TS_VCSC_Teaser_Block_Single extends WPBakeryShortCode {}
}
// Initialize "TS Teaser Blocks" Class
if (class_exists('TS_Teaser_Blocks')) {
	$TS_Teaser_Blocks = new TS_Teaser_Blocks;
}