(function ($) {
    $.fn.circliful = function (options, callback) {
        var settings = $.extend({
            // These are the defaults.
            fgcolor: 					"#556b2f",
            bgcolor: 					"#eee",
            fill: 						false,
            width: 						15,
			responsive:					true,
            dimension: 					200,
			maxsize:					250,
            fontsize: 					30,
			infosize:					15,
            percent: 					50,
            animationstep: 				1.0,
            iconsize: 					30,
            iconcolor: 					'#dddddd',
			iconposition:				'left',
            border: 					'default',
			type:						'full',
            complete: 					null
        }, options);
		
        return this.each(function () {
            var customSettings 			= ["id", "responsive", "fgcolor", "bgcolor", "type", "fill", "width", "dimension", "maxsize", "fontsize", "infosize", "animationstep", "endPercent", "text", "info", "seperator", "decimals", "prefix", "postfix", "group", "fontsize", "icon", "image", "iconcolor", "iconsize", "iconposition", "border"];
            var customSettingsObj 		= {};
            var obj 					= jQuery(this);
            var fill 					= false;
			
			var text 					= '';
			var info 					= '';
			var size 					= 0;

            obj.addClass('circliful');
			// Build Array with Override Settings
            checkDataAttributes(obj);
			// Determine Parent Width
			var parentsize				= obj.parent().width();
			// Determin Responsiveness
			var responsive				= customSettingsObj.responsive;
			// Determine Default Element Width
			var dimension 				= parseInt(customSettingsObj.dimension);
			// Retrieve Assigned Element ID
			var counterID				= customSettingsObj.id;
			// Retrieve Circle Width
			var width					= parseInt(customSettingsObj.width);
			// Retrieve Element Max Width
			var maxsize					= parseInt(customSettingsObj.maxsize);
			// Check Element Width and Adjust
			if (responsive == true) {
				if (parentsize > maxsize) {
					dimension 			= maxsize;
				} else {
					dimension 			= parentsize;
				}
			} else {
				dimension 				= dimension;
			}
			// Retrieve Foreground Color
			var fgcolor 				= customSettingsObj.fgcolor;
			// Retrieve Background Color
			var bgcolor 				= customSettingsObj.bgcolor;
			// Retrieve Animation Step
			var animationstep 			= customSettingsObj.animationstep;
			// Retrieve Pre-Text String
			var prefix					= customSettingsObj.prefix;
			// Retrieve Post-Text String
			var postfix					= customSettingsObj.postfix;
			// Retrieve Font Size (Number)
			var fontsize 				= customSettingsObj.fontsize;
			// Retrieve Font Size (Info Text)
			var infosize 				= customSettingsObj.infosize;
			// Retrieve Icon Size
			var iconsize				= customSettingsObj.iconsize;
			// Retrieve Icon Color
			var iconcolor				= customSettingsObj.iconcolor;
			// Retrieve Icon Position
			var iconposition			= customSettingsObj.iconposition;
			// Retrieve Percent Values
            if (obj.data("total") != undefined && obj.data("part") != undefined) {
                var total 				= obj.data("total") / 100;
                var percent 			= ((obj.data("part") / total) / 100).toFixed(3);
                var endPercent 			= (obj.data("part") / total).toFixed(3)
            } else {
                if (obj.data("percent") != undefined) {
                    var percent 		= obj.data("percent") / 100;
                    var endPercent 		= obj.data("percent")
                } else {
                    var percent 		= settings.percent / 100
					var endPercent 		= 0; //100
                }
            }
			// Retrieve Text Value
            if (obj.data('text') != undefined) {
                text 					= obj.data('text');
				if (text.length != 0) {
					prefix				= jQuery(this).data('prefix');
					postfix				= jQuery(this).data('postfix');
				} else {
					text				= "";
					prefix				= "";
					postfix				= "";
				}
                if ((obj.data('icon') != undefined) && (obj.data('icon') != 'transparent')) {
                    icon = jQuery('<i></i>')
                        .addClass('ts-font-icon circle-icon ' + obj.data('icon'))
						.attr("id", counterID + "-icon")
                        .css({
                            'color': 		iconcolor,
                            'font-size': 	iconsize + 'px',
							'height': 		iconsize + 'px',
							'width': 		iconsize + 'px',
							'line-height': 	iconsize + 'px',
							'margin':		(text.length != 0 ? '0 5px' : 0)
                        });
					var iconimage		= true;
                } else if ((obj.data('image') != undefined) && (obj.data('image') != '')) {
                    icon = jQuery('<img src="' + obj.data('image') + '">')
                        .addClass('ts-font-icon circle-image')
						.attr("id", counterID + "-image")
                        .css({
                            'font-size': 	iconsize + 'px',
							'height': 		iconsize + 'px',
							'width': 		iconsize + 'px',
							'line-height': 	iconsize + 'px',
							'margin':		(text.length != 0 ? '0 5px' : 0)
                        });
					var iconimage		= true;
				} else {
					icon				= '';
					var iconimage		= false;
				}
                if (obj.data('type') != undefined) {
                    var type 			= obj.data('type');
					if (type == 'half') {
						addCircleText(obj, 'circle-text-half', (dimension / 1.45));
					} else {
						addCircleText(obj, 'circle-text', dimension);
					}
                } else {
					var type 			= settings.type;
					addCircleText(obj, 'circle-text', dimension);
                }
            }
            if (jQuery(this).data('info') != undefined) {
                info = obj.data('info');
				if (info.length != 0) {
					if (jQuery(this).data('type') != undefined) {
						type = obj.data('type');
						if (type == 'half') {
							addInfoText(obj, 0.9);
						} else {
							addInfoText(obj, 1.25);
						}
					} else {
						addInfoText(obj, 1.25);
					}
				}
            }

            jQuery(this).width(dimension + 'px');

            var canvas = jQuery('<canvas></canvas>').attr({
			                width: 		dimension,
			                height: 	dimension
			            }).appendTo(jQuery(this)).get(0);

            var context 			= canvas.getContext('2d');
            var x 					= canvas.width / 2;
            var y 					= canvas.height / 2;
            var degrees 			= customSettingsObj.percent * 360.0;
            var radians 			= degrees * (Math.PI / 180);
            var radius 				= canvas.width * 0.4;
			var excess				= canvas.width * 0.1;
            var startAngle 			= 2.3 * Math.PI;
            var endAngle 			= 0;
            var counterClockwise 	= false;
            var curPerc 			= animationstep === 0.0 ? endPercent : 0.0;
            var curStep 			= Math.max(animationstep, 0.0);
            var circ 				= Math.PI * 2;
            var quart 				= Math.PI / 2;
            var type 				= '';
            var fireCallback 		= true;
            if (jQuery(this).data('type') != undefined) {
                type = jQuery(this).data('type');
                if (type == 'half') {
                    startAngle 		= 2.0 * Math.PI;
                    endAngle 		= 3.13;
                    circ 			= Math.PI * 1.0;
                    quart 			= Math.PI / 0.996;
					obj.css('margin-bottom', '-' + (dimension / 2) + 'px');
                }
            }

            /**
             * adds text to circle
             * 
             * @param obj
             * @param cssClass
             * @param lineHeight
             */
            function addCircleText(obj, cssClass, lineHeight) {
				if (text.length != 0) {
					var circletext = prefix + '<span id="' + counterID + '-value">' + text + '</span>' + postfix;
				} else {
					var circletext = '';
				}
				if ((text.length == 0) && (info.length == 0)) {
					if (type == 'half') {
						jQuery("<span></span>")
							.appendTo(obj)
							.addClass(cssClass)
							.attr("id", counterID + "-text")
							.html(circletext)
							.prepend(icon)
							.css({
								'line-height': 		iconsize + 'px',
								'height': 			iconsize + 'px',
								'top':				(dimension / 2 - iconsize) + 'px',
							});
					} else {
						jQuery("<span></span>")
							.appendTo(obj)
							.addClass(cssClass)
							.attr("id", counterID + "-text")
							.html(circletext)
							.prepend(icon)
							.css({
								'line-height': 		iconsize + 'px',
								'height': 			iconsize + 'px',
								'top':				(dimension - iconsize) / 2 + 'px',
							});
					}
				} else {
					if ((iconimage == true) && (text.length != 0)) {

					} else {
						
					}
					if (iconposition == 'left') {
						jQuery("<span></span>")
							.appendTo(obj)
							.addClass(cssClass)
							.attr("id", counterID + "-text")
							.html(circletext)
							.prepend(icon)
							.css({
								'line-height': 		lineHeight + 'px',
								'font-size': 		fontsize + 'px'
							});
					} else {
						jQuery("<span></span>")
							.appendTo(obj)
							.addClass(cssClass)
							.attr("id", counterID + "-text")
							.html(circletext)
							.append(icon)
							.css({
								'line-height': 		lineHeight + 'px',
								'font-size': 		fontsize + 'px'
							});
					}
				}
            }

            /**
             * adds info text to circle
             * 
             * @param obj
             * @param factor
             */
            function addInfoText(obj, factor) {
                jQuery('<span></span>')
                    .appendTo(obj)
                    .addClass('circle-info-half')
					.text(info)
                    .css({
						'line-height': 		(dimension * factor) + 'px',
						'font-size': 		infosize + 'px'
					});
            }

            /**
             * checks which data attributes are defined
             * @param obj
             */
            function checkDataAttributes(obj) {
                jQuery.each(customSettings, function (index, attribute) {
                    if (obj.data(attribute) != undefined) {
                        customSettingsObj[attribute] = obj.data(attribute);
                    } else {
                        customSettingsObj[attribute] = jQuery(settings).attr(attribute);
                    }
                    if (attribute == 'fill' && obj.data('fill') != undefined) {
                        fill = true;
                    } 
                });
            }

            /**
             * animate foreground circle
             * @param current
             */
            function animate(current) {
                context.clearRect(0, 0, canvas.width, canvas.height);
                context.beginPath();
                context.arc(x, y, radius, endAngle, startAngle, false);
                context.lineWidth = width + 1;
                context.strokeStyle = bgcolor;
                context.stroke();
                if (fill) {
                    context.fillStyle = customSettingsObj.fill;
                    context.fill();
                }
                context.beginPath();
                context.arc(x, y, radius, -(quart), ((circ) * current) - quart, false);
                if (customSettingsObj.border == 'outline') {
                	context.lineWidth = width + (width * 0.75);
                } else if(customSettingsObj.border == 'inline') {
                	context.lineWidth = width - (width * 0.75);
                } 
                context.strokeStyle = fgcolor;
                context.stroke();
                if (curPerc < endPercent) {
                    curPerc += curStep;
                    requestAnimationFrame(function () {
                        animate(Math.min(curPerc, endPercent) / 100);
                    }, obj);
                }
                if (curPerc == endPercent && fireCallback && typeof(options) != "undefined") {
                	if (jQuery.isFunction(options.complete)) {
		            	options.complete();
		            	fireCallback = false;
		            }
                }
            }
			jQuery(this).attr("data-size", jQuery(this).parent().width());
            jQuery(this).waypoint({
                handler: function(direction) {
					jQuery(this).attr("data-view", "true");
					// Start Number Animation
					if (text.length != 0) {
						var $counter_decimals 	= jQuery(this).attr("data-decimals");
						var $counter_grouper 	= jQuery(this).attr("data-group");
						var $counter_seperator 	= jQuery(this).attr("data-seperator");
						var countValue = new countUp(counterID + '-value', 0, text, parseInt($counter_decimals), 1.5, {
							useEasing :         true,
							useGrouping :       true,
							separator :         $counter_grouper,
							decimal :           $counter_seperator
						});
						countValue.start();
					}
					// Start Circle Animation
					animate(curPerc / 100);
                },
                offset: 			'85%',
                triggerOnce: 		true
            });
        });
    };
}(jQuery));