if (jQuery.isFunction(jQuery.fn.isotope)) {
    jQuery.Isotope.prototype.flush = function() {
        this.$allAtoms = $();
        this.$filteredAtoms = $();
        //this.element.children().remove();
        //this.reLayout();
    };
    // Timeline Layout
    jQuery.Isotope.prototype._spineTimelineReset = function() {
        this.spineTimeline = {
            colA: 0,
            colB: 0
        };
    };
    jQuery.Isotope.prototype._spineTimelineLayout = function( $elems ) {
        var instance = this;
        var props = this.spineTimeline;
        var gutterWidth = Math.round( this.options.spineTimeline && this.options.spineTimeline.gutterWidth ) || 0;
        var columnPadding = Math.round( this.options.spineTimeline && this.options.spineTimeline.columnPadding ) || 0;
        var centerX = Math.round(this.element.width() / 2);
        var spineHolder = this.options.spineTimeline.spineHolder;
        jQuery('span', jQuery('#' + spineHolder)).remove();
        $elems.each(function(i, val){
            var $this = jQuery(this);
            $this.removeClass('last').removeClass('top');
            if (i == $elems.length - 1) {
                $this.addClass('last');
            }
            var x, y;
            var spanPointer = jQuery('<span />');
            var spanLabel = jQuery('<span />');
            if (($this.hasClass('ts-timeline-break')) || ($this.hasClass('ts-timeline-full'))) {
                $this.removeClass('colA').removeClass('colB');
                var width = $this.width();
                x = centerX - (width / 2);
                if (props.colA >= props.colB){
                    y = props.colA;
                    if (y == 0) $this.addClass('top');
                    props.colA += $this.outerHeight(true);
                    props.colB = props.colA;
                } else {
                    y = props.colB;
                    if (y == 0) $this.addClass('top');
                    props.colB += $this.outerHeight(true);
                    props.colA = props.colB;
                }
                if ($this.hasClass('ts-timeline-full')) {
                    if ($this.attr('data-order') == "desc") {
						jQuery("#" + spineHolder).append(spanPointer.css({top: (y - 5)}));
                    } else {
                        jQuery("#" + spineHolder).append(spanPointer.css({top: (y + $this.outerHeight(true) - 20)}));
                    }
                }
            } else {
                $this.removeClass('left').removeClass('right');
                var isColA = props.colB >= props.colA;
                x = isColA ? centerX - ( $this.outerWidth(true) + gutterWidth / 2 ) :  centerX + (gutterWidth / 2);
                y = isColA ? props.colA : props.colB;
                if (y - props.lastY <= 60) {
                    var extraSpacing = 60 - Math.abs(y - props.lastY);
                    props.lastY = y + extraSpacing;
                } else {
                    props.lastY = y;
                }
                props[( isColA ? 'colA' : 'colB' )] += $this.outerHeight(true);
                jQuery("#" + spineHolder).append(spanPointer.css({top: (y + columnPadding)}));
                if (isColA) { $this.removeClass('colB').addClass('colA'); } else { $this.removeClass('colA').addClass('colB'); }
            }
            instance._pushPosition($this, x, y);
        });
    };
    jQuery.Isotope.prototype._spineTimelineGetContainerSize = function() {
        var size = {};
        size.height = this.spineTimeline[( this.spineTimeline.colB > this.spineTimeline.colA ? 'colB' : 'colA' )];
        return size;
    };
    jQuery.Isotope.prototype._spineTimelineResizeChanged = function() {
        return true;
    };
    // Centered Masonry
    jQuery.Isotope.prototype._getCenteredMasonryColumns = function() {
        var columnOffset = this.options.masonry && this.options.masonry.columnOffset || 0;
        this.width = this.element.width();
        var parentWidth = this.element.parent().width();
        var colW = this.options.masonry && this.options.masonry.columnWidth || this.$filteredAtoms.outerWidth(true) || parentWidth;
        var cols = Math.floor(parentWidth / colW);
        cols = Math.max(cols, 1);
        this.masonry.cols = cols;
        this.masonry.columnWidth = colW ;
    };
    jQuery.Isotope.prototype._masonryReset = function() {
        // layout-specific props
        this.masonry = {};
        // FIXME shouldn't have to call this again
        this._getCenteredMasonryColumns();
        var i = this.masonry.cols;
        this.masonry.colYs = [];
        while (i--) {
            this.masonry.colYs.push( 0 );
        }
    };
    jQuery.Isotope.prototype._masonryResizeChanged = function() {
        var prevColCount = this.masonry.cols;
        // get updated colCount
        this._getCenteredMasonryColumns();
        return ( this.masonry.cols !== prevColCount );
    };
    jQuery.Isotope.prototype._masonryGetContainerSize = function() {
        var unusedCols = 0, i = this.masonry.cols;
        var gutter = this.options.masonry && this.options.masonry.gutterWidth || 0;
        while ( --i ) {
            if ( this.masonry.colYs[i] !== 0 ) {
                break;
            }
            unusedCols++;
        }
        return {
            height:	Math.max.apply( Math, this.masonry.colYs ),
            width: 	(this.masonry.cols - unusedCols) * this.masonry.columnWidth
        };
    };
}